=== added directory '.bzr-builddeb'
=== added file '.bzr-builddeb/default.conf'
--- .bzr-builddeb/default.conf	1970-01-01 00:00:00 +0000
+++ .bzr-builddeb/default.conf	2012-11-05 20:50:59 +0000
@@ -0,0 +1,2 @@
+[BUILDDEB]
+split = True

=== added directory 'debian'
=== added file 'debian/00_remove_unityshell_in_gnome_session.py'
--- debian/00_remove_unityshell_in_gnome_session.py	1970-01-01 00:00:00 +0000
+++ debian/00_remove_unityshell_in_gnome_session.py	2012-10-17 11:25:46 +0000
@@ -0,0 +1,47 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+# Copyright (C) 2012 Canonical
+#
+# Authors:
+#  Didier Roche <didrocks@ubuntu.com>
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; version 3.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUTa
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+from gi.repository import Gio
+import os
+
+gsettings=Gio.Settings(schema="org.compiz.core", path="/org/compiz/profiles/Default/plugins/core/")
+plugins_list = gsettings.get_strv("active-plugins")
+
+# Remove unityshell the default profile if present (case of new install and first session startup)
+try:
+    plugins_list.remove('unityshell')
+except ValueError:
+    pass
+try:
+    plugins_list.remove('unitymtgrabhandles')
+except ValueError:
+    pass
+# gsettings doesn't work directly, the key is somewhat reverted. Work one level under then: dconf!
+#gsettings.set_strv("active-plugins", plugins_list)
+from subprocess import Popen, PIPE, STDOUT
+p = Popen(['dconf', 'load', '/org/compiz/profiles/Default/plugins/core/'], stdout=PIPE, stdin=PIPE, stderr=STDOUT)
+p.communicate(input="[/]\nactive-plugins=%s" % plugins_list)
+
+# remove the eventually existing local config file which can prevent the default profile to use gsettings for quantal users before this fix
+try:
+    os.remove(os.path.join(os.path.expanduser('~'), '.config', 'compiz-1', 'compizconfig', 'config'))
+except OSError:
+    pass
+

=== added file 'debian/65compiz_profile-on-session'
--- debian/65compiz_profile-on-session	1970-01-01 00:00:00 +0000
+++ debian/65compiz_profile-on-session	2012-08-16 13:00:08 +0000
@@ -0,0 +1,9 @@
+# This file is sourced by Xsession(5), not executed.
+# Select unity profile if we are in the default session.
+# The default profile is used otherwise.
+
+if [ "x$DESKTOP_SESSION" = "xubuntu" ]; then
+    COMPIZ_CONFIG_PROFILE="ubuntu"
+    export COMPIZ_CONFIG_PROFILE
+fi
+

=== added file 'debian/ccsm.1'
--- debian/ccsm.1	1970-01-01 00:00:00 +0000
+++ debian/ccsm.1	2012-06-19 11:22:48 +0000
@@ -0,0 +1,20 @@
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
+.TH CCSM "1" "July 2008" "ccsm" "User Commands"
+.SH NAME
+CCSM \- compizconfig-settings-manager
+.SH SYNOPSIS
+.B ccsm
+[\fIoptions\fR]
+.SH OPTIONS
+.TP
+\fB\-h\fR, \fB\-\-help\fR
+show this help message and exit
+.TP
+\fB\-p\fR PLUGIN, \fB\-\-plugin\fR=\fIPLUGIN\fR
+Directly jump to the page of PLUGIN
+.TP
+\fB\-c\fR CATEGORY, \fB\-\-category\fR=\fICATEGORY\fR
+Directly jump to CATEGORY
+.TP
+\fB\-v\fR, \fB\-\-version\fR
+Version

=== added file 'debian/changelog'
--- debian/changelog	1970-01-01 00:00:00 +0000
+++ debian/changelog	2012-11-05 20:50:59 +0000
@@ -0,0 +1,2887 @@
+compiz (1:0.9.8.4+bzr3407-0ubuntu2) UNRELEASED; urgency=low
+
+  * debian/control:
+    - Update Vcs-Bzr
+  * debian/patches/100_expo_layout.patch:
+    - Fix to apply
+
+ -- Michael Terry <mterry@ubuntu.com>  Mon, 05 Nov 2012 14:48:41 -0500
+
+compiz (1:0.9.8.4+bzr3407-0ubuntu1) quantal-proposed; urgency=low
+
+  * New upstream snapshot.
+    - Cherry-picked fixes in Ubuntu merged to development branch
+    - Fix leakage of destroyed_pixmaps_table, containing pointers to freed 
+      decor_t's which could result in a freed GHashTable being passed into 
+      g_hash_table_remove and causing a crash. (LP: #1060171)
+
+ -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 12 Oct 2012 13:36:25 +0300
+
+compiz (1:0.9.8.4-0ubuntu3) quantal-proposed; urgency=low
+
+  * debian/config, debian/compiz-gnome.migrations,
+    debian/00_remove_unityshell_in_gnome_session.py:
+    - add the default gnome_session profile to use gsettings as the migrated
+      user are on this profile (LP: #1036752). The existing migration scripts
+      will upgrade the user config.
+    - For new users and users already on quantal before this fix, remove the
+      local config file created if you logged in the classic session hiding the
+      system one. Also, as the global default is including the unity* plugins,
+      remove them from the list of plugins the first time you log in.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 17 Oct 2012 12:19:08 +0200
+
+compiz (1:0.9.8.4-0ubuntu2) quantal; urgency=low
+
+  * debian/patches/unity_support_test.patch:
+    - force llvmpipe in the unity profile if we are in the grey zone, meaning:
+      the card and drivers have opengl support, however, it doesn't met unity
+      requirements (opengl < 1.4, no vertex shaders support…). Thanks duflu
+      (LP: #1039155)
+      Note that we already discourage them to upgrade from precise to quantal
+      with a warning before the upgrade, however let's get a slow ui rather
+      than none on the iso as well.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 09 Oct 2012 15:26:52 +0200
+
+compiz (1:0.9.8.4-0ubuntu1) quantal-proposed; urgency=low
+
+  * debian/control:
+    - Add dependency on gnome-settings-daemon for compiz-gnome, since some
+      tests need the g-s-d gsetting schemas
+  * New upstream release.
+    - FTBFS with -DCOMPIZ_BUILD_TESTING=OFF if libgtest-dev is not installed 
+      (LP: #1057421)
+    - [performance] glXSwapIntervalEXT called every frame, which is very slow 
+      on Nvidia. (LP: #1051286)
+    - opacify plugin: opacity isn't reset after switching window (LP: #1050757)
+    - cmake fails on python 2.6 as sys.version_info does not contain 
+      major_version or minor_version (LP: #1048964)
+    - scale mode is not visible if a fullscreen window is unredirected 
+      (LP: #1047168)
+    - Unredirected fullscreen windows flicker briefly when another window 
+      (like a menu) opens above them (LP: #1046664)
+    - Week33 - Grid highlight window appears while switching between workspaces
+      (LP: #1037142)
+    - gtk-window-decorator leaks large numbers of pixmaps and pixmap memory 
+      (LP: #1057263)
+    - [fglrx] compiz crashed with SIGSEGV in glXDestroyContext() 
+      [/usr/lib/fglrx/libGL.so.1] from GLScreen::~GLScreen() (LP: #1054724)
+    - Maximized window gets unredirected when it's not fullscreen 
+      (LP: #1053902)
+    - Double shortcuts conflict with gnome-control-center ones (LP: #1050796)
+    - gtk-window-decorator leaking window handles. Window operations become 
+      sluggish after a few days of usage (LP: #1050610)
+    - [valgrind] Up to 520,000 bytes lost when running 
+      CCSGSettingsBackendConceptTest (LP: #1049169)
+    - 1:0.9.8+bzr3319-0ubuntu1 regression: keeps setting gsettings keys to 
+      wrong values (LP: #1042041)
+    - Compiz r3275 breaks VirtualBox Guest Additions: black screen or just 
+      wallpaper (LP: #1030891)
+    - Incorrect (low/stuttering) refresh rate with NVIDIA driver (LP: #92599)
+    - ARM build broken with 'swapInterval' is not a member of 'GL' 
+      (LP: #1056645)
+    - compiz.fix_927168 broke ARM building (LP: #1052838)
+    - compiz crashed with SIGSEGV in __strcasestr_ia32() from 
+      ccsStringToModifiers(binding=NULL) (LP: #1041535)
+  * Cherry-picked from upstream:
+    - ABI bump due to an ABI change in the composite plugin
+    - Removed schema keys still used in keybindings and automated tests 
+      (LP: #1057955)
+
+ -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Thu, 27 Sep 2012 15:43:59 +0200
+
+compiz (1:0.9.8.2+bzr3377-0ubuntu1) quantal-proposed; urgency=low
+
+  [ Sam Spilsbury ]
+  * debian/python-compizconfig.install
+    - Install compizconfig-python.pc
+  * debian/patches/100_expo_layout.patch
+    - re-add the expo layout that used to be in precise (LP: #1047067)
+    - add some testcases
+
+  [ Timo Jyrinki ]
+  * New upstream snapshot.
+    - Fix multiple window placement bugs (LP: #974242) (LP: #976032)
+    - Don't waste CPU looping through and looking at all the windows if you're
+      rendering an output that has no damage on it. (LP: #1014986)
+    - Updated convert files to fix some typos in the key names. (LP: #1041631)
+    - Fix crash when imgsvg is loaded, due to missing symbol
+      (decor_apply_gravity from libdecoration). (LP: #956986)
+    - Treat unresolved symbols at link time as an error, rather than letting
+      them through and cause strange crashes later. (LP: #1043143)
+    - Refactors a little bit of the upgrade code and gets it under test to
+      prepare to fix (LP: #1042537)
+    - Updated AUTHORS from the full bzr log, and re-sort the list.
+      (LP: #1042095)
+    - Fixes FTBFS for kde4-window-decorator (LP: #1041310)
+    - Fix obvious omissions from the introduction of unminimize_*,
+      which were causing the unminimize animation settings to be ignored
+      (LP: #1040455)
+    - resize plugin: don't crash if resize wasn't initiated externally
+      (LP: #1045191)
+    - Clean up capitalization (LP: #1045652)
+    - Avoid division by zero, if plugins try to deform a window down to size
+      zero. (LP: #1045235)
+    - Make "Unredirect Fullscreen Windows" more reliable. This fixes the
+      problem with unredirection failing to engage at all (LP: #1041066) when
+      gtk-window-decorator creates offscreen windows that are stacked on top.
+      This also fixes the problem with unredirect hiding all windows,
+      because it thinks the desktop window should be stacked on top
+      (LP: #980663).
+    - Ensure unredirected windows don't stay unredirected if they're no longer
+      on top. (LP: #1041047)
+    - Fix launching terminal functionality and make show-hud default key 
+      visible. Update the defaults to org.compiz.integrated to reflect the
+      actual gnome values pre-gnome-3. (LP: #1040081) (LP: #1046199) 
+      (LP: #1046190)
+    - Fix show-hud, bump COMPIZ_GNOME_INTEGRATED_SETTINGS_LIST_SIZE.
+      (LP: #1046212)
+    - Fixed: Windows with an alpha-channel, like gnome-terminal, were not
+      being considered as possibly covering fullscreen windows. But they most
+      certainly can. This ensures such RGBA windows are visible if they're 
+      stacked above a fullscreen window. (LP: #1046661)
+    - Remove ListToStringList (LP: #1046184)
+    - Fix typo causing CMake Error (LP: #1045665)
+    - Transitions gtk-window-decorator over to use GSettings. Add a testing 
+      framework for the options code. (LP: #1042323)
+    - Also need kdeworkspace since kdecorationbridge.h is there
+      (LP: #1046770)
+    - Implements some cleanup that was suggested on the merge for the original
+      port to gsettings. Other issues fixed as well. (LP: #1042323)
+    - Fix the case where a new gsettings schema got added for building but
+      it wasn't recompiled locally (LP: #1046701)
+    - Scale: select the window under the pointer, when the scale animation 
+      is over. (LP: #1045127)
+    - Fixes the some "Use of uninitialised value" warnings reported by
+      valgrind (LP: #1004336))
+    - Check if org.gnome.mutter is available before using it (LP: #1048551)
+    - We don't need to map our style windows, prevent them from cluttering 
+      up the paint queue (LP: #1042552)
+    - Migrate profile independent keys separately from the profile 
+      dependent keys (LP: #1046190)
+    - Don't ever enter the subdir of a plugin that is disabled. (LP: #1049100)
+    - Workaround SubBuffer performance regression (LP: #1037411)
+    - Changed the default placement of the benchmark window from 0,0 to
+      100,50. (LP: #1039406)
+    - Ensure window decorations always get rendered after the window, not
+      before. This is how it was in compiz 0.9.7, and is required in order 
+      to resolve unity panel shadow (LP: #1050704)
+    - Fix CMakeLists.txt to bring an xslt file back to compiz-dev
+    - Avoid a NULL dereference and give a useful error message instead
+      (LP: #944653)
+    - Fix (LP: #1050752)
+    - Check that pixmaps which aren't managed by us actually exist before
+      binding. (LP: #927168)
+    - Fix flickering and performance problems with using Unredirect Fullscreen 
+      Windows with multiple monitors. (LP: #1050749) (LP: #1051885)
+  * debian/compiz-dev.install
+    - Remove compizconfig-python.pc, now in python-compizconfig.install
+  * Drop dependency on libgconf2-dev, add gconf2 dependency to the 
+    transitional package for migrations
+  * Add -DUSE_GCONF=OFF to debian/rules
+  * debian/libdecoration0.symbols
+    - Add decor_shadow_options_cmp
+  * Cherry-pick fixes from trunk:
+    - Fix FTBFS with BUILD_GLES
+  * Restore 'Glide 2' unminimize animation via override
+
+  [ Didier Roche ]
+  * debian/libdecoration0.symbols:
+    - update the symbols file
+  * add and cherry-pick missing ABI breakage bump
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 20 Sep 2012 17:39:05 +0200
+
+compiz (1:0.9.8.0-0ubuntu1) quantal-proposed; urgency=low
+
+  * debian/control, debian/rules: 
+    - enable gles on armel and armhf
+    - use dh-translations rather than custom code
+
+  [ Sam Spilsbury ]
+  * Enable OpenGL ES building 
+    - Refresh debian/patches/workaround_broken_drivers.patch
+    - Remove non-ported plugins from compiz-plugins
+    - Add FindOpenGLES2.cmake to compiz-dev
+
+  [ Timo Jyrinki ]
+  * New upstream release.
+    - Code to make compiz work on GLES. This includes several changes 
+      to the compiz API. (LP: #201342) (LP: #901097) (LP: #1004251)
+      (LP: #1037710)
+    - Draft first 0.9.8.0 NEWS and bump VERSION
+  * debian/patches/compiz-package-gles2.patch:
+    - Remove, obsoleted by the upstream GLES work 
+  * Disable plugins that don't work on pure GLES on armhf/armel:
+    - bench, firepaint, mblur, showmouse, splash, showrepaint, td, widget
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 31 Aug 2012 22:59:50 +0200
+
+compiz (1:0.9.8+bzr3319-0ubuntu3) quantal; urgency=low
+
+  * debian/control.in:
+    - Recommends python-gconf for the migration script (lp: #1041498)
+  * postinst/convert-files/compiz-profile-active-Default.convert, 
+    postinst/convert-files/compiz-profile-Default.convert:
+    - updated to fix some key names typos in the list (lp: #1041631)
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 28 Aug 2012 19:50:29 +0200
+
+compiz (1:0.9.8+bzr3319-0ubuntu2) quantal-proposed; urgency=low
+
+  * No change rebuild against the latest metacity
+
+ -- Robert Ancell <robert.ancell@canonical.com>  Fri, 24 Aug 2012 16:36:28 +1200
+
+compiz (1:0.9.8+bzr3319-0ubuntu1) quantal-proposed; urgency=low
+
+  [ Didier Roche ]
+  * debian/patches/ubuntu-config.patch:
+    - refresh with latest trunk
+  * debian/*docs:
+    - remove the TODO copy now removed upstream
+  * debian/compiz-plugins.install:
+    - install stackswitch, trip plugins
+  * debian/rules, debian/control:
+    - remove the compiz gnome-control-center key sedding through metacity.
+      Compiz now directly ships them.
+    - we do not need metacity-common anymore as a build-dep then
+  * debian/compiz-gnome.migrations, debian/control:
+    - build-dep on dh-migrations and ship gconf -> gsettings migration file
+
+  [ Matthieu Baerts (matttbe) ]
+  * Update apport hook for python3 ; thanks to Edward Donovan (LP: #1013171)
+
+  [ Timo Jyrinki ]
+  * New upstream snapshot.
+    - Fix Compiz crash in movementWindowOnScreen (LP: #1015151)
+    - Start window decorator when decor plugin starts (LP: #1014461)
+    - Fixed: Crash in compiz::wall::movementWindowOnScreen (LP: #1015151)
+    - Don't waste memory leaving /bin/sh running (LP: #1015422)
+    - Add reliable detection of the compiz bin directory (LP: #1015898)
+    - Check if the window would actually paint before painting the shadow, 
+      since it is possible that another plugin could be inhibiting paint of 
+      the dock   window. (LP: #1012956)
+    - Don't insert the window into the server list above the window it was
+      created above. (LP: #1008020) (LP: #886605)
+    - makes compiz enhanced zoom and show mouse plugins considerably
+      smoother to use (LP: #930783)
+    - Don't set decoration contexts on undecorated windows, since that 
+      might be read later and code will assume the window is decorated when 
+      it isn't. (LP: #1015593)
+    - Fix potentially unterminated string leading to an uninitialized memory
+      read (LP: #1018302)
+    - Lift the 31/32 character restriction on key names that was causing so 
+      many warnings. It's now 1024 characters according to glib. (LP: #1018730)
+    - Don't print the result of BUILD_DEB. It prevents ccsm et al from 
+      installing. (LP: #1018916)
+    - Use the XDamage extension more efficiently (the way it was designed to be
+      used). This dramatically reduces CPU usage, reduces wakeups, and 
+      increases frame rates. It also solves at least one observed performance 
+      bug (LP: #1007299) and probably several more.
+    - Do the initial work to get libcompizconfig under test. (LP: #990690)
+    - Add support for initiating window picker in other than nomal mode. For 
+      now added only the additional 'All windows' picker (LP: #933776) 
+      (LP: #955035)
+    - Fixes (LP: #1018602) : An invalid read when using g_variant_iter_loop.
+    - Don't allow unbinds of textures kept around for animations in any case, 
+      not just resizing. (LP: #1016366)
+    - Wait for the server to finish processing requests before doing a bind
+      (LP: #1016367)
+    - Using the next/previous bindings the wall plugin didn't calculate 
+      correctly the next workspace when it reaches the begin or the end of a 
+      row of workspaces, so it didn't jump to the next line. (LP: #904205).
+    - Added the plug-in "Stack Window Switcher" converted from git to bzr 
+      (including full history) to Compiz. (LP: #1012205)
+    - Added the unsupported, but fully working plug-in "workspacenames"
+    - Added the plug-in "Trip" (LP: #1012213)
+    - Add extra checks to avoid passing an invalid xid to XGetWindowProperty 
+      which would result in fatal error: BadWindow (invalid Window parameter).
+      (LP: #1019337)
+    - Fix crash LP: #1019337 properly this time.
+    - Added .convert files (for gsettings-data-convert) and a migration python
+      script (best for usage with session-migrations) for migrating some compiz
+      settings from gconf to gsettings
+    - Fix CMake error when USER environment variable is not set (LP: #1023772)
+    - Avoid severe artifacts and flickering when using LLVMpipe (LP: #1021104)
+    - Fix build failure due to invalid sed expression (LP: #1023738)
+    - Generate the CTestFile.cmake using cmake itself (LP: #1024214)
+    - Avoid random build failures "_intltool_update-NOTFOUND: not found"
+      by verifying intltool-update exists. If not, then fail cmake more 
+      cleanly with a nice error message telling the user how to install 
+      it. (LP: #1023742)
+    - Fixed CompTimerTestCallback.TimerOrder failure on slow 
+      systems (like valgrind) (LP: #1021139)
+    - Fix incorrect shell expansion, leading to invalid "sed" syntax 
+      (LP: #1029383)
+    - Install the cmake helper macros and check for them in 
+      COMPIZ_CMAKE_MODULE_PATH (LP: #1024179)
+    - Fixed: schemas were getting installed to ${DESTDIR} twice
+    - Reduced combined filesizes of Compiz' .png resources from 2.2MB to 
+      1.5MB by re compression of those with Trimage Image Compressor.
+    - Added test module for the migration script created by Francis Ginther
+    - Adds a COVERAGE argument to compiz_discover_tests
+    - Fixed various problems described in bug 1030473, optimizing 
+      performance and style (LP: #1030473)
+    - Fixed commands addon desription typo (LP: #1033085)
+    - Reduced the scope of the variable 'icccm_version', removed a break 
+      that can never be executed, added the variables 'frameType', 
+      'frameState' and 'frameActions' to decor_quads_to_property in the 
+      #else branch in KWD::Switcher::updateWindowProperties () as well and 
+      simplified calc_button_size (decor_t *d) in cairo.c.. (LP: #1030473)
+    - Always call terminate callbacks for key bindings. ATM we call just the 
+      first callback. (LP: #960652)
+    - Make valgrind shut up about some known "leaks" in python and glib.
+      Fix some leaks in the tests in the process.
+    - Implemented single click exit from expo screen. (LP: #1033531)
+    - Restore the fix for avoiding re-entering the glib event loop and 
+      crashing. (LP: #1036490)
+    - Including rsvg-cairo.h is now deprecated. (LP: #1039482)
+    - Add keybinding integration for gnome-control-center
+    - Separate the configuration for the minimize and unminimize animations.
+      (LP: #1036739)
+    - Ignore mouse press and release if it does not happen inside of the expo
+      screen. (LP: #1036542). 
+    - Additional keys from metacity to convert to GSettings
+    - Maximize vertically if pointer reaches top or bottom edges.
+    - Explicitly depend on resize-options. (LP: #1039834)
+    - Add some docstring warnings about using those classes directly.
+    - Fix some memory management issues on the mock objects, namely:
+      Make destructor functions virtual where appropriate, so that we can add 
+      them to lists polymorphically. Support polymorphic ccs*Unref function.
+      Also make some other necessary changes to libcompizconfig.
+    - Detect if rsvg 2.36.2 is installed (LP: #1039843)
+    - GSettings integration backend, created a testsuite for it. Refactors a 
+      bunch of the backend code, adds appropriate testsuites and refactors 
+      the integration code to make it more flexible. (LP: #1035261)
+  * Update compiz-core.lintian-overrides
+  * Enable GSettings backend and install the schema files
+  * Switch the default profile to use gsettings 
+  * Add dependency on gsettings-desktop-schemas(-dev)
+  * Add compiz-gnome.gsettings-override
+  * Update gsettings-override to new paths org.compiz.*
+  * Add support for disabling gconf schemas installation
+    - However, not enabled because of gtk-window-decorator for now
+  * Add libcompizconfig_gsettings_backend.so
+  * Workaround to install xml files
+
+  [ Łukasz 'sil2100' Zemczak ]
+  * debian/control, debian/rules:
+    - add dependency and use dh-migrations
+  * debian/compiz-gnome.migrations:
+    - use a migrations file for installing the script for migrating gconf
+      configuration to gsettings
+  * debian/patches/ubuntu-config.patch:
+    - changed keybinding for initiate window picker, according to the design
+      specification
+
+ -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Thu, 23 Aug 2012 09:56:05 +0300
+
+compiz (1:0.9.8+bzr3249-0ubuntu4) quantal; urgency=low
+
+  * Restore the maintainer script, the profile part is needed
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 15 Aug 2012 17:46:48 +0200
+
+compiz (1:0.9.8+bzr3249-0ubuntu3) quantal; urgency=low
+
+  * Remove unity-2d 2nd fallback mechanism for autologin as unity-2d
+    is now deprecated: (part one of LP: #1035261)
+    - debian/65compiz_profile-on-session,
+      debian/compiz-gnome.install:
+      remove conffile and don't install it
+    - debian/compiz-gnome.maintscript:
+      remove it on upgrade
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 15 Aug 2012 14:58:39 +0200
+
+compiz (1:0.9.8+bzr3249-0ubuntu2) quantal; urgency=low
+
+  * debian/control:
+    - take latest libjpeg8 instead of 62
+    - fix a missing Replaces: on libcompizconfig0 (LP: #1019270)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 29 Jun 2012 18:10:50 +0200
+
+compiz (1:0.9.8+bzr3249-0ubuntu1) quantal-proposed; urgency=low
+
+  * New upstream snapshot.
+    - Fall back to a refresh rate that is more likely to look correct; 60Hz.
+      (LP: #1009338)
+    - Benchmark plugin should consume its key binding, and not pass the key to
+      the underlying window. (LP: #1009320)
+    - Avoid needless STL operations leading to expensive heap operations.
+      (LP: #1006335)
+    - Fix a typo that was causing (LP: #1002606)
+      (widthIncBorders/heightIncBorders)
+    - Check if the window is decorated before trying to change its event window
+      states (which won't exist if not decorated) (LP: #1007754)
+    - Use the XDamage extension more efficiently (the way it was designed to be
+      used). This dramatically reduces CPU usage, reduces wakeups, and
+      increases frame rates. It also solves at least one observed performance
+      bug (LP: #1007299) and probably several more.
+    - Avoid constructing and destructing lots of strings on every single event,
+      which was wasting lots of CPU (LP: #1005569)
+    - md LINGUAS doesn't exist, it's mnk (Mandinka in ISO 639-3)
+    - Move grid plugin to google test and don't depend on the plugin for the
+      test (LP: #1005009)
+    - Don't read plugin.Initialized and test the value. (LP: #1004848)
+    - libcompizconfig's install () commands were still using the old includedir
+      and libdir variables rather than their libcompizconfig_* variants.
+      (LP: #1005176)
+    - Execute the cmake files separately to ensure that DESTDIR is respected.
+      (LP: #1005177)
+    - Don't set_target_properties on a target that might not exist
+      (LP: #1005008)
+    - Don't allow windows which we weren't even tracking as decoratable to
+      become decorated if they try and change their hints. (LP: #963794)
+    - Change the mouse pointer while dragging windows in expo. Just like the
+      ubuntu branches do. (LP: #987647)
+    - Fix uninitialized memory use (LP: #1004338)
+    - Fix uninitialized variable (LP: #1004335)
+    - Delay unbinding of pixmaps until then next rebind (LP: #729979)
+      (LP: #1002602)
+    - Don't drop plugins from the list to try and load before you've even tried
+      to load them. Doing so makes missing plugins silently ignored instead of
+      an error message (LP: #1002715). It also means valid plugins in more
+      unusual, but real locations in LD_LIBRARY_PATH will never get loaded
+      (LP: #1002721).
+    - If running test cases under a real X server, we don't care if Xvfb is
+      missing (LP: #994841)
+    - Don't assume pkg_check_modules always sets _PREFIX (LP: #993608)
+    - Don't clear selections in ~PrivateScreen because it causes a race between
+      the existing and the new compiz instances, breaking --replace and
+      non-replace behaviour. (LP: #988684) (LP: #989545)
+    - Always paint with infiniteRegion as the clip region if the window is
+      transformed and always use the supplied region if painting with offset or
+      on transformed screen. (LP: #987639)
+    - Add synchronization primitives to the decoration protocol so that there
+      isn't a race where we bind a texture that's being freed. (LP: #454218) 
+      (LP: #929989)
+    - fix a crash in the first attempt at this (LP: #996901)
+    - Reintroduce the fix for LP: #994841 which was accidentally reverted by
+      revision 3133. (LP: #999019)
+  * Cherry-pick some post-snapshot crasher fix:
+    - rev for Crash in compiz::wall::movementWindowOnScreen (rev 3255)
+      (LP: #1015151)
+    - Don't set decoration contexts on undecorated windows, since that might be
+      read later and code will assume the window is decorated when it isn't.
+      (LP: #1015593). rev 3261
+  * debian/control:
+    - clean build-deps, removing some suggests and rewritting some descriptions
+      to fit the reality
+    - change Vcs-Bzr to canonical branch
+  * add libcompizconfig package:
+    - debian/control:
+      - add some build-deps
+      - add the new packages
+    - debian/libcompizconfig0.install, debian/libcompizconfig0-dev.install:
+      - added the install files,
+      - removed some unused profiles
+    - add debian/config for default profile (wasn't shipped anymore upstream)
+  * merge compiz-plugins-main, compiz-plugins-main-default,
+    compiz-plugins-main-dev and compiz-plugins-extra to this package
+    both .install and .install.armhf, .install.armel):
+    - compiz-plugins-main-default plugins are now in compiz-plugins-default
+    - compiz-plugins-main plugins are now in compiz-plugins
+    - compiz-plugins-extra plugins are now in compiz-plugins-extra
+    - compiz-plugins-main-dev and some part of compiz-plugins-extra content
+      is now in compiz-dev
+    - the gconf configuration part is now in compiz-gnome (won't appear if the
+      .so file isn't installed in ccsm)
+    - debian/control:
+      * add the necessary build-dep
+      * add the needed replaces
+      * add transitional compiz-plugins-main-default, compiz-plugins-main,
+        compiz-plugins-main-dev and compiz-plugins-extra packages
+  * add python-compizconfig to the package:
+    - debian/control:
+      add the necessary build-dep, remove cython as in universe and adapt
+      upstream code to only use pyrexc
+    - debian/rules:
+      build with dh_python2
+    - add debian/python-compizconfig.install
+  * add compizconfig-settings-manager to the package:
+    - debian/control:
+      * drop some deps
+      * add a recommends on -default instead of compiz-plugins
+    - add debian/compizconfig-settings-manager.install
+  * Remove compiz-kde:
+    - not anymore supported upstream
+    - remove the build-deps as well
+    - remove some reference to -kde in description and depends
+    - remove the install file
+  * compiz-core:
+    - remove and don't install debian/compiz-decorator wrapper anymore
+    - same with debian/compiz-decorator.1
+    - run gtk-window-decorator in debian/patches/ubuntu-config.patch by default
+    - put some dev files in compiz-dev now
+  * removing compizconfig-backend-gconf, making this package (as well as the
+    new gsettings backend) part of compiz-gnome:
+    - added to the .install files
+    - added the C/R/P to compiz-gnome
+    - added the transitional package
+  * debian/patches/ccp_plugin.patch:
+    - adapted to new upstream code and style
+  * Misc:
+    - remove a lot of compiz-fusion and compiz-wrapper references (deprecated,
+      upgrade path not supported anymore) in debian/control
+    - remove a lot of breaks: replaces: pre-12.04
+    - update debian/libdecorator0.symbols
+    - set python-compizconfig section to python
+    - set some lintian non applicable warnings in *.lintian-overrides
+    - merging every patches for every independent sources in this source
+    - add debian ccsm manpage (debian/compizconfig-settings-manager.manpages,
+      debian/patches/ccsm.1)
+    - enable building compiz in parallel
+    - switch to dh9
+    - build on unversionned boost -dev
+    - shipped new workspacename plugin
+    - adding some replaces for locale installation support as well
+  * debian/patches/99_valid_ccsm_desktop_file.patch:
+    - create a valid ccsm desktop file
+  * debian/copyright, debian/watch:
+    - redone, as new packaging, new source content, new host (launchpad)
+  * debian/patches/ubuntu-config.patch:
+    - don't expose on edge
+  * debian/source/format:
+    - remove v3 (quilt) format: it doesn't work well with merge-upstream
+      workflow
+  * Note that right now, armhf/armel are building with opengl as opengles is
+    not yet backed into upstream and opengles drivers are broken in quantal
+    kernel
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 19 Jun 2012 12:25:07 +0100
+
+compiz (1:0.9.7.8-0ubuntu3) quantal; urgency=low
+
+  * drop -Werror temporary on armel/hf builds until the GLES patch does 
+    not produce warnings anymore which cause compiz to FTBFS
+
+ --  Oliver Grawert <ogra@ubuntu.com>  Mon, 04 Jun 2012 17:38:35 +0200
+
+compiz (1:0.9.7.8-0ubuntu2) quantal; urgency=low
+
+  * debian/control:
+    - rebuild with new boost
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 31 May 2012 09:41:01 +0200
+
+compiz (1:0.9.7.8-0ubuntu1) precise-proposed; urgency=low
+
+  [ Didier Roche ]
+  * New upstream bug fix release:
+    - [fglrx] Title bar does not update on non-maximized windows (LP: #770283)
+    - Some apps (like Remmina) can't full-screen under Compiz (or Unity)
+      (LP: #946388)
+    - Compiz-core fails to compile with gcc-4.7 - 'cc1plus: all warnings
+      being treated as errors' (LP: #972519)
+    - Menu shadow clipping flickers while switching menubar items/indicators
+      (LP: #978900)
+    - Compiz should not move windows to workspace 0,0 when restarted
+      (LP: #980026)
+    - regression / unable to interact with window-titlebar (window decoration)
+      after minimizing/unminimizing gnome-terminal (LP: #981703)
+  * debian/patches/workaround_770283.patch,
+    debian/patches/fix_976467.patch:
+    - removed, upstreamed
+
+  [ Oliver Grawert ]
+  * update the GLES2 patch for the new upstream release.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 26 Apr 2012 09:19:51 +0200
+
+compiz (1:0.9.7.6-0ubuntu2) precise-proposed; urgency=low
+
+  [ Łukasz 'sil2100' Zemczak ]
+  * debian/patches/workaround_770283.patch:
+    - Workaround a problem with fglrx not refreshing window decoration textures
+      on pixmap modification (LP: #770283)
+
+  [ Oliver Grawert ]
+  * update GLES patch for new quilt patch, fix issue with GLES patch that
+    forcefully unapplied other quilt patches and resulted in
+    gtk-window-decorator to not be started.
+
+ -- Oliver Grawert <ogra@ubuntu.com>  Fri, 20 Apr 2012 18:25:13 +0200
+
+compiz (1:0.9.7.6-0ubuntu1) precise; urgency=low
+
+  [ Didier Roche ]
+  * New upstream release:
+    - Memory leak in dlloaderListPlugins (LP: #968985)
+    - priv->invisible is not updated when the window is mapped (LP: #969102)
+    - window management, multi-monitor - In multi-monitor environment, windows
+      should spread on the monitor in which they reside (LP: #919139)
+    - Drop-down menus look disembodied from their titles (LP: #659816)
+    - Improve performace of the shadow clipping code (LP: #931883)
+    - DecorWindow::computeShadowRegion called way too much (LP: #969101)
+    - white box randomly shows up at top left corner blocking application
+      from using stuff under it (LP: #940603)
+  * Rebuild against latest metacity to get the HUD key configuration
+    exposed in unity 3D as well (LP: #969256)
+  * debian/patches/ubuntu-config.patch:
+    - set multioutput_mode to all outputs (windows to be scaled on each the
+      monitor they are on only) (LP: #919139)
+  * debian/patches/fix_976467.patch:
+    - Fix shadows being clipped incorrectly (LP: #976467)
+
+  [ Oliver Grawert ]
+  * update the GLES2 patch for the new upstream release.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 11 Apr 2012 18:35:39 +0200
+
+compiz (1:0.9.7.4-0ubuntu3) precise; urgency=low
+
+  * fix typo in copying of the cmake files, so FindOpenGLES2.cmake ends up in
+    the right place for other packages (i.e. compiz-plugins-main on GLES2
+    capable arches)
+  * make copying the GLES2 cmake file architecture specifc instead of ignoring
+    if it is not found on arches that do not have it.
+
+ -- Oliver Grawert <ogra@ubuntu.com>  Fri, 06 Apr 2012 13:55:13 +0200
+
+compiz (1:0.9.7.4-0ubuntu2) precise; urgency=low
+
+  * enable Linaros compiz-package-gles2.patch for armhf(/el) builds, thanks
+    to Alexandros Frantzis <alexandros.frantzis@linaro.org> for creating it.
+  * enable quilt in debian/rules
+  * apply patches based on debian architecture via series.<arch> file
+    (stolen from eglibc)
+  * add build deps to libgl1-mesa-dev and libgl-dev for armhf builds
+  * add armel/armhf specific .install files since only a subset of modules can
+    be built yet.
+
+ -- Oliver Grawert <ogra@ubuntu.com>  Thu, 05 Apr 2012 19:09:27 +0200
+
+compiz (1:0.9.7.4-0ubuntu1) precise; urgency=low
+
+  * New upstream release
+    - compiz crashed with SIGSEGV in CompositeScreen::compositingActive()
+    - Window management - Closing one window sends others to the
+      background (LP: #888704)
+    - [regression] Invisible resize border is now only 1px wide (LP: #953839)
+    - Coverity REVERSE_INULL - CID 10888 (LP: #957572)
+    - Unity dash opens and immediately closes if you tap Super+A
+      quickly (LP: #960831)
+    - Unity 5.8: Flickering and corruption on Unity UI elements (LP: #963093)
+    - Unity 5.8: Can't login to Unity since upgrade to 5.8 (LP: #963465)
+    - [regression] Unity 5.8+Compiz 0.9.7.2: Pressing Super+Tab or
+      Super+W works, but unity does not respond to when Super is
+      released. (LP: #963470)
+    - Unity 5.8: Login to blank screen (all black or just wallpaper)
+      (LP: #963633)
+    - Tests do not build when libgtest-dev is installed but libgtest
+      isn't (LP: #964248)
+    - Note that this fix is REMOVED for stability reasons:
+       Unity/compiz intercepts Super and Alt keypresses from grabbed
+       windows like VMs. (806255)
+  * debian/patches/ubuntu-config.patch:
+    - tweak slightly the shadow border for both active/inactive windows.
+    - change the shortcuts as per design request: (LP: #969235)
+      Ctrl + Super + D Minimises all windows
+      Ctrl + Super + Cursor up Maximises the current window
+      Ctrl + Super + Cursor down Restores or minimises current window
+  * debian/rules, debian/compiz-gnome.gconf-defaults:
+    - move the default for the unity-less default profile from DEFAULT_PLUGINS
+      list as it seems compiz tries to load that list, then ccp, then the
+      profile list.
+    - put the active_plugins list back to the Default profile in gconf then.
+  * debian/control:
+    - set Standards-Version to latest
+  * remove debian/patches/always_replace.patch,
+    debian/patches/exit_1_if_composite_cant_init.patch,
+    debian/patches/reset_active_plugin_list.patch,
+    debian/reset-compiz-gconf, debian/compiz-gnome.install:
+    - the 3 bad hacks are now not necessary anymore (LP: #963264)
+  * remove as now in upstream tarball:
+    - debian/patches/fix_953839.patch
+    - debian/patches/revert_lim.patch
+    - debian/patches/fix_953089_2.patch
+    - debian/patches/fix_960831.patch
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 03 Apr 2012 15:43:16 +0200
+
+compiz (1:0.9.7.2-0ubuntu4) precise; urgency=low
+
+  * No-change upload to the release pocket instead of to -proposed, so we can
+    get the package built on all archs immediately instead of it blocking on
+    gtk+3.0's build on armel.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Mar 2012 14:57:30 -0700
+
+compiz (1:0.9.7.2-0ubuntu3) precise-proposed; urgency=low
+
+  * debian/reset-compiz-gconf:
+    - Fix crash in a new session
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 26 Mar 2012 20:35:33 +0200
+
+compiz (1:0.9.7.2-0ubuntu2) precise-proposed; urgency=low
+
+  * debian/patches/reset_active_plugin_list.patch:
+    temporary wrapper from resetting the plugin list to the default.
+    Uncorrect and unknown plugin makes various side effects, like removing
+    plugins, creating hanging at startup and also creating on screen
+    corruption. (LP: #963633)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 26 Mar 2012 18:41:09 +0200
+
+compiz (1:0.9.7.2-0ubuntu1) precise-proposed; urgency=low
+
+  [ Łukasz 'sil2100' Zemczak ]
+  * New upstream snapshot:
+    - Fix global menu not being ergonomical on large screens (LP: #682788)
+    - Fix Alt+Right arrow key (LP: #943612)
+    - Fix key bindings for actions while doing tap detection (LP: #944631)
+    - Window movement is erratic and buggy, backport (LP: #923683)
+    - CompScreenImpl::addAction(CompAction*): Assertion `priv->initialized'
+      failed (LP: #946118)
+    - gtk-window-decorator crash with SIGSEGV in max_window_name_width()
+      (LP: #937815)
+    - Finish the implementation of the locally integrated menubars
+      (LP: #931245)
+    - Unity/compiz intercepts keystrokes from grabbed windows (LP: #806255)
+    - Pressing alt doesn't show the menu title bar in top panel (LP: #943194)
+    - Fix Alt stealing focus from widgets (LP: #943851)
+    - Fix Alt + drag (LP: #945373)
+    - lp:compiz-core fails parallel builds (make -jN) (LP: #938417)
+    - Changing the HUD shortcut disables all Alt-based combinations. And
+      changing the Dash shortcut disables all Super-based shortcuts
+      (LP: #945816)
+    - Fix key bindings (such as Super) not working on empty workspace or on 
+      slow/loaded systems (LP: #953089)
+    - compiz crashed with signal 5 in Glib::exception_handlers_invoke()
+      (LP: #808007)
+    - Fix segfault caused by r3043 (LP: #958540)
+  * Removed cherry-picked patches:
+    - debian/patches/fix_806255.patch
+    - debian/patches/fix_923683.patch
+    - debian/patches/fix_943194.patch
+    - debian/patches/fix_944631.patch
+    - debian/patches/fix_alt_pressing.patch
+    - debian/patches/additional_alt_tapping_fix.patch
+
+  [ Didier Roche ]
+  * pick upstream fix, debian/patches/fix_953839.patch:
+    [regression] Invisible resize border is now only 1px wide (LP: #953839)
+  * debian/patches/revert_lim.patch:
+    - revert the integrated menu patch. It won't be released in precise and
+      triggers a regression (in bug #962085)
+  * debian/patches/fix_953089_2.patch:
+    - second trial to fix remaining corner cases
+  * debian/patches/exit_1_if_composite_cant_init.patch:
+    - try to workaround a crasher which seems to happen when the composite
+      plugin failed to initialize. Hopefully exiting 1 will make gnome-session
+      respawning compiz and then the init will work. (LP: #833729)
+  * debian/patches/always_replace.patch:
+    - right now, always replace the current WM as it seems that some people
+      got another compositor running at the start of the session. This will
+      hopefully workaround the issue that some people experience.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 23 Mar 2012 09:13:51 +0100
+
+compiz (1:0.9.7.0+bzr3035-0ubuntu1) precise; urgency=low
+
+  [ Łukasz 'sil2100' Zemczak ]
+  * New upstream snapshot:
+    - Fix gtk-window-decorator crash upon demaximizing a window (LP: #930071)
+    - Fix core keybindings (LP: #930412)
+    - Fixes compiz crash with SIGSEGV on shutdown (LP: #931283)
+    - Plugins can't tell the difference between a key-tap and modifier
+      key-release (LP: #925293)
+    - compiz-core r3001 (and 3002) ftbfs (LP: #933226)
+    - Semi-maximized windows have no shadow or frame (LP: #924736)
+    - Untranslated strings in gtk-window-decorator (LP: #780505)
+    - Initialize the _NET_WM_STATE_FOCUSED (LP: #932087)
+    - [regression] Customized shortcuts don't work (LP: #931927)
+    - Window stacking problem (LP: #936675)
+    - Quickly demaximized windows can receive maximized window decorations if 
+      they were initially maximized (LP: #936778)
+    - Maximized windows do not get shadows at all (LP: #936774)
+    - [regression] Launcher, top panel and keyboard un-responsive after using 
+      any Super-x shortcut (LP: #934058)
+    - No draggable border if mutter isn't installed (LP: #936781)
+    - Fix compiz crash with SIGSEGV in XDefineCursor() (LP: #936487)
+    - Fixes memory leak at DecorWindow::updateSwitcher() (LP: #940115)
+    - Unresolved symbols in plugins cause compiz to exit (LP: #938478)
+    - Fix compiz spending about 51% of its CPU time in CompRegion 
+      construction/destruction (LP: #940139)
+    - Fix Conditional jump or move depends on uninitialised value(s) in 
+      decor_match_pixmap (LP: #940066)
+    - Fix 'show desktop' behaviour (LP: #871801)
+    - Tweak algorithm used to cast shadows on maximized windows (LP: #936784)
+    - "Svg" and "Png" should be "SVG and "PNG" (LP: #942890)
+    - Fix invalid memory usage after free() in DecorWindow (LP: #943116)
+    - Fix alt + F10 (LP: #943223)
+  * Removed cherry-picked patches
+  * debian/patches/fix_944631.patch:
+    - Always replay the keyboard if something was grabbed and didn't trigger 
+      an action and don't trigger actions which aren't added accidentally 
+      (LP: #943612) (LP: #944631)
+  * debian/patches/fix_923683.patch:
+    - Backports a patch which prevents the shift race condition
+
+  [ Didier Roche ]
+  * debian/patches/fix_alt_pressing.patch:
+    - Patch from ddv to fix all the regressions with the alt key fix and other
+      (LP: #943851, #945373)
+    - Fix Quicklist are not showing if right-clicking a launcher icon in Expo
+      mode if triggered by Super + S (LP: #944979)
+  * debian/patches/fix_806255.patch:
+    - Unity/compiz intercepts keystrokes from grabbed windows (LP: #806255)
+  * debian/patches/fix_943194.patch:
+    - second part for the alt key fix (LP: #943194)
+  * debian/patches/additional_alt_tapping_fix.patch:
+    - again another alt tapping related fix for some regressions from the
+      previous branch. Taken from "tapping-panacea" upstream branch.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 12 Mar 2012 10:22:10 +0100
+
+compiz (1:0.9.7.0~bzr3025-0ubuntu1~ppa1) precise; urgency=low
+
+  * New upstream snapshot:
+    - Fix gtk-window-decorator crash upon demaximizing a window (LP: #930071)
+    - Fix core keybindings (LP: #930412)
+    - Fixes compiz crash with SIGSEGV on shutdown (LP: #931283)
+    - Plugins can't tell the difference between a key-tap and modifier
+      key-release (LP: #925293)
+    - compiz-core r3001 (and 3002) ftbfs (LP: #933226)
+    - Semi-maximized windows have no shadow or frame (LP: #924736)
+    - Untranslated strings in gtk-window-decorator (LP: #780505)
+    - Initialize the _NET_WM_STATE_FOCUSED (LP: #932087)
+    - [regression] Customized shortcuts don't work (LP: #931927)
+    - Window stacking problem (LP: #936675)
+    - Quickly demaximized windows can receive maximized window decorations if 
+      they were initially maximized (LP: #936778)
+    - Maximized windows do not get shadows at all (LP: #936774)
+    - [regression] Launcher, top panel and keyboard un-responsive after using 
+      any Super-x shortcut (LP: #934058)
+    - No draggable border if mutter isn't installed (LP: #936781)
+    - Fix compiz crash with SIGSEGV in XDefineCursor() (LP: #936487)
+    - Fixes memory leak at DecorWindow::updateSwitcher() (LP: #940115)
+    - Unresolved symbols in plugins cause compiz to exit (LP: #938478)
+    - Fix compiz spending about 51% of its CPU time in CompRegion 
+      construction/destruction (LP: #940139)
+    - Fix Conditional jump or move depends on uninitialised value(s) in 
+      decor_match_pixmap (LP: #940066)
+    - Fix 'show desktop' behaviour (LP: #871801)
+  * Removed cherry-picked patches:
+    - debian/patches/fix_871801.patch
+    - debian/patches/fix_924736.patch
+    - debian/patches/fix_925293.patch
+    - debian/patches/fix_930412.patch
+    - debian/patches/fix_931283.patch
+    - debian/patches/fix_931473.patch
+    - debian/patches/fix_931927.patch
+    - debian/patches/fix_931958.patch
+    - debian/patches/fix_932087.patch
+    - debian/patches/fix_933226.patch
+    - debian/patches/fix_gtk_w_d_crash.patch
+
+ -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@canonical.com>  Mon, 27 Feb 2012 14:53:05 +0100
+
+compiz (1:0.9.7.0~bzr2995-0ubuntu5) precise; urgency=low
+
+  * Change some keybindings as per design (LP: #878820, #891757, #751050)
+    debian/patches/ubuntu-config.patch:
+    - Show desktop is now Super + d
+    - Super + Up maximize the window
+    - Super + Down restore the window
+    - Super + W initiate scale for all windows on current ws
+    - Control + Alt + NumPad 5 is used to switch/restore maximize state
+    - Control + Alt + NumPad 0 is used to minimize current window
+    - Ensure we don't have any conficting keys anymore (LP: #922354)
+  * 01_ctrl_alt_*tea*.patch:
+    - Merged into ubuntu-config.patch, no reason to keep it separated
+  * debian/compiz-gnome.gconf-defaults, debian/rules, debian/unity.ini:
+    - Set the new plugin order with the incoming unity change as the default
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 22 Feb 2012 13:44:25 +0100
+
+compiz (1:0.9.7.0~bzr2995-0ubuntu4) precise; urgency=low
+
+  * debian/patches/fix_925293.patch:
+    - rollback that patch as well, not ready for wide consumption
+      (triggered side effects)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 17 Feb 2012 10:00:16 +0100
+
+compiz (1:0.9.7.0~bzr2995-0ubuntu3) precise; urgency=low
+
+  * debian/patches/series:
+    - rollbacking fix_931473.patch which was supposed to fix
+      "Rendering menus leaves transparent areas". Apparently, the fix does
+      the opposite effect on most configurations. Reverted it put it back in
+      the previous state and the ghost menus are way less common.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 16 Feb 2012 20:47:35 +0100
+
+compiz (1:0.9.7.0~bzr2995-0ubuntu2) precise; urgency=low
+
+  * debian/compiz-kde.install, debian/control, debian/rules:
+    - disable right now kde build for compiz-kde package. It's using
+      deprecated kde libraries and fails to build on armel. It's
+      probably as well not needed anymore as most of kde users are using
+      kwin which is better integrated to kde than compiz. There is not
+      anymore upstream compiz maintenance on this plugin as well.
+      (LP: #931500)
+  * debian/patches/fix_931958.patch:
+    impossible to click on keyring dialog since the upgrade. Doesn't really
+    fix 931958 as per say, but another issue impacting seahorse.
+  * debian/patches/fix_871801.patch:
+    window management, alt-tab - After using 'show desktop' to minimise
+    all windows, opening any new window also incorrectly restores all
+    the minimised windows (LP: #871801)
+  * debian/patches/fix_925293.patch:
+    Add support for key "tap" detection (LP: #925293)
+  * debian/patches/fix_933226.patch:
+    Fix FTBFS in previous commit (LP: #933226)
+  * debian/patches/fix_932087.patch:
+    Initialize the _NET_WM_STATE_FOCUSED (LP: #932087)
+  * debian/patches/fix_931473.patch:
+    - Menus don't fully appear (LP: #931473)
+    - Rendering menus leaves transparent areas (LP: #932813)
+  * debian/patches/fix_931927.patch:
+    - Customized shortcuts don't work in compiz 1:0.9.7.0~bzr2995-0ubuntu1
+      (LP: #931927). Breaks API/ABI.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 16 Feb 2012 15:11:51 +0100
+
+compiz (1:0.9.7.0~bzr2995-0ubuntu1) precise; urgency=low
+
+  [ Didier Roche ]
+  * New upstream snapshot:
+    - Fix slow/stuttering display with fglrx (LP: #763005)
+    - Don't dynamically link to compiz_core
+    - Fix build failures with glib 2.30 (oneiric) (LP: #921406)
+    - Fix uninitialized variable warnings in valgrind (LP: #921451)
+    - Fixes up a bunch of boost::variant edge cases
+    - Fixes a race condition where the xig restart test would fail spuriously
+    - Incorrect (low/stuttering) refresh rate with NVIDIA driver (LP: #92599)
+    - Benchmark window slows the system and degrades graphics resources
+      (LP: #254561)
+    - Windows that hide themselves when closed don't appear in any
+      "this workspace" switcher  (LP: #684731)
+    - hang in g_spawn_sync and select()  (LP: #690239)
+    - word misspelled - bunding  (LP: #694169)
+    - sometimes, restored window placed too high.  (LP: #716521)
+    - Compiz clears the root window in the installer session  (LP: #720679)
+    - unity-window-decorator: When switching between windows, Orca does
+      not speak the title of the focused window.  (LP: #724093)
+    - Cannot open a window that starts iconified  (LP: #732997)
+    - Minimize animation flickr when for maximized apps  (LP: #737125)
+    - Pixmap memory leak in gtk-window-decorator  (LP: #740258)
+    - Windows should not automatically be focused when opened if the
+      focus is on another application  (LP: #748840)
+    - [sandybridge] Graphics tearing when playing video  (LP: #755841)
+    - Compiz's "Sync to Vblank" makes display stutter/slow with fglrx
+      (LP: #763005)
+    - [regression] Moving windows lags behind the mouse by 1-2 seconds;
+      appear to freeze when dragging.  (LP: #764330)
+    - Launcher - Spread should not affect the state of window  (LP: #764673)
+    - Clicking on a tweet/message link sometimes does not work  (LP: #790565)
+    - scrolling on top of a close animation switches viewports  (LP: #795065)
+    - unity video tearing when moving windows in oneiric with
+      nvidia-current  (LP: #798868)
+    - dialogs really slow to be displayed since the compiz update (LP: #812711)
+    - It is possible to stack windows relative to windows that are
+      destroyed  (LP: #837252
+    - Should keep list of windows last sent to server and last recv
+      from server  (LP: #841727)
+    - compiz and X can disagree on the stacking order  (LP: #845719)
+    - A minimized window 'remains' behind on the desktop if
+      /apps/compiz-1/plugins/unityshell/screen0/options/
+      show_minimized_windows is set to true  (LP: #847967)
+    - maximized windows fail to update their input extents when
+      undecorated  (LP: #853734)
+    - resizing bugs with xterm  (LP: #854725)
+    - crash on closing a window  (LP: #856015)
+    - Java application windows cut-off/truncated/not displayed properly
+      (LP: #857201)
+    - compiz crashed with SIGSEGV in CompScreen::insertServerWindow()
+      (LP: #857487)
+    - compiz crashed with SIGABRT in raise()  (LP: #857738)
+    - Applications which create multiple windows that are transients of
+      each other can be given invalid stack positions  (LP: #858625)
+    - Windows move to 0,0 on compiz restarts  (LP: #858629)
+    - Crash when selecting Evolution in alt-tab  (LP: #859431)
+    - invisible window when a window is mapped but not yet drawn on by
+      the process mapping it  (LP: #860286)
+    - race condition in configureXWindow causes unpredicatable window
+      geometry changes  (LP: #860304)
+    - windows that are decorated while resizing can cause incorrect
+      resize results  (LP: #860306)
+    - Moving a window while it is being resized by core caused
+      unpredictable movement  (LP: #860309)
+    - Windows which are marked transients of docks should be treated
+      like docks  (LP: #860397)
+    - can't maximize windows on second monitor and Qt windows displayed
+      in wrong place  (LP: #861341)
+  * debian/compiz-decorator, debian/compiz-gnome.install,
+    debian/compiz-plugins-default.install,
+    debian/compiz-plugins.install,
+    debian/compiz-gnome.gconf-defaults, debian/rules, debian/unity.ini:
+    - no more unity-window-decorator, switch back to gtk-window-decorator
+    - remove plugins that are not shipped anymore
+    - don't set in the default list plugins that are not shipped anymore
+  * debian/libdecoration0.symbols:
+    - upated to latest
+  * Removed cherry-picked patches:
+    - debian/patches/02_fix_autofocus_minimize_window.patch
+    - debian/patches/03_fix_configureframe.patch
+    - debian/patches/04_fix_insertServerWindow_crash.patch
+    - debian/patches/05_fix_reconfigureXWindow_crash.patch
+    - debian/patches/fix-748840.patch
+    - debian/patches/fix-832150.patch
+    - debian/patches/fix-863328.patch
+    - debian/patches/fix-864330.patch
+    - debian/patches/fix-864478.patch
+    - debian/patches/fix-865863.patch
+    - debian/patches/fix-866752.patch
+    - debian/patches/fix-869316_869919.patch
+    - debian/patches/fix-869967.patch
+    - debian/patches/fix-886978.patch
+    - debian/patches/fix_slow_vsync_lp763005.patch
+    - debian/patches/rev_2821_fix_807487.patch
+    - debian/patches/rev_2847_bug_796594.patch
+    - debian/patches/rev_2878_bug_865696.patch
+    - debian/patches/rev_2884_fix_874004.patch
+    - debian/patches/rev_2890_fix_879253.patch
+  * debian/rules:
+    - the abi file is now renamed to core/abiversion.h
+    - remove the .a
+    - Remove -Bsymbolic-functions from LDFLAGS as it causes libcompiz_core to
+      be loaded once per plugin when dlopened
+    - don't run tests, they don't run on headless server anymore
+  * debian/compiz-core.install:
+    - contain new libcompiz-core lib
+  * debian/compiz-kde.install:
+    - do not ship kde part for now, it's broken upstream
+  * debian/patches/ubuntu-config.patch:
+    - default configuration is here now.
+  * debian/patches/fix_gtk_w_d_crash.patch:
+    - additional backport for gtk-w-d crash (LP: #930071)
+  * debian/patches/fix_930412.patch:
+    - backport to fix keybindings not working (LP: #930412)
+  * debian/patches/fix_931283.patch:
+    - trunk commit to fix a crash on shutdown (LP: #931283)
+  * debian/patches/fix_924736.patch:
+    - additional fix for getting the shadow active on maximized window
+      (LP: #924736)
+
+  [ Sam Spilsbury ]
+  * Remove unused plugins, disable tests by default
+  * debian/patches/ccp_plugin.patch : force load the cpp plugin if not
+    specified
+  * debian/patches/workaround_broken_drivers.patch : workaround broken
+    drivers that do binary detection
+  * debian/patches/default_drag_key.patch : add a default in case mutter
+    isn't installed
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 13 Feb 2012 15:28:06 +0100
+
+compiz (1:0.9.6+bzr20110929-0ubuntu8) precise; urgency=low
+
+  * Drop build dependency on libdecoration0-dev (built from this very same source).
+
+ -- Matthias Klose <doko@ubuntu.com>  Sun, 04 Dec 2011 22:21:08 +0100
+
+compiz (1:0.9.6+bzr20110929-0ubuntu7) precise; urgency=low
+
+  * Upload to precise
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 10 Nov 2011 09:11:57 +0100
+
+compiz (1:0.9.6+bzr20110929-0ubuntu6) oneiric-proposed; urgency=low
+
+  * debian/patches/rev_2821_fix_807487.patch:
+    - unity-window-decorator crashed with SIGSEGV in
+      g_datalist_id_set_data_full() (LP: #807487)
+  * debian/patches/rev_2847_bug_796594.patch:
+    - Window behaviour - pressing the 'restore' window indicator on a
+      semi-maximised window should return it to the restored state
+      (LP: #796594)
+  * debian/patches/rev_2878_bug_865696.patch:
+    - Windows from other workspaces missing decorations in window spread 
+      (LP: #865696)
+  * debian/patches/rev_2884_fix_874004.patch:
+    - When a window is minimized on another workspace it doesn't appear
+      in the spread (LP: #874004)
+  * debian/patches/rev_2890_fix_879253.patch:
+    - Makes the previous patch building and not crashing.
+  * Add some upstream missing bits from previous fixes:
+    - debian/patches/fix-864330.patch
+    - debian/patches/fix-864478.patch
+  * debian/patches/fix-886978.patch:
+    - compiz crashes with SIGSEGV in PrivateWindow::configure (LP: #886978)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 20 Oct 2011 14:23:52 +0200
+
+compiz (1:0.9.6+bzr20110929-0ubuntu5) oneiric-proposed; urgency=low
+
+  * debian/patches/fix-864330.patch:
+    - fix windows which can have towed moving (LP: #864330)
+  * debian/patches/fix-864478.patch:
+    - Window shading is broken (LP: #864478)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 12 Oct 2011 10:44:49 +0200
+
+compiz (1:0.9.6+bzr20110929-0ubuntu4) oneiric-proposed; urgency=low
+
+  * debian/control:
+    - don't suggest nvidia-glx, it's part of the old initial packaging
+      and probably a bad hint on non nvidia system (LP: #844218)
+  * Cherry-pick upstream patches:
+    - Windows should not automatically be focused when opened if the focus
+      is on another application (LP: #748840)
+    - Launcher - If a spread contains minimised windows, when the spread
+      exits, the minimised windows momentarily appear on the desktop
+      before disappearing (LP: #863328)
+    - reproducible stacking bug in compiz (LP: #869316)
+    - Click-dragging a window that's stacked above a fullscreen window will
+      cause it to go underneath the fullscreen window (LP: #869919)
+    - sometimes the keyboard input doesn't go to the apparently focussed
+      dialog (LP: #869967)
+    - Opening mumble can cause it to be stacked above the dash if you
+      open the dash at the same time (LP: #865863)
+    - Sometimes configure events are missed and windows move slow as a result
+      (LP: #866752)
+    - Workaround ubuntu desktop unity. Mouse at the left side doesn't reveal
+      launcher (LP: #832150)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 06 Oct 2011 17:57:36 +0200
+
+compiz (1:0.9.6+bzr20110929-0ubuntu3) oneiric; urgency=low
+
+  * debian/patches/04_fix_insertServerWindow_crash.patch:
+    - compiz crashed with SIGSEGV in CompScreen::insertServerWindow()
+      (LP: #857487)
+  * debian/patches/05_fix_reconfigureXWindow_crash.patch:
+    - compiz crashed with SIGABRT in raise() (LP: #857738)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 04 Oct 2011 13:49:01 +0200
+
+compiz (1:0.9.6+bzr20110929-0ubuntu2) oneiric; urgency=low
+
+  * debian/patches/02_fix_autofocus_minimize_window.patch:
+    - closing a window gives focus to last minimized window (LP: #862719)
+  * debian/patches/03_fix_configureframe.patch:
+    - compiz crashed with SIGSEGV in PrivateWindow::configureFrame()
+      (LP: #861909)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 04 Oct 2011 08:29:38 +0200
+
+compiz (1:0.9.6+bzr20110929-0ubuntu1) oneiric; urgency=low
+
+  * New upstream snapshot:
+    - Workspace switcher makes windows lose decorations (LP: #853951)
+    - compiz crashed with SIGSEGV in PrivateWindow::addWindowStackChanges()
+      (LP: #861793)
+    - sometimes, restored window placed too high (LP: #716521)
+    - can't maximize windows on second monitor and Qt windows displayed in
+      wrong place (LP: #861341)
+  * 091_no_use_gnome_but_desktop_file.patch:
+    - partially committed upstream, no more needed
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 29 Sep 2011 09:21:42 +0200
+
+compiz (1:0.9.6-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release 0.9.6:
+   - Windows which are marked transients of docks should be treated like docks (LP: #860397)
+   - Applications which create multiple windows that are transients of each other can be given invalid stack positions (LP: #858625)
+   - race condition in configureXWindow causes unpredicatable window geometry changes (LP: #860304)
+   - invisible window when a window is mapped but not yet drawn on by the process mapping it (LP: #860286)
+   - resizing bugs with xterm (LP: #854725)
+   - Cannot open a window that starts iconified (LP: #732997)
+   - maximized windows fail to update their input extents when undecorated (LP: #853734)
+   - Clicking on a tweet/message link sometimes does not work (LP: #790565)
+   - crash on closing a window (LP: #856015)
+   - Windows move to 0,0 on compiz restarts (LP: #858629)
+   - windows that are decorated while resizing can cause incorrect resize results (LP: #860306)
+   - remove transient window handling from unity-window-decorator (LP: #856096)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 28 Sep 2011 14:15:21 +0200
+
+compiz (1:0.9.5.94+bzr20110919-0ubuntu1) oneiric; urgency=low
+
+  * New upstream snapshot:
+    - "maximized windows fail to update their input extents when undecorated"
+      (LP: #853734)
+    - Panel shadow conflicts with Window shadow in Ubuntu Classic Desktop
+      Session (LP: #731685)
+    - "unity-window-decorator: When switching between windows, Orca does not
+      speak the title of the focused window (LP: #724093)
+    - Dash and launcher appear underneath windows (LP: #805087)
+    - A minimized window 'remains' behind on the desktop if
+      /apps/<…>/show_minimized_windows is set to true (LP: #847967)
+    - compiz and X can disagree on stacking order (LP: #845765)
+    - Should keep a list last sent and last recv from server (LP: #841727)
+    - Minimize animation flickr when for maximized apps (LP: #737125)
+    - Dash and launcher appear underneath windows (LP: #805087)
+    - Stacking problem when switching between apps with multiple windows
+      (LP: #802527)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 22 Sep 2011 14:49:10 +0200
+
+compiz (1:0.9.5.94+bzr2803-0ubuntu5) oneiric; urgency=low
+
+  * debian/compiz-gnome.install:
+    - install the upgrade profile as well
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 15 Sep 2011 20:10:48 +0200
+
+compiz (1:0.9.5.94+bzr2803-0ubuntu4) oneiric; urgency=low
+
+  * debian/profile_upgrades/com.canonical.unity.unity.02.upgrade:
+    - upgrade the settings for the expo changes (LP: #837545)
+  * debian/patches/01_ctrl_alt_*tea*.patch:
+    - make Ctrl + Alt + T the default in compiz too as if you unity --reset
+      to reset all the keys in gconf, it will revert the associated key
+      for metacity in gnome-control-center
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 15 Sep 2011 19:59:40 +0200
+
+compiz (1:0.9.5.94+bzr2803-0ubuntu3) oneiric; urgency=low
+
+  * debian/profile_upgrades/com.canonical.unity.unity.01.upgrade,
+    debian/compiz-gnome.install:
+    - upgrade configuration to remove uneeded staticswitcher and add
+      pause to spread as default for the switcher (LP: #838075)
+  * debian/control:
+    - breaks on unpatched libcompizconfig as it would otherwise lead to
+      a desktop with only "staticswitcher" enabled
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 14 Sep 2011 17:21:35 +0200
+
+compiz (1:0.9.5.94+bzr2803-0ubuntu1) oneiric; urgency=low
+
+  [ David Barth ]
+  * New upstream release 0.9.5.94
+    - Merge in change to have a serverWindows () this break the API
+    - "mumble fix", ie "It is possible to stack windows relative to windows that are destroyed" (LP: #837252)
+    - fix for "Severe screen corruption after rotate the screen" (LP: #833549)
+    - Remove inactive API
+    - Fix for "vp switch causes windows to move further offscreen" (LP: #831987)
+    - Debug messages removed
+    - Memory leak fix in gtk and unity window decorators
+    - Fix further issues with shaped windows mapping/unmapping (rev. 2793)
+  * removed patches that were integrated into the new upstream release
+    - debian/patches/100_core-fix-rev-2794.patch
+    - debian/patches/101_memleak-fix-rev-2794.patch
+    - debian/patches/102_attrib-fix-rev-2796.patch
+    - debian/patches/103_driver_workaround.patch
+
+  [ Didier Roche ]
+  * debian/rules, debian/compiz-gnome.install, debian/compiz-keybindings.sed:
+    - readd and tweak some compiz keys for g-c-c and Gnome integration
+      This fixes Ctrl + Alt + T to open a terminal (LP: #820266)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 12 Sep 2011 08:09:46 +0200
+
+compiz (1:0.9.5.92+bzr2791-0ubuntu1) oneiric; urgency=low
+
+  * debian/65compiz_profile-on-session:
+    - the default profile is "ubuntu" (that fix missed in the vcs it seems)
+  * debian/compiz-decorator:
+    - go back to the unity decorator, the unitydialog work got rolled back
+  * debian/rules:
+    - don't use gsettings, it needs testing and is not ready for Oneiric
+  * debian/patches/103_driver_workaround.patch:
+    - backported new revision from trunk to fix ati binary drivers issue
+
+  [ David Barth ]
+  * Re-apply some distro-patches that were dropped upstream
+  * debian/compiz-gnome.install:
+    - remove gsettings schemas
+  * debian/compiz-core.install:
+    - add additional decorator files
+  * debian/libdecoration0.symbols: update
+  * debian/compiz-core.install: remove references to:
+    -debian/tmp/usr/bin/simple-decorator
+    -debian/tmp/usr/bin/decoration_inspector
+    -debian/tmp/usr/share/simple-decorator/simple-decoration.png
+    -debian/tmp/usr/share/decoration_inspector/decoration_inspector.xml
+  * debian/patches/100_core-fix-rev-2794.patch: core fix to avoid decoration
+    problems
+  * debian/patches/101_memleak-fix-rev-2794.patch: memleak fix
+  * debian/patches/102_attrib-fix-rev-2796.patch: fix for window getting lost
+    when cycling thru workspaces
+
+  [ Didier Roche ]
+  * New upstream release
+  * debian/control:
+    - remove the build-dep on cdbs
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Tue, 23 Aug 2011 18:19:11 +0200
+
+compiz (1:0.9.5.0-0ubuntu5) oneiric; urgency=low
+
+  * Make compiz-dev deps on libdecoration0-dev as compiztoolbox is using it.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 11 Aug 2011 21:21:23 +0200
+
+compiz (1:0.9.5.0-0ubuntu4) oneiric; urgency=low
+
+  * debian/compiz-gnome.gconf-defaults, debian/unity.ini:
+    - remove Static Application Switcher plugin as now handled by unity.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 11 Aug 2011 16:28:49 +0200
+
+compiz (1:0.9.5.0-0ubuntu3) oneiric; urgency=low
+
+  * debian/control:
+    - build-dep on boost 46
+  * debian/65compiz_profile-on-session:
+    - set ubuntu as the default unity session
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 10 Aug 2011 10:22:16 +0200
+
+compiz (1:0.9.5.0-0ubuntu2) oneiric; urgency=low
+
+  * debian/compiz-decorator:
+    - use gtk-window-decorator for alpha3 by default. Too many bugs with u-w-d
+      right now (the side effect is that the decorator isn't removed and we
+      don't get the invisible resize area anymore)
+  * debian/compiz-gnome.gconf-defaults, debian/unity.ini
+    - remove the unity dialogs from oneiric, it's not ready, we won't ship it
+      for now.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 01 Aug 2011 14:38:26 +0200
+
+compiz (1:0.9.5.0-0ubuntu1) oneiric; urgency=low
+
+  * New upstream release:
+    - unity window decorator needs to support different metacity frame types
+      (LP: #795048)
+    - firefox window mapped fullscreen gets mapped under gnome-panel
+      (LP: #800592)
+  * Switch to dpkg-source 3.0 (quilt) format
+  * remove all debian/patches/*:
+    - upstream now directly deliver with our patches
+  * debian/control:
+    - replace kdebase-workspace-dev build-dep by kde-workspace-dev
+    - build on libdecoration0-dev to build the unity window decorator
+    - make compiz-dev dep on gtk-3
+  * debian/compiz-plugins-default.install:
+    - grid is now in -main
+  * debian/libdecoration0.symbols:
+    - add new symbols
+  * debian/patches/01_don_t_init_a11y.patch:
+    - don't initialize the GAIL and AT bridges when comipz initialize
+      (LP: #810045)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 19 Jul 2011 08:00:29 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu6) oneiric; urgency=low
+
+  * debian/control:
+    - don't build with g-c-c integration (broken with gnome 3)
+      removed dep on libgnome-window-settings-dev, libgnomeui-dev,
+      libgnome-desktop-dev
+  * debian/patches/091_no_use_gnome_but_desktop_file.patch,
+    debian/rules, debian/compiz-gnome.install:
+    - don't install anymore previous files, but still build
+      /usr/share/applications/compiz.desktop for starting compiz with
+      gnome-session
+  * debian/65compiz_profile-on-session:
+    - use DESKTOP_SESSION now
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 07 Jul 2011 16:15:23 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu5) oneiric; urgency=low
+
+  * debian/patches/090_run_gtk_init.patch:
+    - run gtk_init_check in compiz core (needed for unity and unity dialogs, and
+      there is no good upgrade story with the current backend to add a new
+      plugin)
+  * debian/control:
+    - add a libgtk-3-dev dep
+    - breaks against previous unity version (gtk_init should run be once with
+      ldopen)
+    - bump standards-version
+  * debian/compiz-gnome.gconf-defaults, debian/unity.ini:
+    - add unity dialogs by default (doesn't support upgrade though, need to
+      reset the profile manually)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 04 Jul 2011 18:33:26 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu4) oneiric; urgency=low
+
+  * debian/patches/00_bzr_fix_727143.patch:
+    - Fix unity-window-decorator crashes with SIGSEGV when closing Java
+      windows (LP: #727143)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 24 Jun 2011 10:46:01 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu3) oneiric; urgency=low
+
+  * Separate plugins we install by default from others:
+    - create compiz-plugins-default which is a subpart of what compiz-plugins
+      depended on
+    - compiz-plugins install compiz-plugins-default
+    - compiz, compiz-core, compiz-gnome, compiz-kde now depends on
+      compiz-plugins-default and recommends compiz-plugins-main-default
+    - compiz-dev still depends on compiz-plugins as shipping the compiztoolbox
+      and cube headers
+    - reshuffle the replaces to handle transitions
+  * move /usr/share/compiz/kde.xml wrongly set in compiz-plugins to compiz-kde
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 07 Jun 2011 14:01:18 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu2) oneiric; urgency=low
+
+  * debian/rules, debian/compiz-gnome.install:
+    - generate g-c-c keybindings from new metacity package
+    - don't generate schema for gconf bindings, not sure we will ship them or
+      should switch to gsettings
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 06 Jun 2011 17:58:54 +0200
+
+compiz (1:0.9.4+bzr20110606-0ubuntu1) oneiric; urgency=low
+
+  * New bug fix release:
+    - Switcher window borders are not properly unmapped with
+      (unity|gtk)-window-decorator (LP: #789580)
+    - maximized window is displaced (LP: #772612)
+    - Unity launcher gets visible while screensaver is active (LP: #771391)
+    - 1 pixel icons in notification-area-applet when compiz is the windows
+      manager (LP: #767095)
+  * debian/patches/00_bzr_fix_apps_without_startupid.patch:
+    - removed: upstream
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 06 Jun 2011 16:18:08 +0200
+
+compiz (1:0.9.4+bzr20110415-0ubuntu2) natty; urgency=low
+
+  * debian/patches/00_bzr_fix_apps_without_startupid.patch:
+    - from upstream trunk, fix crash on applications removing _NET_STARTUP_ID
+      (LP: #759363)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 19 Apr 2011 11:40:43 +0200
+
+compiz (1:0.9.4+bzr20110415-0ubuntu1) natty; urgency=low
+
+  * New upstream snapshot
+    - Focus problem with Thunderbird (LP: #753951)
+    - Chromium fullscreen + Alt-TAB confuses the launcher (LP: #757434)
+    - compiz hangs randomly several times per day (LP: #740126)
+  * debian/patches/00_*:
+    - removed as part of upstream tarball
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 15 Apr 2011 17:08:40 +0200
+
+compiz (1:0.9.4+bzr20110411-0ubuntu2) natty; urgency=low
+
+  * 00_bzr_fix_crash_with_some_apps.patch
+    - Fix inkscape/unison and other applications crashes (LP: #758307)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 14 Apr 2011 14:37:39 +0200
+
+compiz (1:0.9.4+bzr20110411-0ubuntu1) natty; urgency=low
+
+  * New upstream snapshot, including all 01_bzr* patch:
+    - compiz crashed with SIGSEGV in PluginClassHandler<DecorWindow, CompWindow,
+      0>::get() (LP: #743807)
+    - Animation for Grid Previews is broken (LP: #754088)
+    - Grid plugin: Maximizing a window from left or right edge loses original
+      size (LP: #753051)
+  * add 00_remove_printf.patch: remove debug printf
+  * 02_add_debug_spewer_for_apport.patch:
+    - refreshed
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 11 Apr 2011 13:25:14 +0200
+
+compiz (1:0.9.4+bzr20110407-0ubuntu2) natty; urgency=low
+
+  * New upstream snapshot:
+    - fix unity-window-decorator crashed with SIGSEGV in event_filter_funct
+      (LP: #711561)
+  * debian/patches/086_new_grid_defaults.patch:
+    - change threshold to 15 on sides and 20 on top to work well with the new
+      animtion
+  * debian/patches/01_bzr_fix_grid_on_multimonitor.patch,
+    01_bzr_fix_resize.patch, 01_bzr_fix_grid_premultiply.patch:
+    - from upstream bzr, fix grid on multimonitor and colors handling
+  * debian/patches/086_new_grid_defaults.patch,
+    debian/patches/029_default_options.patch:
+    - set the resize grid shadow to orange (LP: #752711)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 07 Apr 2011 18:06:44 +0200
+
+compiz (1:0.9.4+bzr20110406-0ubuntu1) natty; urgency=low
+
+  * new upstream bzr tarball:
+    - display/size problems with xterm (LP: #748137)
+    - fix crashes on tcl/tk applications (LP: #741074, #747439)
+    - fix grab on compose keys (LP: #747323)
+    - resync stack at regular interval to avoid invisible windows
+      (LP: #723014, #743011, #736876, #740465, #684590)
+    - fix weird order in alt + tab (LP: #175874)
+    - fix crash in gitk (LP: #743011, #741074)
+    - avoid compiz detection by fglrx driver (LP: #740298)
+    - Wrong window moves (LP: #741656, #743634)
+    - Unity Grid is broken for multi-monitor setups (LP: #709221)
+    - Feature Freeze Exception: Animation for Grid Plugin Previews (LP: #744104)
+    - unity-window-decorator crashed with SIGSEGV in gdk_window_get_events()
+      (LP: #725284)
+    - fix xterm (LP: #692463)
+    - start the decorator on a secondary screen (LP: #730495)
+  * debian/patches/090_git_fix_new_invisible_windows.patch,
+    debian/patches/100_bump_core.h.patch:
+    - upstreamed
+  * debian/patches/01_unity_window_decorator.patch
+    debian/patches/085_add_grid_plugin.patch:
+    - in bzr upstream tarball
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 06 Apr 2011 19:37:45 +0200
+
+compiz (1:0.9.4git20110322-0ubuntu5) natty; urgency=low
+
+  * debian/patches/080_fix_session_handling.patch:
+    reverted, seems to break more people that it fixes it. Not commited to
+    compiz trunk as well
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 24 Mar 2011 12:03:47 +0100
+
+compiz (1:0.9.4git20110322-0ubuntu4) natty; urgency=low
+
+  * 080_fix_session_handling.patch:
+    - fix respawn on crash (LP: #716462)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 23 Mar 2011 23:38:35 +0100
+
+compiz (1:0.9.4git20110322-0ubuntu3) natty; urgency=low
+
+  * 90_git_fix_new_invisible_windows.patch:
+    from git, fix a case with new invisible windows (LP: #741072)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 23 Mar 2011 17:36:06 +0100
+
+compiz (1:0.9.4git20110322-0ubuntu2) natty; urgency=low
+
+  * debian/patches/01_unity_window_decorator.patch:
+    - fix frequent crash (LP: #740480)
+  * debian/compiz-decorator:
+    - reset the unity window decorator by default 
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 23 Mar 2011 08:55:46 +0100
+
+compiz (1:0.9.4git20110322-0ubuntu1) natty; urgency=low
+
+  * New upstream bug fix snapshot:
+    - Application windows can sometimes fail to display and will
+      mask regions of the screen (LP: #709461)
+    - Compiz switcher Alt-Tab order is not predictable - should
+      maintain LIFO ordering in application switcher (LP: #175874)
+    - after compiz crashed, gnome-panel isn't mapped again (LP: #711378)
+    - invisible windows border problem (LP: #710271)
+    - Compiz thinks you are clicking in an edge window when you
+      are not (LP: #734250)
+    - Add test case for invisible window regressions (LP: #736876)
+    - often can't alt-click-dnd to move the focussed dialog (LP: #711911)
+    - When windows open for the first time they should not hide (LP: #723878)
+    - Unity Grid is broken for multi-monitor setups (LP: #709221)
+    - Pixmaps trashed during animations when window is unmapped (LP: #733331)
+    - Windows have blank decorations when rapidly closing and
+      reopening (LP: #733328)
+    - Unity is not restored on unity/compiz crash: compiz doesn't register
+      properly with gnome-session (LP: #716462)
+  * remove the patch taken from upstream
+  * refresh u-w-d patch with latest upstream work
+  * debian/compiz-core.install:
+    - image move to the final destination
+  * debian/patches/100_bump_core.h.patch:
+    - bump for ABI breakage
+  * debian/compiz-decorator:
+    - use gtk-window-decorator and not unity-window-decorator as it's really
+      crashy for now (will probably redo an upload tomorrow with a fixed
+      decorator)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 22 Mar 2011 21:45:34 +0100
+
+compiz (1:0.9.4-0ubuntu7) natty; urgency=low
+
+  * debian/control:
+    - breaks on old simple-ccsm until a new one for 0.9 is available
+  * debian/patches/029_default_options.patch: 
+    - don't enable showing desktop while scale is triggered (LP: #736947)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 17 Mar 2011 17:13:32 +0100
+
+compiz (1:0.9.4-0ubuntu5) natty; urgency=low
+
+  * debian/patches/029_default_options.patch: (LP: #723273)
+    - remove Super W change for the "Initiate Window Picker for current
+       workspace". The default is now compiz default: Shift + Alt + Up
+    - transforming the Super A change to Super W for "Initiate Window Picker
+      For All Windows"
+  * debian/compiz-gnome.gconf-defaults:
+    - disable Alt + F1/F2 in the gnome-compat plugin for the unity profile only
+      (those keys are handled by unity itself now)
+  * debian/source_compiz.py:
+    - add xorg info in case of crash
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 16 Mar 2011 19:28:01 +0100
+
+compiz (1:0.9.4-0ubuntu4) natty; urgency=low
+
+  * Fix crashes in unity-window-decorator
+    (LP: #724874, #728563, #728383)
+  * Fix grid plugin not working with snap (LP: #716313)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 07 Mar 2011 16:31:04 +0100
+
+compiz (1:0.9.4-0ubuntu3) natty; urgency=low
+
+  * debian/rules:
+    - don't run unitymtgrabhandles and unityshell by default
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 01 Mar 2011 13:31:32 +0100
+
+compiz (1:0.9.4-0ubuntu2) natty; urgency=low
+
+  * Force libdecoration0 to have the same version than compiz-plugins
+  * debian/patches/01_unity_window_decorator.patch
+    - fix a crash in unity-window-decorator (LP: #726063, #725284, #726101)
+  * Backport some patches from upstream to fix other crashes and bring
+    support to the unity plugin (LP: #726702)
+  * debian/compiz-core.install:
+    png are now installed in /usr/share/compiz
+  * add the future unity mt plugin by default
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 28 Feb 2011 20:51:00 +0100
+
+compiz (1:0.9.4-0ubuntu1) natty; urgency=low
+
+  * New upstream release:
+    - Fix no windows receiving the focus if someone got the focus then was
+      destroyed
+    - Fix crash when resizing using keybindings
+    - Fix unresponsive inactive decorations (LP: #703755) 
+    - Fix the long awaited gconf crash (LP: #691561)
+    - gtk-window-decorator doesn't respect special decoration styles
+      (LP: #290835)
+  * debian/compiz-core.links,
+    debian/source_compiz.py,
+    debian/compiz-core.install:
+    - install again a richer apport hook to redirect nux/libunity/unityshell
+      crash. It also asks the user to redirect unity issues against unity (still
+      incuding xorg info when needed)
+  * Removed a bunch of patches either cherry-picked or pushed upstream. With the
+    other fixes, the gconf workaround is hopefully not needed anymore.
+  * refresh existing patches to still apply
+  * debian/control:
+    - rename dep on compiz-fusion* to compiz*
+  * debian/patches/085_add_grid_plugin.patch:
+    - refresh the grid plugin from new release
+  * debian/patches/086_new_grid_defaults.patch
+    - separate tweaking the default settings to only have the effect that were
+      specified:
+      top -> maximize, left (top or bottom left) -> window half left of the
+      screen, right (top or bottom right) -> window half right of the screen,
+      bottom -> do nothing
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 24 Feb 2011 17:31:29 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu11) natty; urgency=low
+
+  * debian/patches/18_really_fix_stacking_issues.patch:
+    - hopefully, this time, the invisible window is dead (LP: #709461)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 11 Feb 2011 13:00:01 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu10) natty; urgency=low
+
+  * debian/patches/080_migrate_gconf_from_alpha1.patch
+    debian/reset-compiz-gconf, debian/compiz-gnome.install:
+    - remove the additional python wrapper now that people who installed
+      alpha1 are considerated to be transitionned to the new schema.
+  * debian/patches/17_fix_stacking_issue.patch:
+    - backport from upstream. This seems to fix the random invisible window
+      (LP: #709461)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 08 Feb 2011 10:31:06 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu9) natty; urgency=low
+
+  * debian/patches/086_fix_unreachable_options_crash.patch:
+    getOptions is broken at start as some initialized options aren't map when
+    calling from the core. Use direct call instead (LP: #708812).
+    Fixes crashes at start.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 02 Feb 2011 15:17:02 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu8) natty; urgency=low
+
+  * debian/patches/14_fix_empathy_list_vanish.patch:
+    - fix the buddy list disappearing (LP: #682781)
+  * debian/patchs/15_hidden_maximized_decoration.patch:
+    - fix sometimes invisible decoration on maximized window still decorated
+  * 16_display_unfocused_state.patch:
+    - fix unfocused state not being displayed properly in the decoration
+      (LP: #704413)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 31 Jan 2011 15:50:17 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu7) natty; urgency=low
+
+  * debian/patches/000_workaround_gconfbackend_init_hang.patch:
+    - readd the workaround. Seems that slow machines really have a problem with
+      the new init order
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 28 Jan 2011 19:07:35 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu6) natty; urgency=low
+
+  * debian/control:
+    - compiz-gnome replaces compiz-fusion-plugins-extra (grid gconf schema file
+      is hosted there) (LP: #708835)
+  * debian/patches/029_default_options.patch:
+    - set the spacing to 68 temporary as a workaround to avoid the spread mode
+      to overlap the launcher (LP: #702822)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 28 Jan 2011 15:46:20 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu5) natty; urgency=low
+
+  * debian/patches/000_workaround_gconfbackend_init_hang.patch:
+    - remove the workaround (commented in debian/patches/series). It seems to
+      work for others without it, I still have it hanging there, but maybe
+      that's a system issue, let's see if people reports hangs at start.
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - adapt to new version
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 27 Jan 2011 17:42:04 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu4) natty; urgency=low
+
+  * debian/patches/000_fix_stacking.patch:
+    - so awaited patch to fix menu stacking issue
+      (LP: #693073, #695638, #690461) (congrats smspillaz)
+  * debian/patches/065_add_bailer_and_detection_plugins.patch:
+    - remove zenity message, now handled in the session level
+  * debian/patches/029_default_options.patch:
+    - set back to opacity to 100 when dragging windows, seems to have a lot of
+      perf issues on some graphic card. (LP: #703458)
+  * debian/patches/03_git_fix_maprequest.patch
+    debian/patches/04_git_fix_override_redirect_window.patch
+    debian/patches/06_git_fix_unmapped_then_remapped_window.patch
+    debian/patches/07_git_fix_click_to_focus_issue.patch
+    debian/patches/08_make_qt_wine_appearing.patch
+    debian/patches/09_git_valgrind_cleanage.patch
+    debian/patches/10_git_set_vp_before_window_initialization.patch:
+    - misc fixes backported from upstream git head. Fixing flash and gnome-panel
+      crash (LP: #683100, #690461)
+  * debian/patches/000_workaround_gconfbackend_init_hang.patch:
+    - adapt to new version
+  * debian/patches/029_default_options.patch:
+    - disable ligthning by default on the opengl plugin as it's not really used
+      and conflict with unity (LP: #703140)
+  * debian/patches/11_git_fix_windows_jumping.patch
+    debian/patches/12_fix_warning.patch
+    debian/patches/13_fix_window_geometries_and_properties.patch:
+    - last minute fix due to regression introduced by the patch above, fix wrong
+      geometry and wrong startup position (LP: #707853, #707852)
+  * debian/patches/085_add_grid_plugin.patch,
+    debian/rules, debian/control, debian/unity.ini,
+    debian/compiz-gnome.gconf-defaults
+    - add to main (as upstream is doing in the git repository) the grid plugin
+      and activate it by default. Replaces the -extra package with a previous
+      version
+    - tweak the default settings to only have the effect that were specified:
+      top -> maximize, left (top or bottom left) -> window half left of the
+      screen, right (top or bottom right) -> window half right of the screen
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 27 Jan 2011 13:05:18 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu3) natty; urgency=low
+
+  * debian/patches/01_unity_window_decorator.patch:
+    - dont dep on system libdecoration but on built one
+  * debian/control:
+    - remove circular build-dep on libdecoration0-dev
+    - build against new libmetacity ABI
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 19 Jan 2011 17:52:09 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu2) natty; urgency=low
+
+  * debian/control:
+    - temporary depends on libdecoration0-dev as the unity-window-decorator
+      needs it. The correct fix will need to shuffle the order of build around
+      and take the current library.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 14 Jan 2011 03:17:38 +0100
+
+compiz (1:0.9.2.1+glibmainloop4-0ubuntu1) natty; urgency=low
+
+  [ Didier Roche ]
+  * New upstream release:
+    - Fixed a high number of wakeups (LP: #681696)
+    - Fixed links not working in some gtk windows
+    - Raise the window when it is moved if raise on click is enabled
+    - Fix crash when loading plugins on the command line
+    - Fix focus issues on window close and reopen rapidly
+    - Fix focus issues with multiple X screens
+    - Glib plugin removed
+    - Fix bug where not moving the mouse and clicking button 2 or 3 in
+      scale addon would close the current active window, not the window the
+      mouse hovers over
+    - Add unity-window-decorator
+    - Move window doesn't raise window (LP: #695570)
+    - gtk.Label <a href> link-activate signal broken with compiz in natty
+      (LP: #687732)
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - remove GNOME failsafe detection as now handled as a session type in
+      gnome-session
+  * Remove deprecated or now merge upstream patches:
+    - 01_backport_trunk_fix.patch
+    - 002_ship_splited_gconf_cmakeext_files.patch
+    - 004_packagemode_is_release_debug_for_plugins.patch
+    - 005_no_glib_plugin.patch
+    - 017_always_unredirect_screensaver_on_nvidia.patch
+    - 080_migrate_gconf_from_alpha1.patch
+  * debian/compiz-gnome.gconf-defaults,
+    debian/patches/029_default_options.patch:
+    - new settings for natty. Also set the 2x2 layout by default
+  * unity-decorator:
+    - debian/compiz-decorator:
+      launch unity-compiz-decorator in gnome sessions
+    - debian/compiz-gnome.install:
+      install it
+    - debian/control:
+      depends on latest metacity having the right extension
+    - debian/patches/01_unity_window_decorator.patch:
+      add unity-window-decorator
+  * debian/patches/02_add_debug_spewer_for_apport.patch:
+    - new plugin (not activated for now) to get additional info for apport
+
+  [ Bryce Harrington ]
+  * compiz-core.install, compiz-core.links, source_compiz.py:
+    Replace the compiz apport hook with a link to xorg's apport script.
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 13 Jan 2011 21:50:27 +0100
+
+compiz (1:0.9.2.1+glibmainloop3-0ubuntu5) natty; urgency=low
+
+  * Restore the workaround to avoid crashes (lp: #691561)
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Fri, 17 Dec 2010 21:08:43 +0100
+
+compiz (1:0.9.2.1+glibmainloop3-0ubuntu4) natty; urgency=low
+
+  * debian/patches/000_workaround_gconfbackend_init_hang.patch:
+    - drop the workaround, the issue has not been confirmed but the update
+      broke the menus in unity (lp: #690461)
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - adapted regarding previous patch
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Thu, 16 Dec 2010 22:19:50 +0100
+
+compiz (1:0.9.2.1+glibmainloop3-0ubuntu3) natty; urgency=low
+
+  * debian/patches/080_migrate_gconf_from_alpha1.patch,
+  debian/reset-compiz-gconf,
+  debian/compiz-gnome.install:
+  - temporary wrapper from new gconf path not transitionned from alpha1
+    (allscreens became screen0). This will reset the current compiz profiles
+    (LP: #690011)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 14 Dec 2010 19:25:03 +0100
+
+compiz (1:0.9.2.1+glibmainloop3-0ubuntu2) natty; urgency=low
+
+  * debian/patches/000_workaround_gconfbackend_init_hang.patch:
+    - workaround in delaying the plugin init as the gconf backend hangs when
+      trying to contact/launch the gconf daemon. This only happens when you
+      don't change your current profile, at session start.
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - adapted regarding previous patch
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 14 Dec 2010 02:57:50 +0100
+
+compiz (1:0.9.2.1+glibmainloop3-0ubuntu1) natty; urgency=low
+
+  * new glibmainloop branch snapshot:
+    - fix launching an application set it to the wrong place (LP: #683273)
+    - Can't resize windows to be displayed on several monitors (LP: #455378)
+    - Scale All Windows gets its suffixes wrong for a 3x3 layout (LP: #683063)
+    - Compiz sometimes loses focus when closing some windows (LP: #671459)
+    - Fix hanging when session exit (LP: #683121)
+  * debian/patches/000_fix_OOo_crash1.patch
+    debian/patches/000_fix_OOo_crash2.patch
+    debian/patches/001_fix_gconf_path.patch
+    debian/patches/003_more_gconf_parser_fix.patch:
+   - remove, upstreamed.
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - adapt to new version
+  * debian/patches/01_backport_trunk_fix.patch:
+    - backport some additional fixes from trunk, otherwise compiz crash at start
+  * debian/source_compiz.py:
+    - fix gconf path
+  * debian/compiz-gnome.gconf-defaults, debian/rules, debian/unity.ini,
+    debian/patches/030_no_fade_in_staticswicher.patch:
+    - change order to load fade before staticswichter to avoid the fade effect
+      when alt + tabbing (LP: #683635)
+    - add snap and workarounds by default as well
+  * debian/compiz-gnome.gconf-defaults,
+    debian/compiz-keybindings.sed,
+    debian/patches/021_hide_tooltip_on_decorator.patch,
+    debian/patches/057_update_gnome_bindings.patch:
+    - update the gconf path from allscreens to screen0 as new gconf path in the
+      gconf backend
+  * debian/control:
+    - handle the ABI breakage with other compiz components
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 13 Dec 2010 16:38:10 +0100
+
+compiz (1:0.9.2.1+glibmainloop2-0ubuntu4) natty; urgency=low
+
+  * debian/patches/065_add_bailer_and_detection_plugins.patch:
+    - fix the fallback not launching gnome-panel when no 3D support
+      (LP: #683356, #683531)
+  * debian/patches/000_fix_OOo_crash{1,2].patch:
+    - cherry-pick fix crashes with random applications (LP: #675506)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 01 Dec 2010 13:10:41 +0100
+
+compiz (1:0.9.2.1+glibmainloop2-0ubuntu3) natty; urgency=low
+
+  * debian/rules:
+    - use our own keybindings with new Compiz wm_name
+      (note, upstream one faily try to install them ignoring DESTDIR, keep in
+       mind when fixed to keep ours)
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 29 Nov 2010 19:37:41 +0100
+
+compiz (1:0.9.2.1+glibmainloop2-0ubuntu2) natty; urgency=low
+
+  * debian/rules:
+    - build with RelWithDebInfo cmake flag to get debug info and release
+      optimisation
+  * debian/patches/004_packagemode_is_release_debug_for_plugins.patch:
+    - when compiz plugin built in "Package" mode, add optimization + debug
+      symbols for stripping in dbgsym. Thanks RAOF for pointing at it
+      (LP: #682574)
+  * debian/patches/005_no_glib_plugin.patch:
+    - remove glib plugin as conflicting with the glibmainloop branch
+  * debian/source_compiz.py:
+    - grab new gconf path in apport bug report
+
+ -- Didier Roche <didrocks@ubuntu.com>  Mon, 29 Nov 2010 12:23:15 +0100
+
+compiz (1:0.9.2.1+glibmainloop2-0ubuntu1) natty; urgency=low
+
+  * new upstream snapshot with glibmm experimental branch:
+    - Compiz crashes when scrolling in Openoffice (LP: #675506)
+    - Compiz sometimes loses focus when closing some windows (LP: #671459)
+    - Fix --replace hang (LP: #680165)
+  * debian/65compiz_profile-on-session:
+    - add unity profile to default session
+  * debian/rules:
+    - add bailer, detection, regex and animation and fade plugin to both
+      profiles
+    - get an optimized plugin default order
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - start stripping it down as now we have a detection and bailer plugins
+      for that. The failsafe session should be moved in the detection plugin.
+  * debian/patches/055_fix_COMPIZ_DEFAULT_PLUGINS.patch,
+    debian/patches/056_Preserve-DESTDIR-if-no-override-in-COMPIZ_DESTDIR.patch
+    debian/patches/057_update_gnome_bindings.patch:
+    - removed, upstreamed
+  * debian/patches/065_add_bailer_and_detection_plugins.patch:
+    - add bailer and detection plugins to fallback to 2D session or run in
+      degraded mode.
+  * debian/compiz-gnome.install, debian/unity.ini,
+    debian/compiz-gnome.gconf-defaults:
+    - add the unity profile to ini and gconf backend
+  * debian/patches/001_fix_gconf_path.patch:
+    - fix the path when generating the gconf keys (compiz-1)
+  * debian/patches/002_ship_splited_gconf_cmakeext_files.patch:
+    - ship and link the splited gconf extension schema builder
+  * debian/control:
+    - add libglibmm-2.4-dev build-dep and to -dev dep
+  * debian/patches/003_more_gconf_parser_fix.patch:
+    - fix parser breakage with some plugins
+
+ -- Didier Roche <didrocks@ubuntu.com>  Fri, 26 Nov 2010 20:30:56 +0100
+
+compiz (1:0.9.2.1+glibmainloop-0ubuntu3) natty; urgency=low
+
+  * debian/rules:
+    - add gnomecompat as a default plugin (LP: #675774)
+    - add vpswitch too
+  * debian/libdecoration0.symbols:
+    - add a symbol file
+  * debian/patches/057_update_gnome_bindings.patch:
+    - update wmname to get the keybindings shown in GNOME capplet
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 18 Nov 2010 14:35:04 +0100
+
+compiz (1:0.9.2.1+glibmainloop-0ubuntu2) natty; urgency=low
+
+  * debian/patches/065_glib_mainloop.patch:
+    - removed as part of make dist
+  * debian/control:
+    - make compiz-dev dep on libglib2.0-dev
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 11 Nov 2010 21:52:26 +0100
+
+compiz (1:0.9.2.1+glibmainloop-0ubuntu1) natty; urgency=low
+
+  * New upstream snapshot with glib mainloop support needed for unity compiz
+  * debian/rules:
+    - use the ezoom plugin rather than the zoom one
+  * debian/patches/055_fix_COMPIZ_DEFAULT_PLUGINS.patch,
+    debian/patches/056_Preserve-DESTDIR-if-no-override-in-COMPIZ_DESTDIR.patch:
+    - refresh to new upstream snapshot
+
+ -- Didier Roche <didrocks@ubuntu.com>  Thu, 11 Nov 2010 18:20:59 +0100
+
+compiz (1:0.9.2.1-0ubuntu2) natty; urgency=low
+
+  * debian/control:
+    - add missing replaces with latest natty version
+
+ -- Didier Roche <didrocks@ubuntu.com>  Wed, 10 Nov 2010 10:40:29 +0100
+
+compiz (1:0.9.2.1-0ubuntu1) natty; urgency=low
+
+  [ Travis Watkins ]
+  * debian/patches/010-disable-child-window-clipping.patch,
+    debian/patches/013-add-cursor-theme-support.patch,
+    debian/patches/016_call_glxwaitx_before_drawing.patch,
+    debian/patches/035_ignore_workspaces,
+    debian/patches/037_fullscreen_stacking_fixes.patch,
+    debian/patches/061_KWD_stubs.patch,
+    debian/patches/090_profiling,
+    - removed as they are applied upstream or obsolete
+  * debian/patches/017_always_unredirect_screensaver_on_nvidia.patch
+    debian/patches/018_use_metacity_settings.patch
+    debian/patches/021_hide_tooltip_on_decorator.patch
+    debian/patches/029_default_options
+    debian/patches/060_move_checks_to_compiz.patch
+    - updated for 0.9 and added DEP-3 comments
+  * comment debian/patches/014_fix-no-border-window-shadow.patch
+  * debian/kde4-window-decorator.1:
+    - renamed kde-window-decorator.1 with name fixups
+  * debian/compiz-decorator.1,
+    debian/compiz-core.manpages:
+    - add compiz-decorator manpage
+  * debian/compiz.1,
+    debian/kde4-window-decorator.1:
+    - refreshed
+  * debian/compiz-decorator:
+    - remove support for kde-window-decorator as it no longer exists
+  * debian/compiz-gnome.gconf-defaults:
+    - strip down to just gtk-window-decorator defaults, we set the rest in
+      other places already
+  * debian/rules:
+    - switch to debhelper 7 style rules, much easier to understand
+  * debian/control:
+    - add cmake and boost build-depends, remove automake
+
+  [ Didier Roche ]
+  * new upstream release
+  * remerge and adapt travis' work to latest release in natty
+  * debian/patches/029_default_options.patch:
+    - retake latest patch and refresh to new version
+  * debian/patches/060_move_checks_to_compiz.patch:
+    - remove all plugins and not use the DEFAULT plugin list (just load cpp)
+  * debian/compiz-gnome.gconf-defaults:
+    - keep some needed value. With gsetting port, we should only push default,
+      don't be evil and avoid patching the schema
+  * debian/control:
+     - bump all dep to 0.9 for compiz components
+     - add libboost-serialization1.42-dev build-dep
+     - add some sanity check as well (lintian warnings)
+     - additional dependency on compiz-plugins from compiz-dev
+  * debian/patches/015_optional-fbo.patch:
+    - removed as the new version doesn't seem to handle that natively
+  * debian/patches/014-fix-gtk-window-decorator-no-argb-crash.patch:
+    - removed as seems to be upstreamed
+  * debian/patches/015_draw_dock_shadows_on_desktop.patch:
+    - removed from now, let's revert to upstream behavior
+  * debian/patches/020_disable_gdk_gtk_disable_deprecated:
+    - removed, upstream
+  * disable debian/patches/021_hide_tooltip_on_decorator.patch for now
+  * debian/compiz-core.install,debian/compiz-dev.install,
+    debian/compiz-gnome.install:
+    - changed the path according to new upstream layout and remove some
+      libraries and re-ad /usr/share/gnome/wm-properties/compiz.desktop to
+      make the gnome-window-properties work again (LP: #269805)
+    - compiz-gnome install gconf schemas, not compiz-plugins
+    - also some cleanage to make things easier to read
+  * debian/compiz-kde.manpages:
+    - adapt to kde4 new manpage
+  * convert to quilt format
+  * remove debian/patches/562027-fix-gconf-ftbfs.patch,
+     debian/patches/635258-fix-pixmap-size-calculations.patch,
+     debian/patches/111_link-kde-window-decorator-with-x11:
+    - not relevant in the context
+  * debian/compiz-kde.install, debian/compiz-plugins.install:
+    - put likde in compiz-kde package
+  * debian/rules:
+    - a lot of cleanage, try to make the rule easy to read
+    - force to build in release mode
+    - compile the default plugins list
+    - force copying to cmake install dir. Don't use findcompiz_install which is
+      broken upstream when using DESTDIR and COMPIZ_DESTDIR
+    - add some switch to ensure we build in package mode not in debug one
+  * add debian/patches/055_fix_COMPIZ_DEFAULT_PLUGINS.patch:
+    - use COMPIZ_DEFAULT_PLUGINS from debian/rules
+  * debian/patches/056_Preserve-DESTDIR-if-no-override-in-COMPIZ_DESTDIR.patch:
+    - make compiz respect env variable
+  * debian/patches/065_glib_mainloop.patch:
+    - added but not activated yet: need some work with tip of compiz 0.9.2.1
+
+ -- Didier Roche <didrocks@ubuntu.com>  Tue, 19 Oct 2010 12:23:51 +0200
+
+compiz (1:0.8.6-0ubuntu12) natty; urgency=low
+
+  * Merge patch 110_link-gtk-windows-decorator-with-xcursor into
+    013-add-cursor-theme-support as that's where the bug was introduced.
+  * Remove bogus dh_install -pcompiz-wrapper call in rules leaving a
+    debhelper.log over; presumably left over from the removal of this package.
+
+ -- Loïc Minier <loic.minier@ubuntu.com>  Mon, 18 Oct 2010 00:13:28 +0200
+
+compiz (1:0.8.6-0ubuntu11) natty; urgency=low
+
+  * New patch, 110_link-gtk-windows-decorator-with-xcursor, fix configure.ac
+    to require the xcursor pkg-config file/libs etc. for gtk/window-decorator
+    which calls XcursorSetTheme(); fixes FTBFS.
+  * New patch, 111_link-kde-window-decorator-with-x11, fix configure.ac to
+    require the x11 pkg-config file/libs etc. for kde/window-decorator which
+    calls XGetWMProtocols(); fixes FTBFS.
+
+ -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 17 Oct 2010 23:19:57 +0200
+
+compiz (1:0.8.6-0ubuntu10) natty; urgency=low
+
+  * New patch, 635258-fix-pixmap-size-calculations, from commit
+    0f95c41a0aa175ddf7947ba18b01f746c95594a9 in the 0.8 branch; thanks
+    Paul Donohue; LP: #635258.
+
+ -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 17 Oct 2010 22:02:58 +0200
+
+compiz (1:0.8.6-0ubuntu9) maverick; urgency=low
+
+  * debian/compiz-gnome.gconf-defaults: /apps/gwd/metacity_theme_opacity
+    is a float (1.0), not int (1).
+
+ -- Anders Kaseorg <andersk@mit.edu>  Fri, 24 Sep 2010 21:09:32 -0400
+
+compiz (1:0.8.6-0ubuntu8) maverick; urgency=low
+
+  * debian/compiz-gnome.gconf-defaults
+    - move the shadow 4 pixels down, in order to reduce the shadow between 
+      menubaritems and the menu frame (LP: #634417)
+
+  * debian/patches/029_default_options.patch
+    - get rid of the transparency on the unfocused window frame. (LP: #634417)
+
+ -- Ken VanDine <ken.vandine@canonical.com>  Tue, 21 Sep 2010 16:59:27 -0400
+
+compiz (1:0.8.6-0ubuntu7) maverick; urgency=low
+
+  * 060_move_checks_to_compiz.patch: Remove Sandybridge bridge devices from
+    the blacklist, they were preventing compiz from loading on machines
+    with discreet GPU's as well. (LP: #644372)
+
+ -- Robert Hooker <robert.hooker@canonical.com>  Tue, 21 Sep 2010 09:46:36 -0400
+
+compiz (1:0.8.6-0ubuntu6) maverick; urgency=low
+
+  * Update 060_move_checks_to_compiz.patch to add Intel Sandybridge pci id's
+    to the blacklist, the mesa dri driver claims it instead of swrast so 
+    compiz tries to use it but does not work currently. (LP: #633376)
+
+ -- Robert Hooker <robert.hooker@canonical.com>  Wed, 08 Sep 2010 13:10:11 -0400
+
+compiz (1:0.8.6-0ubuntu5) maverick; urgency=low
+
+  * Fix LP: #622195 - dh_install can't rename files. In trying to do so,
+    compiz-wm.desktop is installed one folder too deep, breaking
+    gnome-{appearance,window}-properties
+    - update debian/compiz-gnome.install
+
+ -- Chris Coulson <chris.coulson@canonical.com>  Thu, 26 Aug 2010 21:33:53 +0100
+
+compiz (1:0.8.6-0ubuntu4) maverick; urgency=low
+
+  * debian/control: Argh, also reduce the libcompizconfig0 dependency to the
+    version that actually rebuilt against 0.8.6.
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 03 Aug 2010 10:40:30 +0200
+
+compiz (1:0.8.6-0ubuntu3) maverick; urgency=low
+
+  * debian/control: Reduce libcompizconfig0 breaks to << the version that
+    actually rebuilt against 0.8.6.
+
+ -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 03 Aug 2010 00:13:46 +0200
+
+compiz (1:0.8.6-0ubuntu2) maverick; urgency=low
+
+  * control: Don't build-depends on libdbus-qt-1-dev, it's deprecated
+
+ -- Sebastien Bacher <seb128@ubuntu.com>  Mon, 02 Aug 2010 17:49:08 +0200
+
+compiz (1:0.8.6-0ubuntu1) maverick; urgency=low
+
+  * New upstream release:
+    - Maintenance release.
+    - Various focus and window placement fixes.
+    - Fixed handling of windows that have a (server-drawn) border.
+    - Fixed handling of window icons that have a colour depth of 1 bit.
+    - Added KDE 4.4 support to KDE4 window decorator.
+  * debian/control:
+    - Build-depend on libx11-dev, libxext-dev
+  * debian/patches/020_fix_focus.patch:
+  * debian/patches/030_from_git_crash_fix_multiscreen.patch:
+  * debian/patches/031_from_git_fix_gnome_keybindings.patch:
+  * debian/patches/070_remove_deprecated_gtk_symbol.patch:
+    - Applied upstream
+
+ -- Robert Ancell <robert.ancell@canonical.com>  Tue, 27 Jul 2010 17:23:05 +0200
+
+compiz (1:0.8.4-4ubuntu1) maverick; urgency=low
+
+  * Merge with Debian unstable, remaining Ubuntu changes:
+  * debian/control:
+    - Build-depend on cdbs for strip-schemas
+    - Add version on libmetacity-dev build-depend
+    - Add KDE build-depends
+    - Add metacity-common build-depends (for getting keybindings)
+    - Add gnome-control-center-dev build-depends (may not be required)
+    - Add libx11-xcb-dev build-depend
+    - Add Vcs-Bzr link
+    - compiz provides x-window-manager
+    - compiz-core does not provide mesa-utils
+    - compiz-core breaks old version of compiz-fusion-plugins-main and
+      compiz-fusion-plugins-extra
+    - compiz-core replaces old compiz-wrapper
+    - compiz-dev depends on libx11-xcb-dev
+    - compiz-gnome and compiz-kde depend on compiz-plugins and their backends
+  * debian/rules:
+    - Compile a subset of the plugins
+    - Do not build the kconfig plugin (in favior of libcompizconfig)
+    - Build with --enable-gconf
+    - Build translations/language packs
+    - Install compiz-decorator wrapper
+    - Install apport hook
+    - Copy keybindings from metacity
+    - Exclude some files from compiz-plugins
+  * debian/compiz-core.install:
+    - Don't install plugin files
+    - Install apport hooks
+  * debian/compiz-decorator:
+    - Script to run the appropriate decorator for the current session
+  * debian/compiz-dev.install:
+    - Install XSLT file
+  * debian/compiz-gtk.*:
+    - Not required, merged into compiz-gnome
+  * debian/compiz-gnome.gconf-defaults:
+    - Set Ubuntu defaults
+  * debian/compiz-gnome.install:
+    - Rename wm-properties desktop file, don't know why
+    - Install gnome-control-center keybindings files
+    - Add files from compiz-gtk
+  * debian/compiz-gnome.manpages:
+    - Add files from compiz-gtk
+  * debian/compiz-keybindings.sed:
+    - Script to add keybindings
+  * debian/compiz-plugins.install:
+    - Install XML files for the plugins
+  * debian/source_compiz.py:
+    - Apport hook
+  * debian/patches/012_snap-by-default.patch:
+    - Not enabled, not sure if we want this in Ubuntu
+  * debian/patches/021_hide_tooltip_on_decorator.patch:
+    - Make decorator tooltips optional
+  * debian/patches/029_default_options.patch:
+    - Updated with additional changes over Debian
+  * debian/patches/090_profiling.patch:
+    - Timing profiling patch (disabled)
+  * debian/watch:
+    - Update download location
+
+ -- Robert Ancell <robert.ancell@canonical.com>  Thu, 17 Jun 2010 10:12:18 +1000
+
+compiz (0.8.4-4) unstable; urgency=low
+
+  * Drop libdbus-qt-1-dev from Build-Depends, as kindly requested by
+    Michael Biebl (Closes: #581788). Qt3 is going away, we already use
+    --disable-kde and --enable-kde4 to that effect, so libdbus-qt-1-dev
+    can be kicked away.
+  * Add libglu1-mesa-dev, needed for <GL/glu.h>.
+
+ -- Cyril Brulebois <kibi@debian.org>  Sun, 16 May 2010 20:44:51 +0200
+
+compiz (0.8.4-3) unstable; urgency=high
+
+  [ Brice Goglin ]
+  * Remove Thierry Reding from Uploaders, closes: #572540.
+
+  [ Cyril Brulebois ]
+  * Add patch to prevent FTBFS due to deprecated GDK/GTK stuff:
+    * 020_disable_gdk_gtk_disable_deprecated (Closes: #577352).
+  * Add myself to Uploaders.
+  * Set urgency to high due to RC bugfix.
+
+ -- Cyril Brulebois <kibi@debian.org>  Thu, 15 Apr 2010 03:29:29 +0200
+
+compiz (0.8.4-2) unstable; urgency=low
+
+  * Bump the dh_makeshlibs call to (>= 0.8.4)
+
+ -- Sean Finney <seanius@debian.org>  Thu, 11 Feb 2010 23:08:16 +0100
+
+compiz (0.8.4-1) unstable; urgency=low
+
+  * New upstream release.
+
+  [ Sean Finney ]
+  * Fix FTBFS: "gconf/gconf-client.h: No such file or directory"
+    - thanks to Sebastian Harl <tokkee@debian.org> (Closes: #562027, #562438) 
+  * Add compiz-decorator symlink for compatibility with ubuntu systems.
+  * Make all patches DEP-3 formatted.
+  * No longer keep the ubuntu patches logically separated from ours
+  * Enable 010-disable-child-window-clipping.patch, as there's an ABI bump.
+    Also, massage the patch a little so that it applies cleanly.
+  * Synchronize ubuntu patches from 0.8.4-0ubuntu10
+    * 015_draw_dock_shadows_on_desktop.patch:
+      - change decoration plugin to draw dock shadows only on the
+        desktop window instead of on top of all other windows
+    * 016_call_glxwaitx_before_drawing.patch:
+      - Call glXWaitX before we start drawing to make sure X is done
+        handling rendering calls. Suggested by Michel Dänzer to ensure
+        we don't have any rendering glitches.
+    * 017_always_unredirect_screensaver_on_nvidia.patch:
+      - always unredirect gnome-screensaver when using nvidia, workaround
+        for LP #160264 while still disabling unredirect fullscreen
+        windows for nvidia users
+    * 020_fix_focus.patch:
+      - give back the focus to the previous focused window (LP: #455900)
+    * 030_from_git_crash_fix_multiscreen.patch:
+      - merge commit 24dea72a395071b533dcf66b2eef37b20522cbba to fix
+        crash with wobbly windows in a multi screen setup
+    * 031_from_git_fix_gnome_keybindings.patch:
+      - fix gnome keybindings (terminal key)
+    * 060_move_checks_to_compiz.patch:
+      - add all relevant checks from compiz-manager to compiz itself
+        Compiz already checks for almost everything it needs so there is no
+        need to check twice.
+    * 061_KWD_stubs.patch (updated locally to remove fuzz):
+      - Horrible hack to define empty stubs for some new pure virtual
+        functions in KWD::Window, to fix FTBFS.
+  * The following patches have been updated to cleanly apply:
+    * 014-fix-gtk-window-decorator-no-argb-crash.patch
+    * 015_optional-fbo.patch
+    * ubuntu/010-disable-child-window-clipping.patch
+    * ubuntu/013-add-cursor-theme-support.patch
+    * ubuntu/018_use_metacity_settings.patch
+    * ubuntu/029_default_options
+    * ubuntu/035_ignore_workspaces
+    * ubuntu/037_fullscreen_stacking_fixes.patch
+    * ubuntu/049-damage-report-non-empty.patch
+    * ubuntu/050_stacking.patch
+  * Transition from compiz-manager to compiz binary for /usr/bin/compiz
+  * Remove all patches to the embedded compiz-manager script
+    * 028_compiz_manager_blacklist
+    * 029_compiz_manager_decoration.patch
+    * 029_compiz_manager_nvidia_settings.patch
+    * 030_compiz_manager_multi_display
+    * 031_compiz_manager_extra_blacklist_support
+    * 032_compiz_manager_add_gnomecompat
+    * 033_compiz_manager_xdg_dirs
+    * 042-compiz-manager-default-plugin
+    * 046_compiz_manager_second_screen.patch
+
+ -- Sean Finney <seanius@debian.org>  Thu, 11 Feb 2010 20:17:39 +0100
+
+compiz (0.8.2-6) unstable; urgency=low
+
+  * Add libxcursor-dev build-dep as required by patch
+    ubuntu/013-add-cursor-theme-support; also let compiz-dev pull it as it's
+    referenced in the .pc file; closes: #525240, #524943.
+  * Add a virtual compiz-core-abiversion-2009xxyy provides to compiz-core to
+    allow for strict dependencies of plugins on the compiz-core
+    CORE_ABIVERSION they were built with, as read from include/compiz-core.h.
+  * Use the new Breaks feature for the compiz-core -> libcompizconfig0 dep.
+    This makes upgrades smoother than Conflicts.
+  * Bump the compiz-core Breaks on libcompizconfig0 to 0.8.0 as the last
+    CORE_ABIVERSION bump happened between 0.7.8 and 0.8.0; closes: #523514.
+  * Add a missing libxml2-dev build-dep and update the compiz-dev deps to
+    match what compiz.pc requires and use the same versions as the build-deps.
+  * Build-dep on libcairo2-dev instead of libcairo-dev.
+  * Add missing libstartup-notification0-dev (>= 0.7) bdep and version the
+    compiz-dev dep to match.
+  * Use the same version in the libdecoration0-dev dep on libxrender-dev as
+    in the libxrender-dev bdep.
+
+ -- Loic Minier <lool@dooz.org>  Fri, 24 Apr 2009 15:15:24 +0200
+
+compiz (0.8.2-5) unstable; urgency=low
+
+  * remove obsolete --enable-gconf-dump configure option
+  * add build-dependency on libgnomeui-dev to fix new FTBFS (Closes: #524446)
+  * add Vcs-Git and Vcs-Browser headers to debian/control
+
+ -- Sean Finney <seanius@debian.org>  Sun, 19 Apr 2009 18:45:39 +0200
+
+compiz (0.8.2-4) unstable; urgency=low
+
+  * disable child window clipping patch: it breaks the abi
+
+ -- Sean Finney <seanius@debian.org>  Sat, 11 Apr 2009 18:55:35 +0200
+
+compiz (0.8.2-3) unstable; urgency=low
+
+  * import of some ubuntu patches for 0.8.2 with some modifications
+    - see debian/patches/ubuntu for patches
+    - see debian/patches/series for which patches are used and which
+      are not.
+    - includes patch to copy gnome/metacity keyboard shortcuts
+      (Closes: #503442, #454922).
+
+ -- Sean Finney <seanius@debian.org>  Sat, 11 Apr 2009 14:26:06 +0200
+
+compiz (0.8.2-2) unstable; urgency=low
+
+  * upgrading compiz-manager backed out some locally modified but not
+    quilt-using changes in paths.  so, new patch compiz-debian-paths.patch
+    should fix this (closes: #522985).
+
+ -- Sean Finney <seanius@debian.org>  Wed, 08 Apr 2009 23:13:19 +0200
+
+compiz (0.8.2-1) unstable; urgency=low
+
+  * new upstream release.
+  * update location of compiz-gnome desktop file
+  * add new app desktop file for compiz to compiz-core
+  * update build-deps to use kdebase-workspace-dev
+  * add build-dep on libxslt1-dev
+  * disable kde3 decorator and enable kde4 decorator
+  * include a gbp.conf for use with git-buildpackage
+  * bump the libdecoration0 shlibs version to 0.8.2
+  * update compiz-manager to upstream's 223180bf
+  * Obsolete patches now removed:
+    - disable-libx11-xcb-support.patch
+    - xscreensaver-damage-fix.patch
+    - compiz-manager-posixly-correct.patch
+  * Lintian fixes: 
+    - update Standards-Version to 3.8.1
+    - add misc:Depends to compiz
+
+ -- Sean Finney <seanius@debian.org>  Wed, 01 Apr 2009 00:00:10 +0200
+
+compiz (0.7.6-8) unstable; urgency=low
+
+  * Don't run glib-gettextize, to fix FTBFS caused by intltoolize changes
+    (closes: #518909).
+  * Rebuild against new metacity (closes: #518910).
+
+ -- Julien Cristau <jcristau@debian.org>  Mon, 09 Mar 2009 18:44:13 +0100
+
+compiz (0.7.6-7) unstable; urgency=medium
+
+  * refresh quilt patches to apply with no fuzz/offsets. 
+  * add fglrx driver to compiz-manager whitelist (closes: #495539).
+
+ -- Sean Finney <seanius@debian.org>  Mon, 01 Sep 2008 08:00:56 +0200
+
+compiz (0.7.6-6) unstable; urgency=high
+
+  * backport commit aed97c441881d9c382c7865d0305fc8f884c10ac to fix the 
+    problems that seem to come up with certain xscreensavers the Right Way.
+    (closes: #483170).
+
+ -- Sean Finney <seanius@debian.org>  Sat, 30 Aug 2008 11:39:17 +0200
+
+compiz (0.7.6-5) unstable; urgency=high
+
+  * Brown paper bag: remove shlibs.local and libdecoration0.shlibs, call
+    dh_makeshlibs with the proper flags to actually fix dependencies on
+    libdecoration0.
+
+ -- Julien Cristau <jcristau@debian.org>  Fri, 01 Aug 2008 18:57:30 +0200
+
+compiz (0.7.6-4) unstable; urgency=low
+
+  [ Julien Cristau ]
+  * Bump libdecoration0 shlibs to >= 0.7.6 (closes: #485775).
+
+  [ Sean Finney ]
+  * Include fix for posixly-incorrect usage of ENV (closes: #484225).
+
+ -- Julien Cristau <jcristau@debian.org>  Sat, 26 Jul 2008 21:44:51 +0200
+
+compiz (0.7.6-3) unstable; urgency=high
+
+  * Add a versioned Replaces on older compiz-plugins to compiz-gtk, to prevent
+    file conflicts.  Thanks to Daniel Burrows for the report (closes: #485436).
+
+ -- Sean Finney <seanius@debian.org>  Mon, 09 Jun 2008 18:39:57 +0200
+
+compiz (0.7.6-2) unstable; urgency=low
+
+  * Add Conflicts against xscreensaver-data-extra as an unfortunately
+    heavy handed workaround to prevent graphical lockups with an as-of-yet
+    unknown bug somewhere in the screensaver-compiz-driver-xserver chain.
+    (See: #483170, and other bugs/urls referenced in that report)
+
+ -- Sean Finney <seanius@debian.org>  Sat, 07 Jun 2008 14:22:15 +0200
+
+compiz (0.7.6-1) unstable; urgency=low
+
+  * New upstream release
+
+  [ Sean Finney ]
+  * Special-case the gconf and kconfig plugins to go into the -gtk and -kde
+    packages respectively, as they are semi-obsoleted by the ccp plugin anyway
+    and cause potentially problematic dependencies.  Thanks to Fabiano 
+    Manoel de Andrade for the report (closes: #482150).
+  * Add versioned Conflicts on libcompizconfig0 to compiz-core, to reflect
+    ABI breakage without introducing a circular dependency.  Thanks
+    to Mike Hommey for the report (closes: #482646).
+  * Make debian/rules stricter about catching uninstalled files.
+  * Make debian/rules able to build/clean/build again.
+  * Misc cleanups in debian/rules.
+  * Lintian fixes:
+    - Spelling correction in debian/control
+    - Fix for build-depends-on-1-revision for x11proto-gl-dev
+
+  [ Julien Cristau ]
+  * Add Depends: libxslt1-dev, libxml2-dev to compiz-dev, as they are required
+    by compiz.pc (closes: #482192).
+
+ -- Sean Finney <seanius@debian.org>  Mon, 26 May 2008 23:04:24 +0200
+
+compiz (0.7.4-1) unstable; urgency=low
+
+  * New upstream release
+  * Incorporate xcb-disabling patch from
+    http://gitweb.opencompositing.org/?p=users/3v1n0/compiz-patches
+
+ -- Sean Finney <seanius@debian.org>  Sun, 18 May 2008 19:15:13 +0200
+
+compiz (0.6.3~git20080115.0ea58487-1) unstable; urgency=low
+
+  * New upstream (git snapshot) release.  Refreshed quilt patches.
+  * Contains upstream fix for kde-window-decorator problems with not properly
+    mapping/rendering titlebars.  closes: #458464, #460186.
+  * Remove timestamps from quilt patches (package maintainers, you 
+    should put QUILT_NO_DIFF_TIMESTAMPS=1 in your ~/.quiltrc).
+  * add compizconfig-settings-manager to Suggests field for compiz.
+  * don't blindly assume that the nvidia-settings program is present.
+    patch: compiz-manager-nvidia-settings-optional.patch.  closes: #463645.
+
+ -- sean finney <seanius@debian.org>  Tue, 26 Feb 2008 20:08:31 +0100
+
+compiz (0.6.3~git20071222.061ff159-1) unstable; urgency=low
+
+  * New upstream (git snapshot) release.  Refreshed quilt patches.
+  * Remove build-dependency on libfuse-dev, since we explicitly disable the
+    fuse plugin and it causes FTBFS on non-linux arches.  It should also make
+    backporting easier (closes: #451149, #455516).
+  * compiz-manager-posixly-correct.patch: fix from Brian Carlson to get
+    compiz-manager to run when POSIXLY_CORRECT is set (always pass
+    options before arguments closes: #456628).
+  * Remove libmetacity entry from shlibs override (closes: #455515) Thanks to
+    Rober Millan for noticing this.
+  * Remove outdated info in README.Debian for compiz-core (closes: #454340).
+  * lintian:
+    - Standards-Version to 3.7.3
+    - libdecoration0-dev to section libdevel
+
+ -- Sean Finney <seanius@debian.org>  Sat, 22 Dec 2007 12:01:54 +0100
+
+compiz (0.6.3~git20071208.25941d14-1) unstable; urgency=low
+
+  [Sean Finney]
+  * New upstream (git snapshot) release.
+  * Remove autofoo generated content and create/remove it as part of the
+    standard build process instead.
+  * Similarly, add Build-Deps on autoconf and similar stuff.
+  * Remove the old/buggy compiz.wrapper script and now use Kristian Lyngstol's
+    compiz-manager script as a drop-in replacement for it.  This should fix
+    numerous problems with plugin settings and window decorators not behaving
+    properly.  specifically, it closes: #449389, #390929, #400583, #440095.
+    it also closes: #446901, #447345 closes: #393501, #445026.  
+  * Update copyright file accordingly.
+
+ -- Sean Finney <seanius@debian.org>  Sun, 16 Dec 2007 17:29:03 +0100
+
+compiz (0.6.3~git20071104.c9009efd-1) unstable; urgency=low
+
+  [Sean Finney]
+  * New upstream (git snapshot) release.
+  * Disable the (unused?) fuse plugin, explicitly enable the gconf plugin
+  * lintian: update FSF address
+
+  [Brice Goglin]
+  * Make compiz dependencies on compiz-* packages versioned,
+    closes: #440494.
+  * Make the build-dependency on libfuse-dev require >= 2.7.0.
+
+ -- Sean Finney <seanius@debian.org>  Sun, 04 Nov 2007 21:20:17 +0100
+
+compiz (0.5.2-2) unstable; urgency=low
+
+  * oops, shipping copies of a few .h and .pc files in both compiz-dev
+    and libdecoration0-dev.  fixed.
+
+ -- sean finney <seanius@debian.org>  Wed, 29 Aug 2007 21:06:29 +0200
+
+compiz (0.5.2-1) unstable; urgency=low
+
+  * New upstream release.
+  * updated/massaged various quilt patches
+  * make sure configure is executable at build time.  seems that this
+    causes problems in a pbuilder environment
+  * new build-dependencies on libxml-parser-perl and xsltproc
+  * modify compiz-dev.install to install all the extra .h/.pc files
+    being generated in this new version.
+
+ -- sean finney <seanius@debian.org>  Wed, 22 Aug 2007 22:58:09 -0700
+
+compiz (0.5.0.dfsg-3) UNRELEASED; urgency=low
+
+  * Restore all ${misc:Depends} in debian/control so that for instance
+    compiz-gtk and compiz-plugins gets the required dependency on gconf2
+    (for gconf-schemas in postinst), closes: #436432.
+
+ -- Brice Goglin <bgoglin@debian.org>  Tue, 07 Aug 2007 15:10:49 +0200
+
+compiz (0.5.0.dfsg-2) unstable; urgency=low
+
+  * Drop the now obsolete Source-Version in favour of binary:Version in
+    debian/control.
+  * Replace --strict-binding and --use-cow documentation by --loose-binding
+    and --use-root-window respectively in the compiz.real manpage. Thanks
+    Michael Gilbert. (Closes: 432920)
+  * Rearrange and add missing command-line options in the compiz.real manpage.
+  * compiz-gtk needs to conflict with libmetacity0 (<< 1:2.15.21) because of
+    an incompatible ABI change. This should really be fixed in libmetacity. A
+    shlibs bump should do the trick. (Closes: 425631)
+  * Add upstream patch that fixes non-tfp textures (icons, cube top image
+    etc.) on big endian platforms. Thanks Michel Dänzer.
+  * Run dh_makeshlibs with -V. (Closes: 425463)
+  * Use package-local shlibs override file to depend on libmetacity0 (>=
+    1:2.15.21) and libdecoration0 (>= 0.5.0). Thanks Sune Vuorela.
+
+ -- Thierry Reding <thierry@gilfi.de>  Fri, 13 Jul 2007 11:25:13 +0200
+
+compiz (0.5.0.dfsg-1) unstable; urgency=low
+
+  [ Thierry Reding ]
+  * New upstream development release:
+    - Remove stencil buffer requirement.
+    - Focus stealing prevention support.
+    - Better occlusion detection and more efficient rendering.
+    - Added plugins:
+      + blur: blur windows and contents behind translucent windows
+      + fuse: map compiz options to a file-system
+      + ini: flat file configuration backend
+      + inotify: file change notification
+      + video: composited video interface for efficient playback
+  * Forward-port patches:
+    - Dropped 012_debian-kde-includes-dir.patch, no longer needed.
+    - Dropped 013_set-qtdir-fallback.patch, no longer needed.
+    - Refresh other patches.
+  * Use compiz' default set of plugins.
+  * Add build-dependency on libfuse-dev needed by the fuse plugin.
+  * No longer conflict with metacity >= 2.15.21, now that metacity 2.18 is in
+    unstable. (Closes: #411012)
+  * Add symlink to the compiz-core README to the compiz package.
+    (Closes: #408605)
+  * Drop po/*.gmo and kde/window-decorator/*.moc.cpp from the original
+    tarball. Add a note to debian/copyright.
+  * Pass QTDIR=/usr to the configure script so that the moc can be found.
+  * shlibs bump for libdecoration because it contains added symbols.
+    Thanks Julien Cristau.
+
+  [ Julien Cristau ]
+  * Don't remove .cvsignore files and autogen.sh in clean.
+
+ -- Thierry Reding <thierry@gilfi.de>  Sat, 19 May 2007 17:34:51 +0200
+
+compiz (0.3.6-1) experimental; urgency=low
+
+  [ Thierry Reding ]
+  * New upstream release:
+    + Drop 002_tfp-server-extension.patch, obsolete.
+    + Drop 005_glfinish.patch, fixed upstream.
+    + Refresh 011_snap-by-default.patch.
+  * Replace build-dependency on libdbus-1-dev by libdbus-glib-1-dev.
+  * Add build-dependency on kdebase-dev and libdbus-qt-1-dev for the KDE
+    window decorator.
+  * Add patch 012_debian-kde-includes-dir to correctly detect the KDE include
+    directory on Debian systems.
+  * Add patch 013_set-qtdir-fallback to set the QTDIR variable to /usr if it
+    has not explicitly been set before. This allows the configure script to
+    correctly detect the moc compiler.
+  * Add the compiz-kde package which provides a window decorator for KDE.
+    Closes: #390338.
+  * Add the libdecoration0 and libdecoration0-dev packages. libdecoration0 is
+    needed by both Gtk and KDE window decorators while libdecoration0-dev can
+    be used to write additional decorators.
+  * Add patch 015_optional-fbo which adds a command-line option for disabling
+    the use of FBOs (work around buggy drivers). Add the --no-fbo option to
+    command-line in the compiz wrapper.
+  * Remove the --strict-binding and --use-cow options from the command-line in
+    the compiz wrapper. These are now the defaults.
+  * Add png and svg to the list of default plugins. They are needed to load
+    PNG and SVG images (e.g. for the cube's top face).
+  * Check whether the GLX_EXT_texture_from_pixmap extension is available in
+    direct or indirect rendering contexts. If it is available only in indirect
+    rendering contexts, force compiz to use indirect rendering.
+
+ -- David Nusinow <dnusinow@debian.org>  Wed, 17 Jan 2007 23:46:34 -0500
+
+compiz (0.3.4-1) experimental; urgency=low
+
+  * New upstream release:
+    + Drop 012_metacity-theme-support.patch, fixed upstream.
+    + Drop 013_fix-default-plugins.patch, fixed upstream.
+    + Refresh all other patches.
+  * Don't use xsfbs anymore until there's an easy way to keep it up-to-date
+    in git repositories. For now using quilt works just fine.
+  * Drop build-dependencies on automake1.9 and libtool because we don't run
+    the complete autotools stack anymore.
+  * Add missing dependencies to the compiz-dev package. It needs to pull in
+    all packages required by its pkgconfig file.
+  * Add a dependency on libgl1-mesa-dev | libgl-dev to compiz-dev because
+    compiz.h includes files provided in that package.
+
+ -- Thierry Reding <thierry@gilfi.de>  Sun, 26 Nov 2006 00:36:39 +0100
+
+
+compiz (0.3.2-1) experimental; urgency=low
+
+  * New upstream release. Closes: #396770.
+    + Remove 010_snap-inverted.patch, applied upstream.
+    + Refreshed other patches to apply cleanly again.
+    + Remove gtk-window-decorator.schemas and use the one provided by
+      upstream (gtk/window-decorator/gwd.schemas).
+  * Targetted at experimental until the release of etch.
+
+ -- Thierry Reding <thierry@gilfi.de>  Tue, 14 Nov 2006 02:36:40 +0100
+
+compiz (0.2.2-1) unstable; urgency=low
+
+  [ Thierry Reding ]
+  * New upstream release:
+    + Drop 013_dont-fail-if-theme-not-found.patch, applied upstream.
+  * Make 012_metacity-theme-support also patch the configure script, not only
+    configure.ac.
+  * Add 013_fix-default-plugins.patch which fixes upstream's handling of the
+    default plugins configuration variable.
+  * Make all plugins that were enabled in previous versions default plugins so
+    compiz' behaviour doesn't change. Drop the 'water' plugin because our X
+    server does not support it yet.
+  * Drop --disable-kde from the configure flags because it is now disabled by
+    default.
+  * Add a dependency on mesa-utils to compiz-core to provide glxinfo that is
+    needed by the compiz wrapper. Thanks Per Bojsen.
+    Closes: #393113.
+  * Conflict with libmetacity0 (>= 1:2.15.21) because it would currently make
+    gtk-window-decorator segfault.
+
+  [ David Nusinow ]
+  * Add myself to uploaders. Thierry is still the primary maintainer.
+
+ -- David Nusinow <dnusinow@debian.org>  Mon,  6 Nov 2006 23:13:41 -0500
+
+compiz (0.2.0-1) unstable; urgency=low
+
+  [ Thierry Reding ]
+  * New upstream release.
+    + Drop 011_plane-plugin-schema.patch, applied upstream.
+    + Drop 012_freedesktop-schema.patch, applied upstream.
+  * Replace 010_snap-by-default by the upstream patch 010_snap-inverted and
+    add 011_snap-by-default to enable snapping by default.
+  * Add 012_metacity-theme-support.patch which uses an older version of the
+    metacity library for theme support so that compiz can be built for Debian
+    unstable.
+  * Install a schemas file for the Gtk window decorator which is used to
+    enable the use of metacity themes.
+  * Suggest nvidia-glx (>= 1.0.9625-1). (Closes: #390326).
+  * Add code to the compiz wrapper to handle the NVIDIA GLX implementation
+    Closes: #390814.
+  * No longer build static versions of the plugins.
+  * Remove .la files manually because they are not needed.
+  * Clean up build-dependencies:
+    + Remove unnecessarily versioned build-dependencies.
+    + Tighten the build-dependency on libxcomposite-dev to (>= 1:0.3-2).
+      Closes: 390304, 390416.
+  * Add a manpage documenting the compiz wrapper.
+  * Check if the gconf plugin is installed before trying to load it in the
+    wrapper.
+  * Enable building the gconf-dump plugin.
+  * Add a README file to the compiz-core package.
+  * List copyright holders and contributors in the copyright file.
+    Closes: #392422.
+  * Add 013_dont-fail-if-theme-not-found.patch which will make compiz use its
+    default theme if the metacity theme cannot be found.
+  * Make compiz-gtk suggest gnome-themes so people can take advantage of the
+    metacity theme support.
+
+  [ David Nusinow ]
+  * Tighten up all the X library build-depends by explicitly using current
+    versions. Thanks aj.
+
+ -- David Nusinow <dnusinow@debian.org>  Fri, 13 Oct 2006 16:22:17 -0400
+
+compiz (0.0.13+git20060928-2) unstable; urgency=low
+
+  * Change the maintainer field to the Debian X Strike Force.
+  * Add myself to the uploaders field.
+  * Move compiz.{docs,install,manpages} to compiz-core.{docs,install,manpages}
+    so the installed files end up in the correct package.
+  * Rename compiz.1 to compiz.real.1, because it's actually documenting the
+    real compiz binary.
+
+ -- Thierry Reding <thierry@gilfi.de>  Fri, 29 Sep 2006 09:24:30 +0200
+
+compiz (0.0.13+git20060928-1) unstable; urgency=low
+
+  * Initial release. (Closes: #352151)
+  * Install the compiz schema during postinst and removes it during prerm
+    (using dh_gconf).
+  * Add patches by Kristian Høgsberg to make compiz work on AIGLX:
+    + 002_tfp-server-extension.patch
+    + 005_glfinish.patch
+  * No longer build the compiz-kde package, because it is unusable.
+  * Add gtk-window-decorator.1 manpage.
+  * Install the window settings configuration plugin into the right location
+    (/usr/lib/libgnome-window-settings1/libcompiz.so).
+  * Bump build-dependency on libxcomposite-dev (>= 0.3) because it provides
+    the XComposite{Get,Release}OverlayWindow functions.
+  * Install a compiz wrapper as /usr/bin/compiz to call compiz.real with
+    required arguments (load gconf plugin).
+  * Add 010_snap-by-default.patch to turn snapping on by default.
+  * Add a versioned build-dependency on x11proto-gl-dev (>= 1.4.8-1) to make
+    sure compiz gets built with the correct opcodes for the GLX_EXT_tfp
+    extension.
+  * Add build-dependency on libmetacity-dev, which is needed for metacity
+    theme support.
+  * Add the compiz-gtk package containing the former gnome-window-decorator.
+    The compiz-gnome package provides the files necessary to integrate compiz
+    and compiz-gtk with the GNOME desktop environment.
+  * Add a build-dependency on libxinerama-dev, needed to build compiz with
+    support for the xinerama extension.
+  * Revise the compiz.1 manpage.
+  * Rename the compiz package to compiz-core and make compiz a meta-package
+    pulling in everything necessary to run compiz from within GNOME.
+  * Add 011_plane-plugin-schema.patch by Eugene Konev      gconf settings
+    for the plane plugin.
+  * Add 012_freedesktop-schema.patch that fixes a typo in compiz.schema.in.
+
+ -- Thierry Reding <thierry@gilfi.de>  Fri, 29 Sep 2006 07:56:05 +0200
+

=== added file 'debian/compat'
--- debian/compat	1970-01-01 00:00:00 +0000
+++ debian/compat	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+9

=== added file 'debian/compiz-core.README.Debian'
--- debian/compiz-core.README.Debian	1970-01-01 00:00:00 +0000
+++ debian/compiz-core.README.Debian	2012-06-19 11:22:48 +0000
@@ -0,0 +1,36 @@
+Xorg Server Configuration
+=========================
+
+In order for compiz to work you need to add the following to you server
+configuration file (/etc/X11/xorg.conf):
+
+  + Enable the composite extension: locate the section named "Extensions" and
+    add the following line:
+
+        Option "Composite" "enable"
+
+    If there is no section "Extensions" yet, you should add one that looks
+    like this:
+
+        Section "Extensions"
+            Option "Composite" "enable"
+        EndSection
+
+  + Make XAA not hold any pixmaps in offscreen memory. This slows down compiz
+    in many configurations. You can disable this by adding the following line
+    to your "Device" section:
+
+        Option "XAANoOffscreenPixmaps" "true"
+
+Now restart your X server and login to your favorite session. After the
+session has loaded completely, open a terminal window and type the following
+command:
+
+    $ compiz --replace &
+
+Which will start compiz, make it replace the current window manager and
+background the process so you can safely close the terminal again. If all went
+well, compiz should start up and enable a whole bunch of desktop effects.
+
+ -- Thierry Reding <thierry@gilfi.de>  Tue,  3 Oct 2006 14:12:26 +0200
+

=== added file 'debian/compiz-core.docs'
--- debian/compiz-core.docs	1970-01-01 00:00:00 +0000
+++ debian/compiz-core.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/compiz-core.install'
--- debian/compiz-core.install	1970-01-01 00:00:00 +0000
+++ debian/compiz-core.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,8 @@
+debian/tmp/usr/bin/compiz*
+debian/tmp/usr/lib/libcompiz_core.so.*
+debian/tmp/usr/share/compiz/cube/images/*.png
+debian/tmp/usr/share/compiz/*.png
+debian/tmp/usr/share/compiz/core.xml
+debian/source_compiz.py usr/share/apport/package-hooks
+debian/tmp/usr/share/locale
+debian/tmp/usr/share/applications/compiz.desktop

=== added file 'debian/compiz-core.lintian-overrides'
--- debian/compiz-core.lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/compiz-core.lintian-overrides	2012-07-12 11:08:19 +0000
@@ -0,0 +1,2 @@
+compiz-core: package-name-doesnt-match-sonames libcompiz-coreABI-20120603
+compiz-core: binary-without-manpage usr/bin/compiz-decorator

=== added file 'debian/compiz-core.manpages'
--- debian/compiz-core.manpages	1970-01-01 00:00:00 +0000
+++ debian/compiz-core.manpages	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+debian/compiz.1

=== added file 'debian/compiz-dev.docs'
--- debian/compiz-dev.docs	1970-01-01 00:00:00 +0000
+++ debian/compiz-dev.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/compiz-dev.install'
--- debian/compiz-dev.install	1970-01-01 00:00:00 +0000
+++ debian/compiz-dev.install	2012-09-10 13:45:36 +0000
@@ -0,0 +1,16 @@
+debian/tmp/usr/include/compiz/[!d]*
+debian/tmp/usr/lib/libcompiz_core.so
+debian/tmp/usr/lib/pkgconfig/compiz-animation.pc
+debian/tmp/usr/lib/pkgconfig/compiz-compiztoolbox.pc
+debian/tmp/usr/lib/pkgconfig/compiz-composite.pc
+debian/tmp/usr/lib/pkgconfig/compiz-cube.pc
+debian/tmp/usr/lib/pkgconfig/compiz-mousepoll.pc
+debian/tmp/usr/lib/pkgconfig/compiz-opengl.pc
+debian/tmp/usr/lib/pkgconfig/compiz.pc
+debian/tmp/usr/lib/pkgconfig/compiz-scale.pc
+debian/tmp/usr/lib/pkgconfig/compiz-text.pc
+debian/tmp/usr/share/compiz/xslt
+debian/tmp/usr/share/cmake*/FindCompiz.cmake
+debian/tmp/usr/share/cmake*/Modules/FindCompiz.cmake
+debian/tmp/usr/share/cmake*/FindOpenGLES2.cmake 
+debian/tmp/usr/share/compiz/cmake

=== added file 'debian/compiz-gnome.docs'
--- debian/compiz-gnome.docs	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/compiz-gnome.gconf-defaults'
--- debian/compiz-gnome.gconf-defaults	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.gconf-defaults	2012-06-19 11:22:48 +0000
@@ -0,0 +1,10 @@
+/apps/compiz-1/plugins/move/screen0/options/constrain_y                true
+/apps/compiz-1/general/screen0/options/hsize				2
+/apps/compiz-1/general/screen0/options/vsize				2
+/apps/gwd/blur_type							all
+/apps/gwd/metacity_theme_opacity					1.0
+/apps/gwd/metacity_theme_shade_opacity					true
+/apps/compizconfig-1/profiles/unity/general/screen0/options/active_plugins [core,composite,opengl,compiztoolbox,decor,vpswitch,snap,mousepoll,resize,place,move,wall,grid,regex,imgpng,session,gnomecompat,animation,fade,unitymtgrabhandles,workarounds,scale,expo,ezoom,unityshell]
+/apps/compizconfig-1/profiles/unity/plugins/gnomecompat/screen0/options/main_menu_key ""
+/apps/compizconfig-1/profiles/unity/plugins/gnomecompat/screen0/options/run_key ""
+/apps/compizconfig-1/profiles/Default/general/screen0/options/active_plugins [core,composite,opengl,compiztoolbox,decor,vpswitch,snap,mousepoll,resize,place,move,wall,grid,regex,imgpng,session,gnomecompat,animation,fade,workarounds,scale,expo,ezoom]

=== added file 'debian/compiz-gnome.gsettings-override'
--- debian/compiz-gnome.gsettings-override	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.gsettings-override	2012-09-20 08:27:40 +0000
@@ -0,0 +1,15 @@
+[org.compiz.core]
+active-plugins=['core','composite','opengl','compiztoolbox','decor','vpswitch','snap','mousepoll','resize','place','move','wall','grid','regex','imgpng','session','gnomecompat','animation','fade','unitymtgrabhandles','workarounds','scale','expo','ezoom','unityshell']
+hsize=2
+vsize=2
+
+[org.compiz.gnomecompat]
+main-menu-key=""
+run-key=""
+
+[org.compiz.move]
+constrain-y=true
+
+[org.compiz.animation]
+unminimize-effects=['animation:Glide 2']
+

=== added file 'debian/compiz-gnome.install'
--- debian/compiz-gnome.install	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.install	2012-09-12 12:48:46 +0000
@@ -0,0 +1,11 @@
+debian/tmp/usr/share/applications/compiz.desktop usr/share/gnome/wm-properties/
+debian/tmp/usr/share/gnome-control-center
+debian/tmp/usr/share/gconf/schemas/*.schemas
+debian/tmp/usr/share/glib-2.0/schemas/*.xml
+debian/tmp/usr/bin/gtk-window-decorator
+debian/65compiz_profile-on-session /etc/X11/Xsession.d
+debian/unity.ini /etc/compizconfig/
+debian/profile_upgrades/*.upgrade etc/compizconfig/upgrades
+debian/tmp/usr/lib/compizconfig/backends/libgsettings.so
+debian/tmp/usr/lib/libcompizconfig_gsettings_backend.so
+postinst/convert-files/*.convert usr/lib/compiz/migration/

=== added file 'debian/compiz-gnome.manpages'
--- debian/compiz-gnome.manpages	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.manpages	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+debian/gtk-window-decorator.1

=== added file 'debian/compiz-gnome.migrations'
--- debian/compiz-gnome.migrations	1970-01-01 00:00:00 +0000
+++ debian/compiz-gnome.migrations	2012-10-17 10:50:45 +0000
@@ -0,0 +1,3 @@
+postinst/migration-scripts/02_migrate_to_gsettings.py
+postinst/migration-scripts/03_migrate_profile_independent.py
+debian/00_remove_unityshell_in_gnome_session.py

=== added file 'debian/compiz-kde.docs'
--- debian/compiz-kde.docs	1970-01-01 00:00:00 +0000
+++ debian/compiz-kde.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/compiz-kde.manpages'
--- debian/compiz-kde.manpages	1970-01-01 00:00:00 +0000
+++ debian/compiz-kde.manpages	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+debian/kde4-window-decorator.1

=== added file 'debian/compiz-plugins-default.install'
--- debian/compiz-plugins-default.install	1970-01-01 00:00:00 +0000
+++ debian/compiz-plugins-default.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,23 @@
+debian/tmp/usr/*/compiz/*animation.*
+debian/tmp/usr/*/compiz/*compiztoolbox.*
+debian/tmp/usr/*/compiz/*composite.*
+debian/tmp/usr/*/compiz/*decor.*
+debian/tmp/usr/*/compiz/*expo.*
+debian/tmp/usr/*/compiz/*ezoom.*
+debian/tmp/usr/*/compiz/*fade.*
+debian/tmp/usr/*/compiz/*gnomecompat.*
+debian/tmp/usr/*/compiz/*grid.*
+debian/tmp/usr/*/compiz/*imgpng.*
+debian/tmp/usr/*/compiz/*mousepoll.*
+debian/tmp/usr/*/compiz/*move.*
+debian/tmp/usr/*/compiz/*opengl.*
+debian/tmp/usr/*/compiz/*place.*
+debian/tmp/usr/*/compiz/*regex.*
+debian/tmp/usr/*/compiz/*resize.*
+debian/tmp/usr/*/compiz/*scale.*
+debian/tmp/usr/*/compiz/*session.*
+debian/tmp/usr/*/compiz/*snap.*
+debian/tmp/usr/*/compiz/*vpswitch.*
+debian/tmp/usr/*/compiz/*wall.*
+debian/tmp/usr/*/compiz/*workarounds.*
+

=== added file 'debian/compiz-plugins.docs'
--- debian/compiz-plugins.docs	1970-01-01 00:00:00 +0000
+++ debian/compiz-plugins.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/compiz-plugins.install'
--- debian/compiz-plugins.install	1970-01-01 00:00:00 +0000
+++ debian/compiz-plugins.install	2012-08-24 13:41:00 +0000
@@ -0,0 +1,51 @@
+debian/tmp/usr/*/compiz/*addhelper.*
+debian/tmp/usr/*/compiz/*annotate.*
+debian/tmp/usr/*/compiz/*bench.*
+debian/tmp/usr/*/compiz/*clone.*
+debian/tmp/usr/*/compiz/*commands.*
+debian/tmp/usr/*/compiz/*copytex.*
+debian/tmp/usr/*/compiz/*crashhandler.*
+debian/tmp/usr/*/compiz/*cube.*
+debian/tmp/usr/*/compiz/*dbus.*
+debian/tmp/usr/*/compiz/*extrawm.*
+debian/tmp/usr/*/compiz/*fadedesktop.*
+debian/tmp/usr/*/compiz/*firepaint.*
+debian/tmp/usr/*/compiz/*imgjpeg.*
+debian/tmp/usr/*/compiz/*imgsvg.*
+debian/tmp/usr/*/compiz/*inotify.*
+debian/tmp/usr/*/compiz/*kdecompat.*
+debian/tmp/usr/*/compiz/*mag.*
+debian/tmp/usr/share/compiz/mag
+debian/tmp/usr/*/compiz/*maximumize.*
+debian/tmp/usr/*/compiz/*mblur.*
+debian/tmp/usr/*/compiz/*neg.*
+debian/tmp/usr/*/compiz/*notification.*
+debian/tmp/usr/share/compiz/notification
+debian/tmp/usr/*/compiz/*obs.*
+debian/tmp/usr/*/compiz/*opacify.*
+debian/tmp/usr/*/compiz/*put.*
+debian/tmp/usr/*/compiz/*resizeinfo.*
+debian/tmp/usr/*/compiz/*ring.*
+debian/tmp/usr/*/compiz/*rotate.*
+debian/tmp/usr/*/compiz/*scaleaddon.*
+debian/tmp/usr/*/compiz/*scalefilter.*
+debian/tmp/usr/*/compiz/*screenshot.*
+debian/tmp/usr/*/compiz/*shelf.*
+debian/tmp/usr/*/compiz/*shift.*
+debian/tmp/usr/*/compiz/*showdesktop.*
+debian/tmp/usr/*/compiz/*showmouse.*
+debian/tmp//usr/share/compiz/showmouse
+debian/tmp/usr/*/compiz/*splash.*
+debian/tmp/usr/share/compiz/splash
+debian/tmp/usr/*/compiz/*showrepaint.*
+debian/tmp/usr/*/compiz/*switcher.*
+debian/tmp/usr/*/compiz/*td.*
+debian/tmp/usr/*/compiz/*text.*
+debian/tmp/usr/*/compiz/*titleinfo.*
+debian/tmp/usr/*/compiz/*trailfocus.*
+debian/tmp/usr/*/compiz/*water.*
+debian/tmp/usr/*/compiz/*widget.*
+debian/tmp/usr/*/compiz/*winrules.*
+debian/tmp/usr/*/compiz/*wobbly.*
+debian/tmp/usr/*/compiz/*workspacenames.*
+

=== added file 'debian/compiz-plugins.install.armel'
--- debian/compiz-plugins.install.armel	1970-01-01 00:00:00 +0000
+++ debian/compiz-plugins.install.armel	2012-08-29 11:56:44 +0000
@@ -0,0 +1,41 @@
+debian/tmp/usr/*/compiz/*addhelper.*
+debian/tmp/usr/*/compiz/*annotate.*
+debian/tmp/usr/*/compiz/*clone.*
+debian/tmp/usr/*/compiz/*commands.*
+debian/tmp/usr/*/compiz/*copytex.*
+debian/tmp/usr/*/compiz/*crashhandler.*
+debian/tmp/usr/*/compiz/*cube.*
+debian/tmp/usr/*/compiz/*dbus.*
+debian/tmp/usr/*/compiz/*extrawm.*
+debian/tmp/usr/*/compiz/*fadedesktop.*
+debian/tmp/usr/*/compiz/*imgjpeg.*
+debian/tmp/usr/*/compiz/*imgsvg.*
+debian/tmp/usr/*/compiz/*inotify.*
+debian/tmp/usr/*/compiz/*kdecompat.*
+debian/tmp/usr/*/compiz/*mag.*
+debian/tmp/usr/share/compiz/mag
+debian/tmp/usr/*/compiz/*maximumize.*
+debian/tmp/usr/*/compiz/*neg.*
+debian/tmp/usr/*/compiz/*notification.*
+debian/tmp/usr/share/compiz/notification
+debian/tmp/usr/*/compiz/*obs.*
+debian/tmp/usr/*/compiz/*opacify.*
+debian/tmp/usr/*/compiz/*put.*
+debian/tmp/usr/*/compiz/*resizeinfo.*
+debian/tmp/usr/*/compiz/*ring.*
+debian/tmp/usr/*/compiz/*rotate.*
+debian/tmp/usr/*/compiz/*scaleaddon.*
+debian/tmp/usr/*/compiz/*scalefilter.*
+debian/tmp/usr/*/compiz/*screenshot.*
+debian/tmp/usr/*/compiz/*shelf.*
+debian/tmp/usr/*/compiz/*shift.*
+debian/tmp/usr/*/compiz/*showdesktop.*
+debian/tmp/usr/*/compiz/*switcher.*
+debian/tmp/usr/*/compiz/*text.*
+debian/tmp/usr/*/compiz/*titleinfo.*
+debian/tmp/usr/*/compiz/*trailfocus.*
+debian/tmp/usr/*/compiz/*water.*
+debian/tmp/usr/*/compiz/*winrules.*
+debian/tmp/usr/*/compiz/*wobbly.*
+debian/tmp/usr/*/compiz/*workspacenames.*
+

=== added file 'debian/compiz-plugins.install.armhf'
--- debian/compiz-plugins.install.armhf	1970-01-01 00:00:00 +0000
+++ debian/compiz-plugins.install.armhf	2012-08-29 11:56:44 +0000
@@ -0,0 +1,41 @@
+debian/tmp/usr/*/compiz/*addhelper.*
+debian/tmp/usr/*/compiz/*annotate.*
+debian/tmp/usr/*/compiz/*clone.*
+debian/tmp/usr/*/compiz/*commands.*
+debian/tmp/usr/*/compiz/*copytex.*
+debian/tmp/usr/*/compiz/*crashhandler.*
+debian/tmp/usr/*/compiz/*cube.*
+debian/tmp/usr/*/compiz/*dbus.*
+debian/tmp/usr/*/compiz/*extrawm.*
+debian/tmp/usr/*/compiz/*fadedesktop.*
+debian/tmp/usr/*/compiz/*imgjpeg.*
+debian/tmp/usr/*/compiz/*imgsvg.*
+debian/tmp/usr/*/compiz/*inotify.*
+debian/tmp/usr/*/compiz/*kdecompat.*
+debian/tmp/usr/*/compiz/*mag.*
+debian/tmp/usr/share/compiz/mag
+debian/tmp/usr/*/compiz/*maximumize.*
+debian/tmp/usr/*/compiz/*neg.*
+debian/tmp/usr/*/compiz/*notification.*
+debian/tmp/usr/share/compiz/notification
+debian/tmp/usr/*/compiz/*obs.*
+debian/tmp/usr/*/compiz/*opacify.*
+debian/tmp/usr/*/compiz/*put.*
+debian/tmp/usr/*/compiz/*resizeinfo.*
+debian/tmp/usr/*/compiz/*ring.*
+debian/tmp/usr/*/compiz/*rotate.*
+debian/tmp/usr/*/compiz/*scaleaddon.*
+debian/tmp/usr/*/compiz/*scalefilter.*
+debian/tmp/usr/*/compiz/*screenshot.*
+debian/tmp/usr/*/compiz/*shelf.*
+debian/tmp/usr/*/compiz/*shift.*
+debian/tmp/usr/*/compiz/*showdesktop.*
+debian/tmp/usr/*/compiz/*switcher.*
+debian/tmp/usr/*/compiz/*text.*
+debian/tmp/usr/*/compiz/*titleinfo.*
+debian/tmp/usr/*/compiz/*trailfocus.*
+debian/tmp/usr/*/compiz/*water.*
+debian/tmp/usr/*/compiz/*winrules.*
+debian/tmp/usr/*/compiz/*wobbly.*
+debian/tmp/usr/*/compiz/*workspacenames.*
+

=== added file 'debian/compiz.1'
--- debian/compiz.1	1970-01-01 00:00:00 +0000
+++ debian/compiz.1	2012-06-19 11:22:48 +0000
@@ -0,0 +1,64 @@
+.TH COMPIZ 1 "September 29, 2006"
+
+.SH NAME
+compiz \- OpenGL window and compositing manager
+
+.SH SYNOPSIS
+.B compiz
+.RI [ options ]
+.RI [ plugins ]
+.SH DESCRIPTION
+.B compiz
+is a compositing window-manager using OpenGL for rendering.
+
+.SH OPTIONS
+.TP
+.B \-\-help
+Show summary of options.
+.TP
+.B \-v, \-\-version
+Show version of program.
+.TP
+.BI "\-\-display " DISPLAY
+Manage the display called
+.I DISPLAY
+instead of the name obtained from the
+.I $DISPLAY
+environment variable.
+.TP
+.BI "\-\-refresh\-rate " RATE
+Set the default refresh rate.
+.TP
+.BI \-\-fast\-filter
+Use a fast texture filter.
+.TP
+.BI \-\-indirect\-rendering
+Force an indirect rendering context. Use this when running compiz on AIGLX.
+.TP
+.BI \-\-strict\-binding
+Enable strict binding of textures. Use this when running compiz on AIGLX.
+.TP
+.BI \-\-use\-cow
+Make use of the composite overlay window.
+.TP
+.BI \-\-replace
+Replace any existing window managers on the given X display.
+.TP
+.BI \-\-sm\-disable
+Disable the session management.
+.TP
+.BI "\-\-sm\-client\-id " ID
+Use the given
+.I ID
+as the client ID for session management.
+.TP
+.BI "\-\-bg\-image " IMAGE
+Use
+.I IMAGE
+as background image.
+
+.SH AUTHOR
+compiz was written by David Reveman <davidr@novell.com> and others.
+.PP
+This manual page was written by Thierry Reding <thierry@gilfi.de>,
+for the Debian project (but may be used by others).

=== added file 'debian/compiz.lintian-overrides'
--- debian/compiz.lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/compiz.lintian-overrides	2012-06-19 11:22:48 +0000
@@ -0,0 +1,2 @@
+compiz: no-debconf-templates
+compiz: postinst-does-not-load-confmodule

=== added file 'debian/compizconfig-settings-manager.install'
--- debian/compizconfig-settings-manager.install	1970-01-01 00:00:00 +0000
+++ debian/compizconfig-settings-manager.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,7 @@
+debian/tmp/usr/bin/ccsm
+debian/tmp/usr/share/applications/ccsm.desktop
+debian/tmp/usr/share/icons/hicolor/*/apps/ccsm.*
+debian/tmp/usr/lib/python*/*/ccm*
+debian/tmp/usr/lib/python2.7/dist-packages/ccsm*
+debian/tmp/usr/share/ccsm
+

=== added file 'debian/compizconfig-settings-manager.manpages'
--- debian/compizconfig-settings-manager.manpages	1970-01-01 00:00:00 +0000
+++ debian/compizconfig-settings-manager.manpages	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+debian/ccsm.1

=== added file 'debian/config'
--- debian/config	1970-01-01 00:00:00 +0000
+++ debian/config	2012-10-17 10:31:42 +0000
@@ -0,0 +1,16 @@
+[general]
+backend = ini
+plugin_list_autosort = true
+
+[gnome_session]
+backend = gsettings
+integration = true
+plugin_list_autosort = true
+profile = Default
+
+[general_ubuntu]
+backend = gsettings
+integration = true
+plugin_list_autosort = true
+profile = unity
+

=== added file 'debian/control'
--- debian/control	1970-01-01 00:00:00 +0000
+++ debian/control	2012-11-05 20:50:59 +0000
@@ -0,0 +1,315 @@
+Source: compiz
+Section: x11
+Priority: optional
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Uploaders: David Nusinow <dnusinow@debian.org>, Sean Finney <seanius@debian.org>, Cyril Brulebois <kibi@debian.org>
+Build-Depends: cmake (>= 2.6),
+               debhelper (>= 9~),
+               dh-migrations,
+               dh-translations,
+               intltool,
+               libtool,
+               pkg-config,
+               quilt (>= 0.40),
+               libcairo2-dev,
+               libdbus-glib-1-dev,
+               libgl1-mesa-dev (>= 6.5.1) [!armhf !armel] | libgl-dev [!armhf !armel],
+               libegl1-mesa-dev [armhf armel], libgles2-mesa-dev [armhf armel],
+               libboost-dev,
+               libboost-serialization-dev,
+               libglib2.0-dev,
+               libglibmm-2.4-dev,
+               libgtk2.0-dev,
+               libgtk-3-dev,
+               libice-dev (>= 1:1.0.1), 
+               libmetacity-dev (>= 1:2.30.3-0ubuntu3),
+               libpango1.0-dev,
+               libpng12-dev | libpng-dev,
+               librsvg2-dev, 
+               libsm-dev (>= 1:1.0.1),
+               libwnck-dev,
+               libx11-dev,
+               libxcomposite-dev (>= 1:0.3-2),
+               libxext-dev,
+               libxdamage-dev (>=1:1.0.3),
+               libxfixes-dev (>= 1:4.0.1),
+               libxinerama-dev, 
+               libxml-parser-perl,
+               libxrandr-dev (>= 2:1.1.0.2),
+               libxrender-dev (>= 1:0.9.1), 
+               libxcursor-dev,
+               libxml2-dev,
+               libxslt1-dev,
+               xsltproc,
+               libstartup-notification0-dev (>= 0.7),
+               x11proto-gl-dev (>= 1.4.8),
+               libglu1-mesa-dev [!armhf !armel],
+               libjpeg8-dev,
+               libnotify-dev,
+               libx11-xcb-dev,
+               libprotobuf-dev,
+               protobuf-compiler,
+               python-all-dev,
+               python-pyrex,
+               gnome-control-center-dev,
+               gsettings-desktop-schemas-dev,
+Standards-Version: 3.9.3
+# If you aren't a member of ~compiz but need to upload packaging changes,
+# just go ahead.  ~compiz will notice and sync up the code again.
+Vcs-Bzr: https://code.launchpad.net/~compiz/compiz/trunk
+
+Package: compiz
+Architecture: all
+Provides: x-window-manager
+Depends: compiz-core (>= ${source:Version}),
+         compiz-plugins-default (>= ${source:Version}),
+         compiz-gnome,
+         ${misc:Depends},
+Description: OpenGL window and compositing manager
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ This metapackage provides the components necessary for running compiz. It
+ provides the compiz core, a set of standard plugins, a window decorator using
+ the Gtk toolkit and the files necessary to integrate compiz with the GNOME
+ desktop environment.
+
+Package: compiz-core
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+Recommends: compiz-plugins-default,
+Provides: compiz-core-abiversion-${coreabiversion}
+Replaces: compizconfig-settings-manager (<< 0.9.8)
+Description: OpenGL window and compositing manager
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ Compiz combines together a window manager and a composite manager using
+ OpenGL for rendering. A "window manager" allows the manipulation of the
+ multiple applications and dialog windows that are presented on the screen. A
+ "composite manager" allows windows and other graphics to be combined together
+ to create composite images. Compiz achieves its stunning effects by doing
+ both of these functions.
+
+Package: compiz-dev
+Architecture: any
+Depends: compiz-core (= ${binary:Version}),
+         libdecoration0-dev (= ${binary:Version}),
+         ${misc:Depends},
+         compiz-plugins-default (= ${binary:Version}),
+         libgl1-mesa-dev [!armhf !armel] | libgl-dev [!armhf !armel],
+         libegl1-mesa-dev [armhf armel],
+         libgles2-mesa-dev [armhf armel],
+         libpng-dev,
+         libxcomposite-dev (>= 1:0.3-2),
+         libxfixes-dev (>=1:4.0.1),
+         libxdamage-dev (>= 1:1.0.3),
+         libxinerama-dev,
+         libxrandr-dev (>=2:1.1.0.2),
+         libxcursor-dev,
+         libice-dev (>= 1:1.0.1),
+         libsm-dev (>= 1:1.0.1),
+         libstartup-notification0-dev (>= 0.7),
+         libxslt1-dev,
+         libxml2-dev,
+         libx11-xcb-dev,
+         libglib2.0-dev,
+         libglibmm-2.4-dev,
+         libgtk-3-dev,
+Replaces: compiz-plugins-main-dev (<< 1:0.9.8),
+          compiz-plugins-extra (<< 1:0.9.8),
+          compiz-dev (<< 1:0.9.8),
+Breaks: compiz-plugins-main-dev (<< 1:0.9.8),
+        compiz-plugins-extra (<< 1:0.9.8),
+Suggests: compiz-plugins
+Description: OpenGL window and compositing manager - development files
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ This package contains the headers and libraries needed to compile compiz
+ plugins.
+
+Package: compiz-gnome
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         compiz-plugins-default (= ${binary:Version}),
+         gsettings-desktop-schemas,
+         gnome-settings-daemon (>= 3.4.2-0ubuntu9),
+Recommends: python-gconf
+Replaces: compiz-plugins-main (<= 1:0.9.8),
+          compiz-plugins-main-default (<= 1:0.9.8),
+          compizconfig-backend-gconf (<= 1:0.9.8),
+          libcompizconfig0 (<= 1:0.9.8),
+Breaks: compiz-plugins-main (<= 1:0.9.8),
+        compiz-plugins-main-default (<= 1:0.9.8),
+        compizconfig-backend-gconf (<= 1:0.9.8),
+Description: OpenGL window and compositing manager - GNOME window decorator
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ This package contains files needed to integrate compiz with the GNOME desktop
+ environment.
+
+Package: compiz-plugins-default
+Architecture: any
+Depends: compiz-core (= ${binary:Version}),
+         libdecoration0 (= ${binary:Version}),
+         ${shlibs:Depends},
+         ${misc:Depends},
+Replaces: compiz-plugins-main-default (<< 1:0.9.8),
+Breaks: compiz-plugins-main-default (<< 1:0.9.8),
+Description: OpenGL window and compositing manager - default plugins
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ This package contains the default compiz plugins we activate in ubuntu coming
+ with core compiz.
+
+Package: compiz-plugins
+Architecture: any
+Depends: compiz-core (= ${binary:Version}),
+         compiz-plugins-default (= ${binary:Version}),
+         ${shlibs:Depends},
+         ${misc:Depends},
+Replaces: compiz-plugins-main (<< 1:0.9.8),
+          compiz-plugins-extra (<< 1:0.9.8),
+          compiz-plugins-main-default (<< 1:0.9.8),
+Breaks: compiz-plugins-main (<< 1:0.9.8),
+        compiz-plugins-extra (<< 1:0.9.8),
+Description: OpenGL window and compositing manager - plugins
+ Compiz brings to life a variety of visual effects that make the Linux desktop
+ easier to use, more powerful and intuitive, and more accessible for users
+ with special needs.
+ .
+ This package contains the plugins that come with compiz but not officially
+ supported.
+
+Package: libdecoration0
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+Description: Compiz window decoration library
+ The window decoration library is responsible for drawing the window borders
+ and title bar of windows managed by Compiz. It is used by window decorators
+ like gtk-window-decorator.
+
+Package: libdecoration0-dev
+Section: libdevel
+Architecture: any
+Depends: libdecoration0 (= ${binary:Version}),
+         ${misc:Depends},
+         libx11-dev,
+         libxrender-dev (>= 1:0.9.1),
+Description: Compiz window decoration library - development files
+ The window decoration library is responsible for drawing the window borders
+ and title bar of windows managed by Compiz. It is used by window decorators
+ like gtk-window-decorator.
+ .
+ This package contains files required for developing window decorators
+ compatible with Compiz.
+
+Package: libcompizconfig0
+Architecture: any
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         compiz-core (= ${binary:Version}),
+Description: Settings library for plugins - OpenCompositing Project
+ The OpenCompositing Project brings 3D desktop visual effects that improve
+ usability of the X Window System and provide increased productivity
+ through plugins and themes contributed by the community giving a
+ rich desktop experience.
+ .
+ This package contains the library for plugins to configure settings.
+
+Package: libcompizconfig0-dev
+Architecture: any
+Section: libdevel
+Depends: ${misc:Depends},
+         libcompizconfig0 (= ${binary:Version}),
+         compiz-dev,
+Description: Development file for plugin settings - OpenCompositing Project
+ The OpenCompositing Project brings 3D desktop visual effects that improve
+ usability of the X Window System and provide increased productivity
+ through plugins and themes contributed by the community giving a
+ rich desktop experience.
+ .
+ This package contains the headers and development files needed to
+ build plugins with settings support.
+
+Package: python-compizconfig
+Architecture: any
+Section: python
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Provides: ${python:Provides}
+Description: Compizconfig bindings for python
+ Compiz Fusion is the result of the re-unification of the Beryl-project
+ and the community around the Compiz Window Manager. It seeks to provide
+ an easy and fun-to-use windowing environment, allowing use of the
+ graphics hardware to provide impressive effects, amazing speed and
+ unrivalled usefulness
+ .
+ This package provides python bindings for the compizconfig system.
+
+Package: compizconfig-settings-manager
+Architecture: all
+XB-Python-Version: ${python:Versions}
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         ${python:Depends},
+         python-compizconfig (>= ${source:Version}),
+         python-gtk2,
+Recommends: compiz-plugins-default
+Description: Compiz configuration settings manager
+ The OpenCompositing Project brings 3D desktop visual effects that improve
+ usability of the X Window System and provide increased productivity.
+ .
+ This package contains the compizconfig settings manager.
+
+Package: compiz-plugins-main
+Depends: compiz-plugins, ${misc:Depends}
+Architecture: all
+Section: oldlibs
+Description: transitional dummy package.
+ This package ensures a clean upgrade path, and can be safely removed
+ after the upgrade.
+
+Package: compiz-plugins-main-default
+Depends: compiz-plugins-default, ${misc:Depends}
+Architecture: all
+Section: oldlibs
+Description: transitional dummy package.
+ This package ensures a clean upgrade path, and can be safely removed
+ after the upgrade.
+
+Package: compiz-plugins-main-dev
+Depends: compiz-dev, ${misc:Depends}
+Architecture: all
+Section: oldlibs
+Description: transitional dummy package.
+ This package ensures a clean upgrade path, and can be safely removed
+ after the upgrade.
+
+Package: compiz-plugins-extra
+Depends: compiz-plugins, ${misc:Depends}
+Architecture: all
+Section: oldlibs
+Description: transitional dummy package.
+ This package ensures a clean upgrade path, and can be safely removed
+ after the upgrade.
+
+Package: compizconfig-backend-gconf
+Depends: compiz-gnome, gconf2, ${misc:Depends}
+Architecture: all
+Section: oldlibs
+Description: transitional dummy package.
+ This package ensures a clean upgrade path, and can be safely removed
+ after the upgrade.
+

=== added file 'debian/copyright'
--- debian/copyright	1970-01-01 00:00:00 +0000
+++ debian/copyright	2012-06-19 11:47:43 +0000
@@ -0,0 +1,232 @@
+Format: http://www.debian.org/doc/packaging-manuals/copyright-format/1.0/
+Upstream-Name: Compiz
+Upstream-Contact: Sam Spilsbury <sam.spilsbury@canonical.com>
+Source: https://launchpad.net/compiz
+
+Files: *
+Copyright: 2010-2011, Canonical Ltd
+           2007-2008, Quinn Storm <quinn@beryl-project.org>
+           2007-2008, Patrick Niklaus
+           2007-2008, Christopher Williams
+           2007-2008, Guillaume Seguin
+           2007-2008, compiz-fusion.org
+           2007-2008, Dennis Kasprzyk <onestone@opencompositing.org>
+           2007, Danny Baumann <maniac@opencompositing.org>
+           2007, Petr Vlašic
+           2007, Karol Sikora
+           2007, opencompositing.org
+           2006, Robert Carr <racarr@opencompositing.org>
+           2006, Volker Krause <vkrause@kde.org>
+           1999-2000, Daniel M. Duley <mosfet@kde.org> 
+License: GPL-2+
+ This program is free software; you can redistribute it
+ and/or modify it under the terms of the GNU General Public
+ License as published by the Free Software Foundation; either
+ version 2 of the License, or (at your option) any later
+ version.
+ .
+ This program is distributed in the hope that it will be
+ useful, but WITHOUT ANY WARRANTY; without even the implied
+ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ PURPOSE.  See the GNU General Public License for more
+ details.
+ .
+ You should have received a copy of the GNU General Public
+ License along with this package; if not, write to the Free
+ Software Foundation, Inc., 51 Franklin St, Fifth Floor,
+ Boston, MA  02110-1301 USA
+ .
+ On Debian systems, the full text of the GNU General Public
+ License version 2 can be found in the file
+ `/usr/share/common-licenses/GPL-2'.
+
+Files: compizconfig/libcompizconfig/* compizconfig/compizconfig-python/*
+Copyright: 2010, Sam Spilsbury
+           2007, Dennis Kasprzyk <onestone@opencompositing.org>
+           2007, Danny Baumann <maniac@opencompositing.org>
+           2007, Quinn Storm
+           2005-2006, Novell, Inc.
+           2000, Nicolas Devillard <ndevilla AT free DOT fr>
+License: LGPL-2.1+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Lesser General Public License for more details.
+ .
+ You should have received a copy of the GNU Lesser General Public
+ License along with this library; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA  02110-1301  USA
+ .
+ On Debian systems, the full text of the GNU Lesser General Public
+ License version 2.1 can be found in the file
+ `/usr/share/common-licenses/LGPL-2.1'.
+
+Files: gtk/*
+Copyright: 2010-2011, Canonical Ltd.
+           2009-2010, Sam Spilsbury <smspillaz@gmail.com>
+           2008-2009, Dennis Kasprzyk <onestone@compiz-fusion.org
+           2005-2007, Novell, Inc.
+License: LGPL-2+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2 of the License, or (at your option) any later version.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Lesser General Public License for more details.
+ .
+ You should have received a copy of the GNU Lesser General Public
+ License along with this library; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA  02110-1301  USA
+ .
+ On Debian systems, the full text of the GNU Lesser General Public
+ License version 2 can be found in the file
+ `/usr/share/common-licenses/LGPL-2'.
+
+Files: include/* kde/window-decorator-kde4/{kdecoration_plugins.{cpp,h},
+       paintredirector.{cpp,h}, src/*}
+Copyright: 2010-2012, Canonical Ltd
+           2010, Sam Spilsbury <smspillaz@gmail.com>
+           2008, Dennis Kasprzyk <onestone@opencompositing.org>
+           2005-2007, Novell, Inc.
+           2003-2009, Lubos Lunak <l.lunak@kde.org>
+           1999-2000, Daniel M. Duley <mosfet@kde.org> 
+License: MIT/X11
+ Permission is hereby granted, free of charge, to any person obtaining a
+ copy of this software and associated documentation files (the "Software"),
+ to deal in the Software without restriction, including without limitation
+ the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ and/or sell copies of the Software, and to permit persons to whom the
+ Software is furnished to do so, subject to the following conditions:
+ .
+ The above copyright notice and this permission notice shall be included in
+ all copies or substantial portions of the Software.
+ .
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ DEALINGS IN THE SOFTWARE.
+
+Files: plugins/* plugins/decor/src/clip-groups/include/clip-groups.*
+Copyright: 
+           2011, Daniel van Vugt <vanvugt@gmail.com>
+           2010, Jay Catherwood <jay.catherwood@gmail.com>
+           2010, Scott Moreau <oreaus@gmail.com>
+           2008-2009, Sam Spilsbury <smspillaz@gmail.com>
+           2008, Travis Watkins <amaranth@ubuntu.com>
+           2008, Stephen Kennedy <suasol@gmail.com>
+           2008, Marco Diego Aurelio Mesquita <marcodiegomesquita@gmail.com>
+           2008, Eduardo Gurgel Pinho <edgurgel@gmail.com>
+           2007-2010 Canonical Ltd
+           2007-2009, Guillaume Seguin <guillaume@segu.in>
+           2007-2008, Kristian Lyngstøl <kristian@bohemians.org>
+           2007-2008, Danny Baumann <maniac@opencompositing.org>
+           2007, Bellegarde Cedric <gnumdk (at) gmail.com>
+           2007, David Reveman
+           2007, Mike Dransfield <mike (at) blueroot.co.uk>
+           2007, Stjepan Glavina
+           2007 Michael Vogt <mvo@ubuntu.com>
+           2007, Andrew Riedi <andrewriedi@gmail.com>
+           2006-2007, Robert Carr <racarr@opencompositing.org>
+           2006-2010, Dennis Kasprzyk <onestone@opencompositing.org>
+           2006-2010, Patrick Niklaus
+           2006-2010, Roi Cohen
+           2006-2007, Kristian Lyngstøl <kristian@beryl-project.org>
+           2006, Nicholas Thomas
+           2006, Quinn Storm
+           2006, Darryll Truchan <moppsy@comcast.net>
+           2006, Diogo Ferreira
+           2006, Roi Cohen
+           2006, Erkin Bahceci
+           2005-2006, Novel, Inc
+           2003, Rob Adams
+           2002-2003 Red Hat, Inc
+           2001, Havoc Pennington
+License: GPL-2+
+ This program is free software; you can redistribute it
+ and/or modify it under the terms of the GNU General Public
+ License as published by the Free Software Foundation; either
+ version 2 of the License, or (at your option) any later
+ version.
+ .
+ This program is distributed in the hope that it will be
+ useful, but WITHOUT ANY WARRANTY; without even the implied
+ warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+ PURPOSE.  See the GNU General Public License for more
+ details.
+ .
+ You should have received a copy of the GNU General Public
+ License along with this package; if not, write to the Free
+ Software Foundation, Inc., 51 Franklin St, Fifth Floor,
+ Boston, MA  02110-1301 USA
+ .
+ On Debian systems, the full text of the GNU General Public
+ License version 2 can be found in the file
+ `/usr/share/common-licenses/GPL-2'.
+
+Files: plugins/{annotate,blur,clone,commands,compiztoolbox,composite,dbus,
+                decor,ezoom,fade,gnomecompat,imgpng,imgsvg,inotify,move,obs,
+                opengl,regex,resize,rotate,scale,showdesktop,screenshot,
+                switcher,water,woobly}/*
+       plugins/{place,wall}/src/*/tests/*
+Copyright: 2011-2012, Canonical Ltd
+           2009, Sam Spilsbury <smspillaz@gmail.com>
+           2008-2010, Kristian Lyngstøl <kristian@bohemians.org>
+           2008-2009, Danny Baumanan <maniac@opencompositing.org>
+           2008, Dennis Kasprzyk <onestone@opencompositing.org>
+           2007 Diogo "playerX" Ferreira
+           2005-2007, Novell, Inc
+           1999-2005, Brian Paul
+License: MIT/X11
+ Permission is hereby granted, free of charge, to any person obtaining a
+ copy of this software and associated documentation files (the "Software"),
+ to deal in the Software without restriction, including without limitation
+ the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ and/or sell copies of the Software, and to permit persons to whom the
+ Software is furnished to do so, subject to the following conditions:
+ .
+ The above copyright notice and this permission notice shall be included in
+ all copies or substantial portions of the Software.
+ .
+ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
+ THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
+ DEALINGS IN THE SOFTWARE.
+
+Files: plugins/ccp/*
+Copyright: 2007, Dennis Kasprzyk <onestone@opencompositing.org>
+License: LGPL-2.1+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Lesser General Public
+ License as published by the Free Software Foundation; either
+ version 2.1 of the License, or (at your option) any later version.
+ .
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Lesser General Public License for more details.
+ .
+ You should have received a copy of the GNU Lesser General Public
+ License along with this library; if not, write to the Free Software
+ Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA  02110-1301  USA
+ .
+ On Debian systems, the full text of the GNU Lesser General Public
+ License version 2.1 can be found in the file
+ `/usr/share/common-licenses/LGPL-2.1'.
+

=== added file 'debian/gbp.conf'
--- debian/gbp.conf	1970-01-01 00:00:00 +0000
+++ debian/gbp.conf	2012-06-19 11:22:48 +0000
@@ -0,0 +1,8 @@
+[DEFAULT]
+debian-branch = debian-unstable
+debian-tag = compiz-%(version)s
+upstream-branch = upstream-unstable
+upstream-tag = compiz-%(version)s
+
+[git-dch]
+meta = 1

=== added file 'debian/gtk-window-decorator.1'
--- debian/gtk-window-decorator.1	1970-01-01 00:00:00 +0000
+++ debian/gtk-window-decorator.1	2012-06-19 11:22:48 +0000
@@ -0,0 +1,30 @@
+.TH GTK-WINDOW-DECORATOR 1 "September 25, 2006"
+.SH NAME
+gtk-window-decorator \- Compiz window decorator using the Gtk toolkit
+.SH SYNOPSIS
+.B gtk-window-decorator
+.RI [ options ]
+.SH DESCRIPTION
+.B gtk-window-decorator
+is a window decorator for
+.B compiz
+that uses the Gtk toolkit to provide a look and feel similar to that of the
+metacity window manager.
+.SH OPTIONS
+.B gtk-window-decorator
+accepts the following options:
+.TP
+.BI \-\-minimal
+Runs only with minimal window decorations.
+.TP
+.BI \-\-replace
+Replaces any running window decorator.
+.TP
+.BI \-\-help
+Prints the list of accepted options.
+.SH AUTHOR
+gtk-window-decorator was written by David Reveman <davidr@novell.com> and
+others.
+.PP
+This manual page was written by Thierry Reding <thierry@gilfi.de>,
+for the Debian project (but may be used by others).

=== added file 'debian/libcompizconfig0-dev.install'
--- debian/libcompizconfig0-dev.install	1970-01-01 00:00:00 +0000
+++ debian/libcompizconfig0-dev.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,5 @@
+debian/tmp/usr/lib/libcompizconfig.so
+debian/tmp/usr/include/compizconfig/*.h
+debian/tmp/usr/lib/pkgconfig/libcompizconfig.pc
+debian/tmp/usr/share/cmake*/FindCompizConfig.cmake
+debian/tmp/usr/share/compiz/cmake/LibCompizConfigCommon.cmake

=== added file 'debian/libcompizconfig0.install'
--- debian/libcompizconfig0.install	1970-01-01 00:00:00 +0000
+++ debian/libcompizconfig0.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,6 @@
+debian/tmp/usr/lib/libcompizconfig.so.0.0.0
+debian/tmp/usr/lib/libcompizconfig.so.0
+debian/tmp/usr/lib/compizconfig/backends/libini.so
+debian/tmp/usr/share/compiz/ccp.xml
+debian/tmp/usr/lib/compiz/libccp.so
+debian/config /etc/compizconfig

=== added file 'debian/libdecoration0-dev.docs'
--- debian/libdecoration0-dev.docs	1970-01-01 00:00:00 +0000
+++ debian/libdecoration0-dev.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/libdecoration0-dev.install'
--- debian/libdecoration0-dev.install	1970-01-01 00:00:00 +0000
+++ debian/libdecoration0-dev.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,3 @@
+debian/tmp/usr/include/compiz/decoration.h
+debian/tmp/usr/lib/libdecoration.so
+debian/tmp/usr/lib/pkgconfig/libdecoration.pc

=== added file 'debian/libdecoration0.docs'
--- debian/libdecoration0.docs	1970-01-01 00:00:00 +0000
+++ debian/libdecoration0.docs	2012-06-29 07:50:37 +0000
@@ -0,0 +1,3 @@
+AUTHORS
+NEWS
+README

=== added file 'debian/libdecoration0.install'
--- debian/libdecoration0.install	1970-01-01 00:00:00 +0000
+++ debian/libdecoration0.install	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+debian/tmp/usr/lib/libdecoration*.so.*

=== added file 'debian/libdecoration0.symbols'
--- debian/libdecoration0.symbols	1970-01-01 00:00:00 +0000
+++ debian/libdecoration0.symbols	2012-09-20 13:43:47 +0000
@@ -0,0 +1,37 @@
+libdecoration.so.0 libdecoration0 #MINVER#
+ decor_acquire_dm_session@Base 1:0.9.2.1
+ decor_alloc_property@Base 1:0.9.7.0~bzr2995
+ decor_apply_gravity@Base 1:0.9.2.1
+ decor_blend_border_picture@Base 1:0.9.2.1
+ decor_draw_simple@Base 1:0.9.2.1
+ decor_extents_cmp@Base 1:0.9.8.2+bzr3377
+ decor_fill_picture_extents_with_shadow@Base 1:0.9.2.1
+ decor_gen_window_property@Base 1:0.9.5.92
+ decor_get_best_layout@Base 1:0.9.2.1
+ decor_get_default_layout@Base 1:0.9.2.1
+ decor_handle_selection_clear@Base 1:0.9.2.1
+ decor_handle_selection_request@Base 1:0.9.2.1
+ decor_match_pixmap@Base 1:0.9.7.0~bzr2995
+ decor_pixmap_property_to_quads@Base 1:0.9.2.1
+ decor_post_delete_pixmap@Base 1:0.9.8
+ decor_post_generate_request@Base 1:0.9.8
+ decor_post_pending@Base 1:0.9.8
+ decor_property_get_num@Base 1:0.9.7.0~bzr2995
+ decor_property_get_type@Base 1:0.9.5.92
+ decor_property_get_version@Base 1:0.9.2.1
+ decor_quads_to_property@Base 1:0.9.5.92
+ decor_region_to_blur_property@Base 1:0.9.2.1
+ decor_set_dm_check_hint@Base 1:0.9.2.1
+ decor_set_horz_quad_line@Base 1:0.9.2.1
+ decor_set_lSrS_window_quads@Base 1:0.9.2.1
+ decor_set_lSrStSbS_window_quads@Base 1:0.9.2.1
+ decor_set_lSrStSbX_window_quads@Base 1:0.9.2.1
+ decor_set_lSrStXbS_window_quads@Base 1:0.9.2.1
+ decor_set_lXrXtXbX_window_quads@Base 1:0.9.2.1
+ decor_set_vert_quad_row@Base 1:0.9.2.1
+ decor_shadow_create@Base 1:0.9.2.1
+ decor_shadow_destroy@Base 1:0.9.2.1
+ decor_shadow_options_cmp@Base 1:0.9.8.2
+ decor_shadow_reference@Base 1:0.9.2.1
+ decor_version@Base 1:0.9.2.1
+ decor_window_property@Base 1:0.9.2.1

=== added directory 'debian/patches'
=== added file 'debian/patches/100_expo_layout.patch'
--- debian/patches/100_expo_layout.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/100_expo_layout.patch	2012-11-05 20:50:59 +0000
@@ -0,0 +1,2907 @@
+Index: ubuntu/plugins/expo/expo.xml.in
+===================================================================
+--- ubuntu.orig/plugins/expo/expo.xml.in	2012-09-12 22:20:42.944758828 +0800
++++ ubuntu/plugins/expo/expo.xml.in	2012-09-12 22:20:43.240760303 +0800
+@@ -17,6 +17,7 @@
+ 		<plugin>wobbly</plugin>
+ 		<plugin>animation</plugin>
+ 		<plugin>wallpaper</plugin>
++		<plugin>imgpng</plugin>
+ 	    </relation>
+ 	</deps>
+ 	<options>
+@@ -25,7 +26,7 @@
+ 		<option name="expo_key" type="key">
+ 		    <_short>Expo key</_short>
+ 		    <_long>Engage wall expo mode key binding</_long>
+-		    <default>&lt;Super&gt;e</default>
++		    <default>&lt;Super&gt;s</default>
+ 		</option>
+ 		<option name="expo_button" type="button">
+ 		    <_short>Expo button</_short>
+@@ -35,8 +36,6 @@
+ 		<option name="expo_edge" type="edge">
+ 		    <_short>Expo edge</_short>
+ 		    <_long>Engage wall expo mode edge binding</_long>
+-		    <default>
+-		    </default>
+ 		</option>
+ 		<option name="double_click_time" type="int">
+ 		    <_short>Double click time</_short>
+@@ -79,7 +78,7 @@
+ 		<option name="zoom_time" type="float">
+ 		    <_short>Zoom time</_short>
+ 		    <_long>Duration of the zoomout animation</_long>
+-		    <default>0.5</default>
++		    <default>0.3</default>
+ 		    <min>0.1</min>
+ 		    <max>5.0</max>
+ 		    <precision>0.1</precision>
+@@ -130,10 +129,24 @@
+ 			<_name>Curve</_name>
+ 		    </desc>
+ 		</option>
++		<option name="x_offset" type="int">
++		    <_short>X Space</_short>
++		    <_long> Left Side screen space of expo in pixels</_long>
++		    <min>-1680</min>
++		    <max>1680</max>
++		    <default>64</default>
++                </option>
++		<option name="y_offset" type="int">
++		    <_short>Y Space</_short>
++		    <_long> Top Side screen space of expo in pixels</_long>
++		    <min>-100</min>
++		    <max>100</max>
++		    <default>24</default>
++                </option>
+ 		<option name="distance" type="float">
+ 		    <_short>Distance</_short>
+ 		    <_long>Distance of the expo wall</_long>
+-		    <default>0.0</default>
++		    <default>0.005</default>
+ 		    <min>0.0</min>
+ 		    <max>1.0</max>
+ 		    <precision>0.01</precision>
+@@ -141,7 +154,7 @@
+ 		<option name="vp_distance" type="float">
+ 		    <_short>Viewport distance</_short>
+ 		    <_long>Distance between viewports</_long>
+-		    <default>0.10</default>
++		    <default>0.2</default>
+ 		    <min>0.0</min>
+ 		    <max>1.0</max>
+ 		    <precision>0.01</precision>
+@@ -192,7 +205,7 @@
+ 		    <option name="vp_brightness" type="float">
+ 			<_short>Brightness</_short>
+ 			<_long>Inactive viewport brightness.</_long>
+-			<default>75.0</default>
++			<default>40.0</default>
+ 			<min>0.0</min>
+ 			<max>100.0</max>
+ 			<precision>0.1</precision>
+@@ -200,18 +213,28 @@
+ 		    <option name="vp_saturation" type="float">
+ 			<_short>Saturation</_short>
+ 			<_long>Inactive viewport saturation.</_long>
+-			<default>100.0</default>
++			<default>40.0</default>
+ 			<min>0.0</min>
+ 			<max>100.0</max>
+ 			<precision>0.1</precision>
+ 		    </option>
++		    <option name="selected_color" type="color">
++			<_short>Selected Color</_short>
++			<_long>Color to use when highlighting the selected viewport</_long>
++			<default>
++			    <red>0xfbfb</red>
++			    <green>0x8b8b</green>
++			    <blue>0x0</blue>
++			    <alpha>0xffff</alpha>
++			</default>
++		    </option>
+ 		</subgroup>
+ 		<subgroup>
+ 		    <short>Reflection</short>
+ 		    <option name="reflection" type="bool">
+ 			<_short>Reflection</_short>
+ 			<_long>Show a reflection of the viewports on the ground</_long>
+-			<default>true</default>
++			<default>false</default>
+ 		    </option>
+ 		    <option name="ground_color1" type="color">
+ 			<_short>Ground color(near)</_short>
+@@ -244,7 +267,7 @@
+ 		    <option name="scale_factor" type="float">
+ 			<_short>Reflection Scale</_short>
+ 			<_long>Scale factor of the expo wall reflection</_long>
+-			<default>0.75</default>
++			<default>1.0</default>
+ 			<min>0.0</min>
+ 			<max>2.0</max>
+ 			<precision>0.01</precision>
+Index: ubuntu/plugins/expo/src/expo.cpp
+===================================================================
+--- ubuntu.orig/plugins/expo/src/expo.cpp	2012-09-12 22:09:32.323735000 +0800
++++ ubuntu/plugins/expo/src/expo.cpp	2012-09-12 22:29:50.643474721 +0800
+@@ -27,6 +27,8 @@
+ 
+ #include "expo.h"
+ #include "click-threshold.h"
++#include "wall-offset.h"
++#include "windows-on-viewport.h"
+ #include <math.h>
+ #ifndef USE_GLES
+ #include <GL/glu.h>
+@@ -73,11 +75,10 @@
+ 
+     if (dndState == DnDDuring || dndState == DnDStart)
+     {
+-	if (dndWindow)
++	if (dndWindows.size ())
+ 	    finishWindowMovement ();
+ 
+ 	dndState  = DnDNone;
+-	dndWindow = NULL;
+ 
+ 	action->setState (action->state () & CompAction::StateInitButton);
+ 	cScreen->damageScreen ();
+@@ -113,7 +114,6 @@
+ 	clickTime   = 0;
+ 
+ 	dndState  = DnDNone;
+-	dndWindow = NULL;
+ 
+ 	selectedVp = screen->vp ();
+ 	lastSelectedVp = screen->vp ();
+@@ -156,8 +156,8 @@
+     else
+ 	vpUpdateMode = VPUpdateMouseOver;
+ 
+-    dndState  = DnDNone;
+-    dndWindow = NULL;
++    dndState = DnDNone;
++    dndWindows.clear ();
+ 
+     screen->removeAction (&optionGetDndButton ());
+     screen->removeAction (&optionGetExitButton ());
+@@ -202,6 +202,8 @@
+     if (!expoMode)
+ 	return false;
+ 
++    lastSelectedVp = selectedVp;
++
+     newX = selectedVp.x () + 1;
+     newY = selectedVp.y ();
+ 
+@@ -225,7 +227,7 @@
+ 		    CompAction::State   state,
+ 		    CompOption::Vector& options)
+ {
+-    int newX, newY;
++    unsigned int newX, newY;
+ 
+     if (!expoMode)
+ 	return false;
+@@ -272,53 +274,39 @@
+ void
+ ExpoScreen::finishWindowMovement ()
+ {
+-    dndWindow->syncPosition ();
+-    dndWindow->ungrabNotify ();
+-
+-    screen->moveViewport (screen->vp ().x () - selectedVp.x (),
+-			  screen->vp ().y () - selectedVp.y (), true);
+-
+-    /* update saved window attributes in case we moved the
+-       window to a new viewport */
+-    if (dndWindow->saveMask () & CWX)
+-    {
+-	dndWindow->saveWc ().x = dndWindow->saveWc ().x % screen->width ();
+-	if (dndWindow->saveWc ().x < 0)
+-	    dndWindow->saveWc ().x += screen->width ();
+-    }
+-    if (dndWindow->saveMask () & CWY)
++    foreach (CompWindow *dndWindow, dndWindows)
+     {
+-	dndWindow->saveWc ().y = dndWindow->saveWc ().y % screen->height ();
+-	if (dndWindow->saveWc ().y < 0)
+-	    dndWindow->saveWc ().y += screen->height ();
+-    }
+-
+-    /* update window attibutes to make sure a moved maximized window
+-       is properly snapped to the work area */
+-    if (dndWindow->state () & MAXIMIZE_STATE)
+-	dndWindow->updateAttributes (CompStackingUpdateModeNone);
+-
+-#if 0 /* FIXME: obsolete in the meantime? */
+-    {
+-	int lastOutput;
+-	int centerX, centerY;
++	if (dndWindow->grabbed ())
++	{
++	    dndWindow->syncPosition ();
++	    dndWindow->ungrabNotify ();
+ 
+-	/* make sure we snap to the correct output */
+-	lastOutput = s->currentOutputDev;
+-	centerX = (WIN_X (w) + WIN_W (w) / 2) % s->width;
+-	if (centerX < 0)
+-	    centerX += s->width;
+-	centerY = (WIN_Y (w) + WIN_H (w) / 2) % s->height;
+-	if (centerY < 0)
+-	    centerY += s->height;
++	    screen->updateGrab (grabIndex, None);
+ 
+-	s->currentOutputDev = outputDeviceForPoint (s, centerX, centerY);
++	    screen->moveViewport (screen->vp ().x () - selectedVp.x (),
++				  screen->vp ().y () - selectedVp.y (), true);
+ 
+-	updateWindowAttributes (w, CompStackingUpdateModeNone);
++	    /* update saved window attributes in case we moved the
++    window to a new viewport */
++	    if (dndWindow->saveMask () & CWX)
++	    {
++		dndWindow->saveWc ().x = dndWindow->saveWc ().x % screen->width ();
++		if (dndWindow->saveWc ().x < 0)
++		    dndWindow->saveWc ().x += screen->width ();
++	    }
++	    if (dndWindow->saveMask () & CWY)
++	    {
++		dndWindow->saveWc ().y = dndWindow->saveWc ().y % screen->height ();
++		if (dndWindow->saveWc ().y < 0)
++		    dndWindow->saveWc ().y += screen->height ();
++	    }
+ 
+-	s->currentOutputDev = lastOutput;
++	    /* update window attibutes to make sure a moved maximized window
++	   is properly snapped to the work area */
++	    if (dndWindow->state () & MAXIMIZE_STATE)
++		dndWindow->updateAttributes (CompStackingUpdateModeNone);
++	}
+     }
+-#endif
+ }
+ 
+ void
+@@ -402,6 +390,80 @@
+     screen->handleEvent (event);
+ }
+ 
++bool
++ExpoWindow::dragged () const
++{
++    ExpoScreen *es = ExpoScreen::get (screen);
++
++    return std::find (es->dndWindows.begin (), es->dndWindows.end (), window) != es->dndWindows.end ();
++}
++
++const compiz::window::Geometry &
++ExpoWindow::absoluteGeometry () const
++{
++    const compiz::window::Geometry &relativeGeometry (window->geometry ());
++    mAbsoluteGeometry.set ((screen->vp ().x () * screen->width ()) + relativeGeometry.x (),
++			   (screen->vp ().y () * screen->height ()) + relativeGeometry.y (),
++			   relativeGeometry.width (),
++			   relativeGeometry.height (),
++			   relativeGeometry.border ());
++
++    return mAbsoluteGeometry;
++}
++
++bool
++ExpoWindow::isDesktopOrDock () const
++{
++    return window->type () == CompWindowTypeDesktopMask ||
++	   window->type () == CompWindowTypeDockMask;
++}
++
++namespace cei = compiz::expo::impl;
++
++cei::CompizClientListGenerator::CompizClientListGenerator (CompScreen *screen) :
++    mScreen (screen),
++    mClientList (&mScreen->clientList (true)),
++    mClientListIterator (mClientList->begin ())
++{
++}
++
++compiz::expo::ViewportMemberWindow *
++cei::CompizClientListGenerator::nextClient ()
++{
++    if (mClientListIterator == mClientList->end ())
++	return NULL;
++
++    compiz::expo::ViewportMemberWindow *vpMemberWindow = ExpoWindow::get (*mClientListIterator);
++
++    ++mClientListIterator;
++
++    return vpMemberWindow;
++}
++
++bool
++ExpoScreen::windowsOnVp (compiz::expo::ClientListGenerator &clientList,
++			 CompPoint                         &p,
++			 const CompPoint                   &unprojectedCursor,
++			 const CompSize                    &screenSize,
++			 CompScreen                        *screen)
++{
++    return false;
++}
++
++namespace
++{
++    void fillInNewViewportActivityData (unsigned int vpCount,
++					std::vector <float> &vpActivity)
++    {
++	if (vpActivity.size () < vpCount)
++	{
++	    vpActivity.resize (vpCount);
++	    foreach (float& activity, vpActivity)
++		activity = 1.0f;
++	}
++    }
++}
++
+ void
+ ExpoScreen::preparePaint (int msSinceLastPaint)
+ {
+@@ -412,33 +474,43 @@
+     else
+ 	expoCam = MAX (0.0, expoCam - val);
+ 
+-    if (expoCam)
++    if (dndState == DnDDuring)
+     {
+-	unsigned int i, j, vp;
+-	unsigned int vpCount = screen->vpSize ().width () *
+-	                       screen->vpSize ().height ();
++	foreach (CompWindow *w, dndWindows)
++	    ExpoWindow::get (w)->dndOpacity = MIN (1.0, ExpoWindow::get (w)->dndOpacity + val);
++    }
++    else if (dndState == DnDNone)
++    {
++	CompWindowList::iterator it = dndWindows.begin ();
+ 
+-	if (vpActivity.size () < vpCount)
++	while (it != dndWindows.end ())
+ 	{
+-	    vpActivity.resize (vpCount);
+-	    foreach (float& activity, vpActivity)
+-		activity = 1.0f;
+-	}
++	    ExpoWindow::get ((*it))->dndOpacity = MAX (0.0, ExpoWindow::get ((*it))->dndOpacity - val);
+ 
+-	for (i = 0; i < (unsigned int) screen->vpSize ().width (); i++)
+-	{
+-	    for (j = 0; j < (unsigned int) screen->vpSize ().height (); j++)
++	    if (ExpoWindow::get ((*it))->dndOpacity <= 0.0f)
+ 	    {
+-		vp = (j * screen->vpSize ().width ()) + i;
+-
+-		if (CompPoint (i, j) == selectedVp)
+-		    vpActivity[vp] = MIN (1.0, vpActivity[vp] + val);
+-		else
+-		    vpActivity[vp] = MAX (0.0, vpActivity[vp] - val);
++		dndWindows.erase (it);
++		it = dndWindows.begin ();
+ 	    }
++	    else
++		it++;
+ 	}
++    }
+ 
+-	for (i = 0; i < 360; i++)
++    if (expoCam)
++    {
++	unsigned int vpCount = compiz::expo::countViewports (screen->vpSize ());
++
++	fillInNewViewportActivityData (vpCount, vpActivity);
++	compiz::expo::fillInNewViewportActiveData (vpCount, vpActive);
++
++	for (unsigned int i = 0; i < vpCount; i++)
++	    if (vpActive[i])
++		vpActivity[i] = MIN (1.0, vpActivity[i] + val);
++	    else
++		vpActivity[i] = MAX (0.0, vpActivity[i] - val);
++
++	for (int i = 0; i < 360; i++)
+ 	{
+ 	    float fi = (float) i;
+ 
+@@ -509,6 +581,31 @@
+     cScreen->paint (outputs, mask);
+ }
+ 
++namespace
++{
++    void updateViewportActiveStates (CompScreen *screen)
++    {
++	ExpoScreen *es = ExpoScreen::get (screen);
++
++	unsigned int vpCount = compiz::expo::countViewports (screen->vpSize ());
++	fillInNewViewportActivityData (vpCount, es->vpActivity);
++
++	for (int i = 0; i < screen->vpSize ().width (); i++)
++	{
++	    for (int j = 0; j < screen->vpSize ().height (); j++)
++	    {
++		compiz::expo::impl::CompizClientListGenerator clientList (screen);
++
++		compiz::expo::activeViewportsForMembers (clientList,
++							 es->newCursor,
++							 screen->vpSize (),
++							 *screen,
++							 es->vpActive);
++	    }
++	}
++    }
++}
++
+ void
+ ExpoScreen::donePaint ()
+ {
+@@ -539,6 +636,11 @@
+ 	foreach (float& vp, vpActivity)
+ 	    if (vp != 0.0 && vp != 1.0)
+ 		cScreen->damageScreen ();
++
++	foreach (CompWindow *w, dndWindows)
++	    if (ExpoWindow::get (w)->dndOpacity != 0.0f &&
++		ExpoWindow::get (w)->dndOpacity != 1.0f)
++		cScreen->damageScreen ();
+     }
+ 
+     if (grabIndex && expoCam <= 0.0f && !expoMode)
+@@ -553,10 +655,25 @@
+     switch (dndState) {
+     case DnDDuring:
+ 	{
+-	    if (dndWindow)
+-		dndWindow->move (newCursor.x () - prevCursor.x (),
+-				 newCursor.y () - prevCursor.y (),
+-				 optionGetExpoImmediateMove ());
++	    if (dndWindows.size ())
++	    {
++		foreach (CompWindow *dndWindow, dndWindows)
++		{
++		    if (dndWindow->grabbed ())
++		    {
++			ExpoWindow *ew = ExpoWindow::get (dndWindow);
++
++			/* No need to update twice */
++			dndWindow->moveNotifySetEnabled (ew, false);
++			dndWindow->move (newCursor.x () - prevCursor.x (),
++					 newCursor.y () - prevCursor.y (),
++					 optionGetExpoImmediateMove ());
++			dndWindow->moveNotifySetEnabled (ew, true);
++
++			updateViewportActiveStates (screen);
++		    }
++		}
++	    }
+ 
+ 	    prevCursor = newCursor;
+ 	    cScreen->damageScreen ();
+@@ -621,13 +738,13 @@
+ 		    break;
+ 
+ 		dndState  = DnDDuring;
+-		dndWindow = w;
++		dndWindows.push_back (w);
+ 
+ 		w->grabNotify (nx, ny, 0,
+ 			       CompWindowGrabMoveMask |
+ 			       CompWindowGrabButtonMask);
+ 
+-		screen->updateGrab (grabIndex, dragCursor);
++		screen->updateGrab (grabIndex, mMoveCursor);
+ 
+ 		w->raise ();
+ 		w->moveInputFocusTo ();
+@@ -762,6 +879,124 @@
+ }
+ 
+ void
++ExpoScreen::paintViewport (const GLScreenPaintAttrib& attrib,
++			   const GLMatrix&            transform,
++			   const CompRegion&          region,
++			   CompOutput                 *output,
++			   unsigned int               mask,
++			   CompPoint                  vpPos,
++			   GLVector                   &vpCamPos,
++			   bool                       reflection)
++{
++    GLMatrix     sTransform (transform);
++    GLMatrix     sTransform2, sTransform3;
++    float        sx = (float) screen->width () / output->width ();
++    float        sy = (float) screen->height () / output->height ();
++    float        vpp;
++    float        progress = sigmoidProgress (expoCam);
++    unsigned int vp;
++    CompPoint    vpSize (screen->vpSize ().width (), screen->vpSize ().height ());
++
++    const float gapY = optionGetVpDistance () * 0.1f * expoCam;
++    const float gapX = optionGetVpDistance () * 0.1f * screen->height () /
++		       screen->width () * expoCam;
++
++    /* not sure this will work with different resolutions */
++    sTransform.translate (0.0, MAX (0, vpPos.y ()) * -(sy + gapY), 0.0f);
++
++    sTransform2 = sTransform;
++
++    /* not sure this will work with different resolutions */
++    if (optionGetDeform () != DeformCurve)
++	sTransform2.translate (MAX (0, vpPos.x ()) * (sx + gapX), 0.0f, 0.0);
++
++
++    if (optionGetExpoAnimation () == ExpoAnimationVortex)
++	sTransform2.rotate (360 * expoCam,
++			    0.0f, 1.0f, 2.0f * expoCam);
++
++    sTransform3 = sTransform2;
++
++    sTransform3.translate (output->x () / output->width (),
++			   -output->y () / output->height (), 0.0);
++
++    cScreen->setWindowPaintOffset ((screen->vp ().x () - vpPos.x ()) *
++				   screen->width (),
++				   (screen->vp ().y () - vpPos.y ()) *
++				   screen->height ());
++
++    vp = (vpPos.y () * vpSize.x ()) + vpPos.x ();
++
++    vpp = (expoCam * vpActivity[vp]) + (1 - expoCam);
++    vpp = sigmoidProgress (vpp);
++
++    vpBrightness = vpp + ((1.0 - vpp) *
++			  optionGetVpBrightness () / 100.0);
++    vpSaturation = vpp + ((1.0 - vpp) *
++			  optionGetVpSaturation () / 100.0);
++
++    paintingVp = vpPos;
++
++    if (optionGetDeform () == DeformCurve)
++    {
++	float rotateX;
++
++	sTransform3.translate (-vpCamPos[GLVector::x], 0.0f,
++			       curveDistance - DEFAULT_Z_CAMERA);
++
++	rotateX = -vpPos.x () + interpolate (((float) vpSize.x () / 2.0) - 0.5,
++				    screen->vp ().x (), progress);
++
++	sTransform3.rotate (curveAngle * rotateX, 0.0, 1.0, 0.0);
++
++	sTransform3.translate (vpCamPos[GLVector::x], 0.0f,
++			       DEFAULT_Z_CAMERA - curveDistance);
++    }
++
++    if (paintingDndWindow)
++	cScreen->getWindowPaintListSetEnabled (this, true);
++    gScreen->glPaintTransformedOutput (attrib, sTransform3,
++				       screen->region (), output,
++				       mask);
++
++    if (paintingDndWindow)
++	cScreen->getWindowPaintListSetEnabled (this, false);
++
++    if (!reflection && !paintingDndWindow)
++    {
++	int cursor[2] = { pointerX, pointerY };
++
++	invertTransformedVertex (attrib, sTransform3,
++				 output, cursor);
++
++	if ((cursor[0] > 0) && (cursor[0] < (int) screen->width ()) &&
++		(cursor[1] > 0) && (cursor[1] < (int) screen->height ()))
++	{
++	    newCursor.setX (vpPos.x () * screen->width () + cursor[0]);
++	    newCursor.setY (vpPos.y () * screen->height () + cursor[1]);
++
++	    if (anyClick || dndState != DnDNone)
++	    {
++		/* Used to save last viewport interaction was in */
++		selectedVp = vpPos;
++		anyClick = false;
++	    }
++	}
++    }
++
++    /* Calculate the current viewport size */
++    int tl[2] = { 0, 0 };
++    int br[2] = { screen->width (), screen->height () };
++
++    invertTransformedVertex (attrib, sTransform3, output, tl);
++    invertTransformedVertex (attrib, sTransform3, output, br);
++
++    viewport_size = CompSize (br[0] - tl[0], br[1] - tl[1]);
++
++    cScreen->setWindowPaintOffset (0, 0);
++}
++
++void
+ ExpoScreen::paintWall (const GLScreenPaintAttrib& attrib,
+ 		       const GLMatrix&            transform,
+ 		       const CompRegion&          region,
+@@ -772,13 +1007,11 @@
+     GLfloat vertexData[12];
+     GLushort colorData[16];
+     GLMatrix sTransformW, sTransform (transform);
+-    int      i, j, vp;
+     GLenum   oldFilter = gScreen->textureFilter ();
+-
+-    float     sx = (float) screen->width () / output->width ();
+-    float     sy = (float) screen->height () / output->height ();
++    float        sx = (float) screen->width () / output->width ();
++    float        sy = (float) screen->height () / output->height ();
+     float     biasZ;
+-    float     oScale, rotation = 0.0f, progress, vpp;
++    float     oScale, rotation = 0.0f, progress;
+     float     aspectX = 1.0f, aspectY = 1.0f;
+     GLVector  cam;
+     CompPoint vpSize (screen->vpSize ().width (), screen->vpSize ().height ());
+@@ -910,9 +1143,24 @@
+     sTransform.rotate (rotation, 0.0f, 1.0f, 0.0f);
+     sTransform.scale (aspectX, aspectY, 1.0);
+ 
++    CompPoint offsetInScreenCoords (optionGetXOffset (),
++				    optionGetYOffset ());
++    float     offsetInWorldCoordX, offsetInWorldCoordY, worldScaleFactorX, worldScaleFactorY;
++
++    compiz::expo::calculateWallOffset (*output,
++				       offsetInScreenCoords,
++				       vpSize,
++				       *screen,
++				       offsetInWorldCoordX,
++				       offsetInWorldCoordY,
++				       worldScaleFactorX,
++				       worldScaleFactorY,
++				       sigmoidProgress (expoCam));
++
+     /* translate expo to center */
+-    sTransform.translate (vpSize.x () * sx * -0.5,
+-			  vpSize.y () * sy * 0.5, 0.0f);
++    sTransform.translate (vpSize.x () * sx * -0.5 + offsetInWorldCoordX,
++			  vpSize.y () * sy * 0.5 - offsetInWorldCoordY, 0.0f);
++    sTransform.scale (worldScaleFactorX, worldScaleFactorY, 1.0f);
+ 
+     if (optionGetDeform () == DeformCurve)
+ 	sTransform.translate ((vpSize.x () - 1) * sx * 0.5, 0.0, 0.0);
+@@ -936,90 +1184,29 @@
+ 
+     expoActive = true;
+ 
+-    for (j = 0; j < vpSize.y (); j++)
+-    {
+-	GLMatrix sTransform2 (sTransform), sTransform3;
+-
+-	for (i = 0; i < vpSize.x (); i++)
+-	{
+-	    if (optionGetExpoAnimation () == ExpoAnimationVortex)
+-		sTransform2.rotate (360 * expoCam,
+-				    0.0f, 1.0f, 2.0f * expoCam);
+-
+-	    sTransform3 = sTransform2;
+-
+-	    sTransform3.translate (output->x () / output->width (),
+-				   -output->y () / output->height (), 0.0);
+-
+-	    cScreen->setWindowPaintOffset ((screen->vp ().x () - i) *
+-					   screen->width (),
+-					   (screen->vp ().y () - j) *
+-					   screen->height ());
+-
+-	    vp = (j * vpSize.x ()) + i;
+-
+-	    vpp = (expoCam * vpActivity[vp]) + (1 - expoCam);
+-	    vpp = sigmoidProgress (vpp);
+-
+-	    vpBrightness = vpp + ((1.0 - vpp) *
+-				  optionGetVpBrightness () / 100.0);
+-	    vpSaturation = vpp + ((1.0 - vpp) *
+-				  optionGetVpSaturation () / 100.0);
++    for (int j = 0; j < screen->vpSize ().height (); j++)
++	for (int i = 0; i < screen->vpSize().width (); i++)
++	    paintViewport (attrib, sTransform, region, output, mask, CompPoint (i, j), vpCamPos, reflection);
+ 
+-	    paintingVp.set (i, j);
++    paintingDndWindow = true;
+ 
+-	    if (optionGetDeform () == DeformCurve)
+-	    {
+-		float rotateX;
+-
+-		sTransform3.translate (-vpCamPos[GLVector::x], 0.0f,
+-				       curveDistance - DEFAULT_Z_CAMERA);
+-
+-		rotateX = -i + interpolate (((float) vpSize.x () / 2.0) - 0.5,
+-					    screen->vp ().x (), progress);
+-
+-		sTransform3.rotate (curveAngle * rotateX, 0.0, 1.0, 0.0);
+-
+-		sTransform3.translate (vpCamPos[GLVector::x], 0.0f,
+-				       DEFAULT_Z_CAMERA - curveDistance);
+-	    }
+-
+-	    gScreen->glPaintTransformedOutput (attrib, sTransform3,
+-					       screen->region (), output,
+-					       mask);
+-
+-	    if (!reflection)
+-	    {
+-		int cursor[2] = { pointerX, pointerY };
++    foreach (CompWindow *dndWindow, dndWindows)
++    {
++	CompPoint vp;
+ 
+-		invertTransformedVertex (attrib, sTransform3,
+-					 output, cursor);
++	screen->viewportForGeometry (dndWindow->geometry (), vp);
+ 
+-		if ((cursor[0] > 0) && (cursor[0] < (int) screen->width ()) &&
+-		    (cursor[1] > 0) && (cursor[1] < (int) screen->height ()))
+-		{
+-		    newCursor.setX (i * screen->width () + cursor[0]);
+-		    newCursor.setY (j * screen->height () + cursor[1]);
++	while (vp.x () < 0)
++	    vp.setX (screen->vpSize ().width () + vp.x ());
+ 
+-		    if (anyClick || dndState != DnDNone)
+-		    {
+-			/* Used to save last viewport interaction was in */
+-			lastSelectedVp = selectedVp;
+-			selectedVp.set (i, j);
+-			anyClick = false;
+-		    }
+-		}
+-	    }
++	while (vp.y () < 0)
++	    vp.setY (screen->vpSize ().height () + vp.y ());
+ 
+-	    /* not sure this will work with different resolutions */
+-	    if (optionGetDeform () != DeformCurve)
+-		sTransform2.translate (sx + gapX, 0.0f, 0.0);
+-	}
+-
+-	/* not sure this will work with different resolutions */
+-	sTransform.translate (0.0, -(sy + gapY), 0.0f);
++	paintViewport (attrib, sTransform, infiniteRegion, output, mask, vp, vpCamPos, reflection);
+     }
+ 
++    paintingDndWindow = false;
++
+ //    glNormal3f (0.0, 0.0, -1.0);
+ 
+     if (reflection)
+@@ -1187,12 +1374,16 @@
+ 
+     expoActive = false;
+ 
+-    cScreen->setWindowPaintOffset (0, 0);
+-
+     gScreen->glPaintTransformedOutputSetCurrentIndex (glPaintTransformedOutputIndex);
+     gScreen->setTextureFilter (oldFilter);
+ }
+ 
++const CompWindowList &
++ExpoScreen::getWindowPaintList ()
++{
++    return dndWindows;
++}
++
+ bool
+ ExpoScreen::glPaintOutput (const GLScreenPaintAttrib& attrib,
+ 			   const GLMatrix&            transform,
+@@ -1243,10 +1434,15 @@
+ 
+ bool
+ ExpoWindow::glDraw (const GLMatrix&     transform,
+-                    const GLWindowPaintAttrib &attrib,
++		    const GLWindowPaintAttrib &attrib,
+ 		    const CompRegion&   region,
+ 		    unsigned int        mask)
+ {
++    GLMatrix wTransform (transform);
++    CompPoint vp;
++
++    screen->viewportForGeometry (window->geometry (), vp);
++
+     if (eScreen->expoCam == 0.0f)
+ 	return gWindow->glDraw (transform, attrib, region, mask);
+ 
+@@ -1275,8 +1471,11 @@
+ 	    }
+ 	}
+ 
+-	eAttrib.brightness = attrib.brightness * eScreen->vpBrightness;
+-	eAttrib.saturation = attrib.saturation * eScreen->vpSaturation;
++	if ((vp == eScreen->paintingVp || window->onAllViewports ()) && !eScreen->paintingDndWindow)
++	{
++	    eAttrib.brightness = attrib.brightness * eScreen->vpBrightness;
++	    eAttrib.saturation = attrib.saturation * eScreen->vpSaturation;
++	}
+     }
+     else
+     {
+@@ -1287,7 +1486,79 @@
+ 	                              (1 - sigmoidProgress (eScreen->expoCam));
+     }
+ 
+-    return gWindow->glDraw (transform, eAttrib, region, mask);
++    bool status = gWindow->glDraw (transform, eAttrib, region, mask);
++
++    if (window->type () & CompWindowTypeDesktopMask)
++    {
++	/* We want to set the geometry of the polka dots to the window
++	 * region */
++	CompRegion reg = CompRegion (0, 0, window->width (), window->height ());
++
++	foreach(GLTexture * tex, eScreen->polkadots_texture)
++	{
++	    GLTexture::MatrixList matl;
++	    GLTexture::Matrix     mat = tex->matrix();
++	    CompRegion            paintRegion(region);
++
++	    float xScale = screen->width () / (float) eScreen->viewport_size.width ();
++	    float yScale = screen->height () / (float) eScreen->viewport_size.height ();
++
++	    mat.xx *= xScale;
++	    mat.yy *= yScale;
++
++	    /* Not sure what this does, but it is necessary
++	     * (adjusts for scale?) */
++	    mat.x0 -= mat.xx * reg.boundingRect().x1();
++	    mat.y0 -= mat.yy * reg.boundingRect().y1();
++
++	    matl.push_back(mat);
++
++	    if (mask & PAINT_WINDOW_TRANSFORMED_MASK)
++		paintRegion = infiniteRegion;
++
++	    /* Now allow plugins to mess with the geometry of our
++	     * dim (so we get a nice render for things like
++	     * wobbly etc etc */
++	    gWindow->vertexBuffer ()->begin ();
++	    gWindow->glAddGeometry (matl, reg, paintRegion);
++	    if (gWindow->vertexBuffer ()->end ())
++	    {
++		unsigned int glDrawTextureIndex = gWindow->glDrawTextureGetCurrentIndex ();
++		eAttrib.opacity = attrib.opacity * (((1.0 - eScreen->vpBrightness) + (1.0 - eScreen->vpSaturation) / 2.0));
++		/* Texture rendering set-up */
++		//eScreen->gScreen->setTexEnvMode(GL_MODULATE);
++		glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
++		/* Draw the dim texture with all of it's modified
++		* geometry glory */
++		gWindow->glDrawTextureSetCurrentIndex (MAXSHORT);
++		gWindow->glDrawTexture (tex, transform, eAttrib, mask |
++					PAINT_WINDOW_BLEND_MASK |
++					PAINT_WINDOW_TRANSLUCENT_MASK |
++					PAINT_WINDOW_TRANSFORMED_MASK);
++		gWindow->glDrawTextureSetCurrentIndex (glDrawTextureIndex);
++		/* Texture rendering tear-down */
++		glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
++		eScreen->gScreen->setTexEnvMode (GL_REPLACE);
++	    }
++	}
++
++	/* Paint the outline */
++	if (mGlowQuads && eScreen->paintingVp == eScreen->selectedVp)
++	{
++	    if (region.numRects ())
++	    {
++		/* reset geometry and paint */
++		gWindow->vertexBuffer ()->begin ();
++		gWindow->vertexBuffer ()->end ();
++
++		paintGlow (transform, attrib, infiniteRegion, mask);
++	    }
++	}
++
++  }
++
++  return status;
++
+ }
+ 
+ #define EXPO_GRID_SIZE 100
+@@ -1425,11 +1696,17 @@
+ 		     const CompRegion&          region,
+ 		     unsigned int               mask)
+ {
++    GLMatrix            wTransform (transform);
++    GLWindowPaintAttrib wAttrib (attrib);
++    CompRegion          clip (region);
++
+     if (eScreen->expoActive)
+     {
+ 	float opacity = 1.0;
+ 	bool  hide;
+ 	bool  zoomAnim;
++	CompPoint vp;
++	screen->viewportForGeometry (window->geometry (), vp);
+ 
+ 	zoomAnim = eScreen->optionGetExpoAnimation () ==
+ 	           ExpoScreen::ExpoAnimationZoom;
+@@ -1458,9 +1735,47 @@
+ 
+ 	if (opacity <= 0)
+ 	    mask |= PAINT_WINDOW_NO_CORE_INSTANCE_MASK;
++	else
++	    wAttrib.opacity = wAttrib.opacity * opacity;
++
++	/* Stretch maximized windows a little so that you don't
++	 * have an awkward gap */
++
++	if (window->state () & MAXIMIZE_STATE &&
++		!window->border ().top)
++	{
++	    CompOutput *o = &screen->outputDevs ()[screen->outputDeviceForGeometry(window->geometry())];
++	    float yS = 1.0 + ((o->height () / (float) window->height ()) - 1.0f) * sigmoidProgress (eScreen->expoCam);
++	    float xS = 1.0 + ((o->width () / (float) window->width ()) - 1.0f) * sigmoidProgress (eScreen->expoCam);
++	    wTransform.translate (window->x () + window->width (),
++				  window->y () + window->height (),
++				  0.0f);
++	    wTransform.scale (xS, yS, 1.0f);
++	    wTransform.translate (-(window->x () + window->width ()),
++				  -(window->y () + window->height ()),
++				  0.0f);
++
++	    if (eScreen->paintingVp != vp)
++		mask |= PAINT_WINDOW_NO_CORE_INSTANCE_MASK;
++
++	    mask |= PAINT_WINDOW_TRANSFORMED_MASK;
++	}
++	
++	if (std::find (eScreen->dndWindows.begin(), eScreen->dndWindows.end (), window) != eScreen->dndWindows.end ())
++	{
++	    if (!eScreen->paintingDndWindow)
++	    {
++		mask |= PAINT_WINDOW_NO_CORE_INSTANCE_MASK;
++	    }
++	    else
++	    {
++		mask |= PAINT_WINDOW_TRANSFORMED_MASK;
++		clip = infiniteRegion;
++	    }
++	}
+     }
+ 
+-    return gWindow->glPaint (attrib, transform, region, mask);
++    return gWindow->glPaint (wAttrib, wTransform, clip, mask);
+ }
+ 
+ bool
+@@ -1489,7 +1804,7 @@
+     expoActive (false),
+     expoMode (false),
+     dndState (DnDNone),
+-    dndWindow (NULL),
++    dndWindows (0),
+     origVp (s->vp ()),
+     selectedVp (s->vp ()),
+     lastSelectedVp (s->vp ()),
+@@ -1497,14 +1812,21 @@
+     clickTime (0),
+     doubleClick (false),
+     vpNormals (360 * 3),
+-    grabIndex (0)
+-{
++    grabIndex (0),
++    paintingDndWindow (false),
++    mGlowTextureProperties (&glowTextureProperties)
++{
++    CompString fname;
++    CompString pname = "expo";
++    CompSize   size;
++
++
+     leftKey  = XKeysymToKeycode (s->dpy (), XStringToKeysym ("Left"));
+     rightKey = XKeysymToKeycode (s->dpy (), XStringToKeysym ("Right"));
+     upKey    = XKeysymToKeycode (s->dpy (), XStringToKeysym ("Up"));
+     downKey  = XKeysymToKeycode (s->dpy (), XStringToKeysym ("Down"));
+ 
+-    dragCursor = XCreateFontCursor (screen->dpy (), XC_fleur);
++    mMoveCursor = XCreateFontCursor (screen->dpy (), XC_fleur);
+ 
+     EXPOINITBIND (ExpoKey, doExpo);
+     EXPOTERMBIND (ExpoKey, termExpo);
+@@ -1522,12 +1844,58 @@
+     ScreenInterface::setHandler (screen, false);
+     CompositeScreenInterface::setHandler (cScreen, false);
+     GLScreenInterface::setHandler (gScreen, false);
++
++    outline_texture = GLTexture::imageDataToTexture (mGlowTextureProperties->textureData,
++						     CompSize (mGlowTextureProperties->textureSize,
++							       mGlowTextureProperties->textureSize),
++						     GL_RGBA, GL_UNSIGNED_BYTE);
++    fname = "texture_tile.png";
++    polkadots_texture = GLTexture::readImageToTexture (fname, pname, polkadots_texture_size);
++
++    if (polkadots_texture.empty ())
++	compLogMessage ("expo", CompLogLevelWarn, "failed to bind image to texture");
++    else
++    {
++	foreach (GLTexture *tex, polkadots_texture)
++	{
++	    tex->enable (GLTexture::Good);
++	    glTexParameteri (tex->target (), GL_TEXTURE_WRAP_S, GL_REPEAT);
++	    glTexParameteri (tex->target (), GL_TEXTURE_WRAP_T, GL_REPEAT);
++	    tex->disable ();
++	}
++    }
+ }
+ 
+ ExpoScreen::~ExpoScreen ()
+ {
+-    if (dragCursor != None)
+-	XFreeCursor (screen->dpy (), dragCursor);
++    if (mMoveCursor)
++	XFreeCursor (screen->dpy (), mMoveCursor);
++}
++
++void
++ExpoWindow::moveNotify (int dx, int dy, bool immediate)
++{   
++    window->moveNotify (dx, dy, immediate);
++
++    if (!ExpoScreen::get (screen)->expoActive)
++	return;
++
++    updateViewportActiveStates (screen);
++}
++
++void
++ExpoWindow::resizeNotify(int dx, int dy, int dw, int dh)
++{
++    window->resizeNotify (dx, dy, dw, dh);
++
++    /* mGlowQuads contains positional info, so we need to recalc that */
++    if (mGlowQuads)
++    {
++	/* FIXME: we need to find a more multitexture friendly way
++	 * of doing this */
++	GLTexture::Matrix tMat = eScreen->outline_texture.at (0)->matrix ();
++	computeGlowQuads (&tMat);
++    }
+ }
+ 
+ ExpoWindow::ExpoWindow (CompWindow *w) :
+@@ -1535,10 +1903,28 @@
+     window (w),
+     cWindow (CompositeWindow::get (w)),
+     gWindow (GLWindow::get (w)),
+-    eScreen (ExpoScreen::get (screen))
++    eScreen (ExpoScreen::get (screen)),
++    dndOpacity (0.0f),
++    mGlowQuads (NULL)
+ {
+     CompositeWindowInterface::setHandler (cWindow, false);
+     GLWindowInterface::setHandler (gWindow, false);
++    WindowInterface::setHandler (window, true);
++
++    if (window->type () & CompWindowTypeDesktopMask)
++    {
++	foreach (GLTexture *tex, eScreen->outline_texture)
++	{
++	    GLTexture::Matrix mat = tex->matrix ();
++	    computeGlowQuads (&mat);
++	}
++    }
++}
++
++ExpoWindow::~ExpoWindow ()
++{
++    eScreen->dndWindows.remove (window);
++    computeGlowQuads (NULL);
+ }
+ 
+ bool
+Index: ubuntu/plugins/expo/src/expo.h
+===================================================================
+--- ubuntu.orig/plugins/expo/src/expo.h	2012-09-08 17:26:40.599035911 +0800
++++ ubuntu/plugins/expo/src/expo.h	2012-09-12 22:20:43.276760475 +0800
+@@ -30,6 +30,44 @@
+ #include <opengl/opengl.h>
+ 
+ #include "expo_options.h"
++#include "glow.h"
++#include "viewport-member-window.h"
++#include "client-list-generator.h"
++
++#define WIN_REAL_X(w) (w->x () - w->border ().left)
++#define WIN_REAL_Y(w) (w->y () - w->border ().top)
++#define WIN_REAL_WIDTH(w) (w->width () + 2 * w->geometry ().border () + \
++			   w->border ().left + w->border ().right)
++#define WIN_REAL_HEIGHT(w) (w->height () + 2 * w->geometry ().border () + \
++			    w->border ().top + w->border ().bottom)
++
++namespace compiz
++{
++    namespace expo
++    {
++	namespace impl
++	{
++	    namespace ce = compiz::expo;
++
++	    class CompizClientListGenerator :
++		public ce::ClientListGenerator
++	    {
++		public:
++
++		    CompizClientListGenerator (CompScreen *screen);
++
++		    void refreshClientList ();
++		    ViewportMemberWindow * nextClient ();
++
++		private:
++
++		    CompScreen                 *mScreen;
++		    const CompWindowVector     *mClientList;
++		    CompWindowVector::const_iterator mClientListIterator;
++	    };
++	}
++    }
++}
+ 
+ class ExpoScreen :
+     public ScreenInterface,
+@@ -51,8 +89,10 @@
+ 	bool glPaintOutput (const GLScreenPaintAttrib&, const GLMatrix&,
+ 			    const CompRegion&, CompOutput *, unsigned int);
+ 	void glPaintTransformedOutput (const GLScreenPaintAttrib&,
+-				       const GLMatrix&, const CompRegion&,
+-				       CompOutput *, unsigned int);
++	                               const GLMatrix&, const CompRegion&,
++	                               CompOutput*, unsigned int);
++
++	const CompWindowList & getWindowPaintList ();
+ 
+ 	bool dndInit (CompAction *, CompAction::State, CompOption::Vector&);
+ 	bool dndFini (CompAction *, CompAction::State, CompOption::Vector&);
+@@ -62,6 +102,8 @@
+ 	bool nextVp (CompAction *, CompAction::State, CompOption::Vector&);
+ 	bool prevVp (CompAction *, CompAction::State, CompOption::Vector&);
+ 
++	CompPoint currentViewport ();
++
+ 	typedef enum {
+ 	    DnDNone,
+ 	    DnDDuring,
+@@ -82,7 +124,7 @@
+ 	bool  expoMode;
+ 
+ 	DnDState   dndState;
+-	CompWindow *dndWindow;
++	CompWindowList dndWindows;
+ 
+ 	CompPoint prevCursor;
+ 	CompPoint newCursor;
+@@ -94,6 +136,7 @@
+ 	CompPoint paintingVp;
+ 
+ 	std::vector<float> vpActivity;
++	std::vector<bool>  vpActive;
+ 	float              vpBrightness;
+ 	float              vpSaturation;
+ 
+@@ -113,6 +156,17 @@
+ 
+ 	CompScreen::GrabHandle grabIndex;
+ 
++	GLTexture::List polkadots_texture;
++	CompSize        polkadots_texture_size;
++	CompSize        viewport_size;
++
++	GLTexture::List outline_texture;
++	CompSize        outline_texture_size;
++
++	bool paintingDndWindow;
++
++	const GlowTextureProperties *mGlowTextureProperties;
++
+     private:
+ 	void moveFocusViewport (int, int);
+ 	void finishWindowMovement ();
+@@ -123,24 +177,45 @@
+ 	void paintWall (const GLScreenPaintAttrib&, const GLMatrix&,
+ 			const CompRegion&, CompOutput *, unsigned int, bool);
+ 
++	void paintViewport (const GLScreenPaintAttrib& attrib,
++			    const GLMatrix&            transform,
++			    const CompRegion&          region,
++			    CompOutput                 *output,
++			    unsigned int               mask,
++			    CompPoint                  vpPos,
++			    GLVector                   &vpCamPos,
++			    bool                       reflection);
++
++	bool windowsOnVp (compiz::expo::ClientListGenerator &clientList,
++			  CompPoint                         &p,
++			  const CompPoint		    &unprojectedCursor,
++			  const CompSize		    &screenSize,
++			  CompScreen			    *screen);
++
+ 	KeyCode leftKey;
+ 	KeyCode rightKey;
+ 	KeyCode upKey;
+ 	KeyCode downKey;
+ 
+-	Cursor dragCursor;
++	Cursor  mMoveCursor;
+ };
+ 
+ class ExpoWindow :
++    public compiz::expo::ViewportMemberWindow,
+     public CompositeWindowInterface,
+     public GLWindowInterface,
++    public WindowInterface,
+     public PluginClassHandler<ExpoWindow, CompWindow>
+ {
+     public:
+ 	ExpoWindow (CompWindow *);
++	~ExpoWindow ();
+ 
+ 	bool damageRect (bool, const CompRect&);
+ 
++	void resizeNotify (int dx, int dy, int dw, int dh);
++	void moveNotify (int dx, int dy, bool immediate);
++
+ 	bool glDraw (const GLMatrix&, const GLWindowPaintAttrib&,
+ 		     const CompRegion&, unsigned int);
+ 	bool glPaint (const GLWindowPaintAttrib&, const GLMatrix&,
+@@ -150,11 +225,31 @@
+ 			    unsigned int, unsigned int);
+ 	void glDrawTexture (GLTexture*, const GLMatrix&,
+ 	                    const GLWindowPaintAttrib&, unsigned int);
++	void
++	paintGlow (const GLMatrix            &transform,
++	           const GLWindowPaintAttrib &attrib,
++		   const CompRegion	     &paintRegion,
++		   unsigned int		     mask);
++
++	void
++	computeGlowQuads (GLTexture::Matrix *matrix);
+ 
+ 	CompWindow      *window;
+ 	CompositeWindow *cWindow;
+ 	GLWindow        *gWindow;
+ 	ExpoScreen      *eScreen;
++
++	float           dndOpacity;
++
++	GlowQuad *mGlowQuads;
++
++    private:
++
++	bool isDesktopOrDock () const;
++	bool dragged () const;
++	const compiz::window::Geometry & absoluteGeometry () const;
++
++	mutable compiz::window::Geometry mAbsoluteGeometry;
+ };
+ 
+ class ExpoPluginVTable :
+Index: ubuntu/plugins/expo/src/glow.cpp
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/glow.cpp	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,429 @@
++/**
++ *
++ * Compiz group plugin
++ *
++ * glow.cpp
++ *
++ * Copyright : (C) 2006-2010 by Patrick Niklaus, Roi Cohen,
++ * 				Danny Baumann, Sam Spilsbury
++ * Authors: Patrick Niklaus <patrick.niklaus@googlemail.com>
++ *          Roi Cohen       <roico.beryl@gmail.com>
++ *          Danny Baumann   <maniac@opencompositing.org>
++ * 	    Sam Spilsbury   <smspillaz@gmail.com>
++ *
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++
++#include "expo.h"
++#include "group_glow.h"
++
++const GlowTextureProperties glowTextureProperties = {
++    /* GlowTextureRectangular */
++    glowTexRect, 32, 21
++};
++
++/*
++ * GroupWindow::paintGlow
++ *
++ * Takes our glow texture, stretches the appropriate positions in the glow texture,
++ * adds those geometries (so plugins like wobby and deform this texture correctly)
++ * and then draws the glow texture with this geometry (plugins like wobbly and friends
++ * will automatically deform the texture based on our set geometry)
++ */
++
++void
++ExpoWindow::paintGlow (const GLMatrix            &transform,
++                       const GLWindowPaintAttrib &attrib,
++                       const CompRegion          &paintRegion,
++                       unsigned int               mask)
++{
++    CompRegion      reg;
++    int             i;
++    GLushort        colorData[4];
++    const GLushort *selColorData = ExpoScreen::get (screen)->optionGetSelectedColor ();
++    float           alpha = (float) selColorData[3] / 65535.0f;
++
++    /* Premultiply color */
++    colorData[0] = selColorData[0] * alpha;
++    colorData[1] = selColorData[1] * alpha;
++    colorData[2] = selColorData[2] * alpha;
++    colorData[3] = selColorData[3];
++
++    gWindow->vertexBuffer ()->begin ();
++
++    /* There are 8 glow parts of the glow texture which we wish to paint
++     * separately with different transformations
++     */
++    for (i = 0; i < NUM_GLOWQUADS; i++)
++    {
++	/* Using precalculated quads here */
++	reg = CompRegion (mGlowQuads[i].mBox);
++
++	if (reg.boundingRect ().x1 () < reg.boundingRect ().x2 () &&
++	    reg.boundingRect ().y1 () < reg.boundingRect ().y2 ())
++	{
++	    GLTexture::MatrixList matl;
++	    reg = CompRegion (reg.boundingRect ().x1 (),
++			      reg.boundingRect ().y1 (),
++			      reg.boundingRect ().width (),
++			      reg.boundingRect ().height ());
++
++	    matl.push_back (mGlowQuads[i].mMatrix);
++	    /* Add color data for all 6 vertices of the quad */
++	    for (int n = 0; n < 6; n++)
++		gWindow->vertexBuffer ()->addColors (1, colorData);
++	    gWindow->glAddGeometry (matl, reg, paintRegion);
++	}
++    }
++
++    if (gWindow->vertexBuffer ()->end ())
++    {
++	//GLScreen::get (screen)->setTexEnvMode (GL_MODULATE);
++	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
++
++	/* we use PAINT_WINDOW_TRANSFORMED_MASK here to force
++	the usage of a good texture filter */
++	foreach (GLTexture *tex, ExpoScreen::get (screen)->outline_texture)
++	{
++	    gWindow->glDrawTexture (tex, transform, attrib, mask | 
++				    PAINT_WINDOW_BLEND_MASK       |
++				    PAINT_WINDOW_TRANSLUCENT_MASK |
++				    PAINT_WINDOW_TRANSFORMED_MASK);
++	}
++
++	glBlendFunc (GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
++	GLScreen::get (screen)->setTexEnvMode (GL_REPLACE);
++    }
++}
++
++/*
++ * ExpoWindow::computeGlowQuads
++ *
++ * This function computures the matrix transformation required for each
++ * part of the glow texture which we wish to stretch to some rectangular
++ * dimentions
++ *
++ * There are eight quads different parts of the texture which we wish to
++ * paint here, the 4 sides and four corners, eg:
++ *
++ *		     ------------------
++ *		     | 1 |   4    | 6 |
++ * -------------     ------------------
++ * | 1 | 4 | 6 |     |   |        |   |
++ * -------------     |   |	  |   |
++ * | 2 | n | 7 | ->  | 2 |   n    | 7 |
++ * -------------     |   |        |   |
++ * | 3 | 5 | 8 |     |   |        |   |
++ * -------------     ------------------
++ *		     | 3 |   5    | 8 |
++ *		     ------------------
++ *
++ * In this example here, 2, 4, 5 and 7 are stretched, and the matrices for
++ * each quad rect adjusted accordingly for it's size compared to the original
++ * texture size.
++ *
++ * When we are adjusting the matrices here, the initial size of each corner has
++ * a size of of "1.0f", so according to 2x2 matrix rules,
++ * the scale factor is the inverse of the size of the glow (which explains
++ * while you will see here that matrix->xx is (1 / glowSize)
++ * where glowSize is the size the user specifies they want their glow to extend.
++ * (likewise, matrix->yy is adjusted similarly for corners and for top/bottom)
++ *
++ * matrix->x0 and matrix->y0 here are set to be the top left edge of the rect
++ * adjusted by the matrix scale factor (matrix->xx and matrix->yy)
++ *
++ */
++void
++ExpoWindow::computeGlowQuads (GLTexture::Matrix *matrix)
++{
++    CompRect	      *box;
++    int		      x1, x2, y1, y2;
++    GLTexture::Matrix *quadMatrix;
++    int               glowSize, glowOffset;
++    CompWindow	      *w = window;
++
++    /* Passing NULL to this function frees the glow quads
++     * (so the window is not painted with glow) */
++
++    if (matrix)
++    {
++	if (!mGlowQuads)
++	    mGlowQuads = new GlowQuad[NUM_GLOWQUADS];
++	if (!mGlowQuads)
++	    return;
++    }
++    else
++    {
++	if (mGlowQuads)
++	{
++	    delete[] mGlowQuads;
++	    mGlowQuads = NULL;
++	}
++	return;
++    }
++
++    glowSize = 48;
++    glowOffset = (glowSize * ExpoScreen::get (screen)->mGlowTextureProperties->glowOffset /
++		  ExpoScreen::get (screen)->mGlowTextureProperties->textureSize) + 1;
++
++    /* Top left corner */
++    box = &mGlowQuads[GLOWQUAD_TOPLEFT].mBox;
++    mGlowQuads[GLOWQUAD_TOPLEFT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_TOPLEFT].mMatrix;
++
++    /* Set the desired rect dimentions
++     * for the part of the glow we are painting */
++
++    x1 = WIN_REAL_X (w) - glowSize + glowOffset;
++    y1 = WIN_REAL_Y (w) - glowSize + glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * Scaling both parts of the texture in a positive direction
++     * here (left to right top to bottom)
++     *
++     * The base position (x0 and y0) here requires us to move backwards
++     * on the x and y dimentions by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = 1.0f / glowSize;
++    quadMatrix->yy = 1.0f / (glowSize);
++    quadMatrix->x0 = -(x1 * quadMatrix->xx);
++    quadMatrix->y0 = -(y1 * quadMatrix->yy);
++
++    x2 = MIN (WIN_REAL_X (w) + glowOffset,
++	      WIN_REAL_X (w) + (WIN_REAL_WIDTH (w) / 2));
++    y2 = MIN (WIN_REAL_Y (w) + glowOffset,
++	      WIN_REAL_Y (w) + (WIN_REAL_HEIGHT (w) / 2));
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Top right corner */
++    box = &mGlowQuads[GLOWQUAD_TOPRIGHT].mBox;
++    mGlowQuads[GLOWQUAD_TOPRIGHT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_TOPRIGHT].mMatrix;
++
++    /* Set the desired rect dimentions
++     * for the part of the glow we are painting */
++
++    x1 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset;
++    y1 = WIN_REAL_Y (w) - glowSize + glowOffset;
++    x2 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) + glowSize - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * Scaling the y part of the texture in a positive direction
++     * and the x part in a negative direction here
++     * (right to left top to bottom)
++     *
++     * The base position (x0 and y0) here requires us to move backwards
++     * on the y dimention and forwards on x by the calculated rect dimentions
++     * multiplied by the scale factors (since we are moving forward on x we
++     * need the inverse of that which is 1 - x1 * xx
++     */
++
++    quadMatrix->xx = -1.0f / glowSize;
++    quadMatrix->yy = 1.0f / glowSize;
++    quadMatrix->x0 = 1.0 - (x1 * quadMatrix->xx);
++    quadMatrix->y0 = -(y1 * quadMatrix->yy);
++
++    x1 = MAX (WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset,
++	      WIN_REAL_X (w) + (WIN_REAL_WIDTH (w) / 2));
++    y2 = MIN (WIN_REAL_Y (w) + glowOffset,
++	      WIN_REAL_Y (w) + (WIN_REAL_HEIGHT (w) / 2));
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Bottom left corner */
++    box = &mGlowQuads[GLOWQUAD_BOTTOMLEFT].mBox;
++    mGlowQuads[GLOWQUAD_BOTTOMLEFT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_BOTTOMLEFT].mMatrix;
++
++    x1 = WIN_REAL_X (w) - glowSize + glowOffset;
++    y1 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset;
++    x2 = WIN_REAL_X (w) + glowOffset;
++    y2 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) + glowSize - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * Scaling the x part of the texture in a positive direction
++     * and the y part in a negative direction here
++     * (left to right bottom to top)
++     *
++     * The base position (x0 and y0) here requires us to move backwards
++     * on the x dimention and forwards on y by the calculated rect dimentions
++     * multiplied by the scale factors (since we are moving forward on x we
++     * need the inverse of that which is 1 - y1 * yy
++     */
++
++    quadMatrix->xx = 1.0f / glowSize;
++    quadMatrix->yy = -1.0f / glowSize;
++    quadMatrix->x0 = -(x1 * quadMatrix->xx);
++    quadMatrix->y0 = 1.0f - (y1 * quadMatrix->yy);
++
++    y1 = MAX (WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset,
++	      WIN_REAL_Y (w) + (WIN_REAL_HEIGHT (w) / 2));
++    x2 = MIN (WIN_REAL_X (w) + glowOffset,
++	      WIN_REAL_X (w) + (WIN_REAL_WIDTH (w) / 2));
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Bottom right corner */
++    box = &mGlowQuads[GLOWQUAD_BOTTOMRIGHT].mBox;
++    mGlowQuads[GLOWQUAD_BOTTOMRIGHT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_BOTTOMRIGHT].mMatrix;
++
++    x1 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset;
++    y1 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset;
++    x2 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) + glowSize - glowOffset;
++    y2 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) + glowSize - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * Scaling the both parts of the texture in a negative direction
++     * (right to left bottom to top)
++     *
++     * The base position (x0 and y0) here requires us to move forwards
++     * on both dimentions by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = -1.0f / glowSize;
++    quadMatrix->yy = -1.0f / glowSize;
++    quadMatrix->x0 = 1.0 - (x1 * quadMatrix->xx);
++    quadMatrix->y0 = 1.0 - (y1 * quadMatrix->yy);
++
++    x1 = MAX (WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset,
++	      WIN_REAL_X (w) + (WIN_REAL_WIDTH (w) / 2));
++    y1 = MAX (WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset,
++	      WIN_REAL_Y (w) + (WIN_REAL_HEIGHT (w) / 2));
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Top edge */
++    box = &mGlowQuads[GLOWQUAD_TOP].mBox;
++    mGlowQuads[GLOWQUAD_TOP].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_TOP].mMatrix;
++
++    x1 = WIN_REAL_X (w) + glowOffset;
++    y1 = WIN_REAL_Y (w) - glowSize + glowOffset;
++    x2 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset;
++    y2 = WIN_REAL_Y (w) + glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * No need to scale the x part of the texture here, but we
++     * are scaling on the y part in a positive direciton
++     *
++     * The base position (y0) here requires us to move backwards
++     * on the x dimention and forwards on y by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = 0.0f;
++    quadMatrix->yy = 1.0f / glowSize;
++    quadMatrix->x0 = 1.0;
++    quadMatrix->y0 = -(y1 * quadMatrix->yy);
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Bottom edge */
++    box = &mGlowQuads[GLOWQUAD_BOTTOM].mBox;
++    mGlowQuads[GLOWQUAD_BOTTOM].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_BOTTOM].mMatrix;
++
++    x1 = WIN_REAL_X (w) + glowOffset;
++    y1 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset;
++    x2 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset;
++    y2 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) + glowSize - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * No need to scale the x part of the texture here, but we
++     * are scaling on the y part in a negative direciton
++     *
++     * The base position (y0) here requires us to move forwards
++     * on y by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = 0.0f;
++    quadMatrix->yy = -1.0f / glowSize;
++    quadMatrix->x0 = 1.0;
++    quadMatrix->y0 = 1.0 - (y1 * quadMatrix->yy);
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Left edge */
++    box = &mGlowQuads[GLOWQUAD_LEFT].mBox;
++    mGlowQuads[GLOWQUAD_LEFT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_LEFT].mMatrix;
++
++    x1 = WIN_REAL_X (w) - glowSize + glowOffset;
++    y1 = WIN_REAL_Y (w) + glowOffset;
++    x2 = WIN_REAL_X (w) + glowOffset;
++    y2 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * No need to scale the y part of the texture here, but we
++     * are scaling on the x part in a positive direciton
++     *
++     * The base position (x0) here requires us to move backwards
++     * on x by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = 1.0f / glowSize;
++    quadMatrix->yy = 0.0f;
++    quadMatrix->x0 = -(x1 * quadMatrix->xx);
++    quadMatrix->y0 = 1.0;
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++
++    /* Right edge */
++    box = &mGlowQuads[GLOWQUAD_RIGHT].mBox;
++    mGlowQuads[GLOWQUAD_RIGHT].mMatrix = *matrix;
++    quadMatrix = &mGlowQuads[GLOWQUAD_RIGHT].mMatrix;
++
++    x1 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) - glowOffset;
++    y1 = WIN_REAL_Y (w) + glowOffset;
++    x2 = WIN_REAL_X (w) + WIN_REAL_WIDTH (w) + glowSize - glowOffset;
++    y2 = WIN_REAL_Y (w) + WIN_REAL_HEIGHT (w) - glowOffset;
++
++    /* 2x2 Matrix here, adjust both x and y scale factors
++     * and the x and y position
++     *
++     * No need to scale the y part of the texture here, but we
++     * are scaling on the x part in a negative direciton
++     *
++     * The base position (x0) here requires us to move forwards
++     * on x by the calculated rect dimentions
++     * multiplied by the scale factors
++     */
++
++    quadMatrix->xx = -1.0f / glowSize;
++    quadMatrix->yy = 0.0f;
++    quadMatrix->x0 = 1.0 - (x1 * quadMatrix->xx);
++    quadMatrix->y0 = 1.0;
++
++    *box = CompRect (x1, y1, x2 - x1, y2 - y1);
++}
+Index: ubuntu/plugins/expo/src/glow.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/glow.h	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,66 @@
++/**
++ *
++ * Compiz group plugin
++ *
++ * glow.h
++ *
++ * Copyright : (C) 2006-2010 by Patrick Niklaus, Roi Cohen,
++ * 				Danny Baumann, Sam Spilsbury
++ * Authors: Patrick Niklaus <patrick.niklaus@googlemail.com>
++ *          Roi Cohen       <roico.beryl@gmail.com>
++ *          Danny Baumann   <maniac@opencompositing.org>
++ * 	    Sam Spilsbury   <smspillaz@gmail.com>
++ *
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++ 
++#ifndef _EXPO_GLOW_H
++#define _EXPO_GLOW_H
++ 
++#define GLOWQUAD_TOPLEFT	 0
++#define GLOWQUAD_TOPRIGHT	 1
++#define GLOWQUAD_BOTTOMLEFT	 2
++#define GLOWQUAD_BOTTOMRIGHT     3
++#define GLOWQUAD_TOP		 4
++#define GLOWQUAD_BOTTOM		 5
++#define GLOWQUAD_LEFT		 6
++#define GLOWQUAD_RIGHT		 7
++#define NUM_GLOWQUADS		 8
++
++/* Represents a particular glow texture, so here
++ * we have hardcoded in the texture data, the offset
++ * and the size of the texture
++ */
++
++typedef struct _GlowTextureProperties {
++    char *textureData;
++    int  textureSize;
++    int  glowOffset;
++} GlowTextureProperties;
++
++/* Each glow quad contains a 2x2 scale + positional matrix
++ * (the 3rd column is not used since that is for matrix skew
++ *  operations which we do not care about)
++ * and also a CompRect which describes the size and position of
++ * the quad on the glow
++ */
++
++class GlowQuad {
++    public:
++	CompRect	  mBox;
++	GLTexture::Matrix mMatrix;
++};
++
++extern const GlowTextureProperties glowTextureProperties;
++
++#endif
+Index: ubuntu/plugins/expo/src/group_glow.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/group_glow.h	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,197 @@
++#ifndef _GROUP_GLOWTEX_H
++#define _GROUP_GLOWTEX_H
++
++/**
++ *
++ * Compiz group plugin
++ *
++ * group_glow.h
++ *
++ * Copyright : (C) 2006-2010 by Patrick Niklaus, Roi Cohen,
++ * 				Danny Baumann, Sam Spilsbury
++ * Authors: Patrick Niklaus <patrick.niklaus@googlemail.com>
++ *          Roi Cohen       <roico.beryl@gmail.com>
++ *          Danny Baumann   <maniac@opencompositing.org>
++ * 	    Sam Spilsbury   <smspillaz@gmail.com>
++ *
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++
++/*
++ * glowTex
++ */
++
++static char glowTexRect[4097] = {
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377"
++  "\377\377\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377"
++  "\377\6\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\6\377\377\377\6\377\377"
++  "\377\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377"
++  "\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377\6"
++  "\377\377\377\14\377\377\377\14\377\377\377\14\377\377\377\14\377\377\377"
++  "\14\377\377\377\14\377\377\377\14\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\6\377\377\377\6\377\377\377\14"
++  "\377\377\377\14\377\377\377\22\377\377\377\22\377\377\377\22\377\377\377"
++  "\27\377\377\377\27\377\377\377\27\377\377\377\27\377\377\377\27\377\377\377"
++  "\27\377\377\377\27\377\377\377\27\377\377\377\27\377\377\377\27\377\377\377"
++  "\35\377\377\377\35\377\377\377\35\377\377\377\35\377\377\377\35\377\377\377"
++  "\35\377\377\377\35\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377"
++  "\377\6\377\377\377\6\377\377\377\14\377\377\377\22\377\377\377\27\377\377"
++  "\377\27\377\377\377\35\377\377\377#\377\377\377'\377\377\377'\377\377\377"
++  "+\377\377\377+\377\377\377+\377\377\377+\377\377\377+\377\377\377+\377\377"
++  "\377+\377\377\377+\377\377\377+\377\377\3771\377\377\3771\377\377\3771\377"
++  "\377\3771\377\377\3771\377\377\3771\377\377\3771\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\22\377\377\377"
++  "\27\377\377\377\35\377\377\377#\377\377\377+\377\377\3771\377\377\3776\377"
++  "\377\377<\377\377\377>\377\377\377C\377\377\377I\377\377\377I\377\377\377"
++  "I\377\377\377I\377\377\377I\377\377\377I\377\377\377I\377\377\377I\377\377"
++  "\377L\377\377\377L\377\377\377L\377\377\377L\377\377\377L\377\377\377L\377"
++  "\377\377L\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377"
++  "\377\377\22\377\377\377\27\377\377\377#\377\377\377+\377\377\3776\377\377"
++  "\377C\377\377\377L\377\377\377U\377\377\377]\377\377\377`\377\377\377d\377"
++  "\377\377h\377\377\377k\377\377\377k\377\377\377k\377\377\377k\377\377\377"
++  "k\377\377\377k\377\377\377k\377\377\377p\377\377\377p\377\377\377p\377\377"
++  "\377p\377\377\377p\377\377\377p\377\377\377p\0\0\0\0\0\0\0\0\0\0\0\0\377"
++  "\377\377\6\377\377\377\14\377\377\377\22\314\314\314\35\377\377\377'\377"
++  "\377\3771\377\377\377>\357\357\357P\377\377\377]\363\363\363k\365\365\365"
++  "v\365\365\365|\377\377\377\202\367\367\367\210\367\367\367\214\367\367\367"
++  "\216\367\367\367\221\367\367\367\221\367\367\367\221\367\367\367\221\367"
++  "\367\367\221\367\367\367\221\367\367\367\224\367\367\367\224\367\367\367"
++  "\224\367\367\367\224\367\367\367\224\367\367\367\224\367\367\367\224\0\0"
++  "\0\0\0\0\0\0\377\377\377\6\377\377\377\6\377\377\377\22\377\377\377\27\377"
++  "\377\377'\377\377\3776\377\377\377I\377\377\377Y\377\377\377k\376\376\376"
++  "y\377\377\377\210\377\377\377\224\377\377\377\235\377\377\377\245\377\377"
++  "\377\253\377\377\377\255\377\377\377\262\377\377\377\262\377\377\377\263"
++  "\377\377\377\263\377\377\377\263\377\377\377\263\377\377\377\263\377\377"
++  "\377\266\377\377\377\266\377\377\377\266\377\377\377\266\377\377\377\266"
++  "\377\377\377\266\377\377\377\266\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377"
++  "\14\377\377\377\27\377\377\377#\377\377\3771\377\377\377I\377\377\377]\377"
++  "\377\377r\377\377\377\205\377\377\377\231\377\377\377\247\377\377\377\263"
++  "\377\377\377\275\377\377\377\304\377\377\377\310\377\377\377\313\377\377"
++  "\377\316\377\377\377\320\377\377\377\320\377\377\377\320\377\377\377\320"
++  "\377\377\377\320\377\377\377\320\377\377\377\322\377\377\377\322\377\377"
++  "\377\322\377\377\377\322\377\377\377\322\377\377\377\322\377\377\377\322"
++  "\0\0\0\0\377\377\377\6\377\377\377\6\377\377\377\22\377\377\377\35\377\377"
++  "\377+\377\377\377>\377\377\377Y\377\377\377r\377\377\377\210\376\376\376"
++  "\237\377\377\377\262\377\377\377\302\377\377\377\313\377\377\377\324\377"
++  "\377\377\332\376\376\376\336\377\377\377\341\377\377\377\342\377\377\377"
++  "\344\377\377\377\344\377\377\377\344\377\377\377\344\377\377\377\344\377"
++  "\377\377\344\377\377\377\345\377\377\377\345\377\377\377\345\377\377\377"
++  "\345\377\377\377\345\377\377\377\345\377\377\377\345\0\0\0\0\377\377\377"
++  "\6\377\377\377\14\377\377\377\27\377\377\377#\377\377\3776\377\377\377P\377"
++  "\377\377k\377\377\377\205\376\376\376\237\372\372\372\266\377\377\377\307"
++  "\373\373\373\325\373\373\373\337\374\374\374\345\374\374\374\352\374\374"
++  "\374\355\374\374\374\357\374\374\374\360\374\374\374\361\374\374\374\361"
++  "\374\374\374\362\374\374\374\362\374\374\374\362\374\374\374\362\374\374"
++  "\374\362\374\374\374\362\374\374\374\362\374\374\374\362\374\374\374\362"
++  "\374\374\374\362\374\374\374\362\0\0\0\0\377\377\377\6\377\377\377\14\377"
++  "\377\377\35\377\377\377+\377\377\377C\377\377\377]\377\377\377|\377\377\377"
++  "\231\377\377\377\263\377\377\377\307\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377"
++  "\377\377\6\377\377\377\22\324\324\324#\377\377\3771\377\377\377L\363\363"
++  "\363k\377\377\377\210\377\377\377\247\377\377\377\302\377\377\377\325\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\22\377\377"
++  "\377#\377\377\377<\377\377\377U\377\377\377v\377\377\377\226\377\377\377"
++  "\263\377\377\377\315\377\377\377\337\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377"
++  "\6\377\377\377\14\377\377\377\27\377\377\377'\377\377\377>\377\377\377]\377"
++  "\377\377|\370\370\370\237\377\377\377\275\373\373\373\325\377\377\377\345"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\27\377"
++  "\377\377+\377\377\377C\377\377\377`\377\377\377\202\377\377\377\247\377\377"
++  "\377\304\377\377\377\332\377\377\377\352\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377"
++  "\377\6\377\377\377\14\377\377\377\27\377\377\377+\377\377\377C\377\377\377"
++  "d\377\377\377\210\377\377\377\253\377\377\377\310\376\376\376\336\374\374"
++  "\374\355\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377"
++  "\35\377\377\377+\377\377\377I\377\377\377h\377\377\377\214\377\377\377\260"
++  "\377\377\377\313\374\374\374\342\374\374\374\357\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\377\377\377\6\377\377\377\14\377\377\377\35\342\342\3421\377\377\377I\377"
++  "\377\377k\377\377\377\216\377\377\377\262\377\377\377\316\374\374\374\344"
++  "\377\377\377\360\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377"
++  "\377\377\35\377\377\3771\377\377\377L\377\377\377k\377\377\377\221\377\377"
++  "\377\263\377\377\377\320\377\377\377\344\377\377\377\361\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\35\377\377\3771\377\377"
++  "\377L\377\377\377k\377\377\377\221\377\377\377\263\377\377\377\320\377\377"
++  "\377\344\374\374\374\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377"
++  "\14\377\377\377\35\377\377\3771\377\377\377L\364\364\364p\377\377\377\221"
++  "\372\372\372\266\377\377\377\320\374\374\374\345\377\377\377\362\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\35\377\377\377"
++  "1\377\377\377L\377\377\377p\377\377\377\221\377\377\377\266\373\373\373\322"
++  "\377\377\377\345\377\377\377\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377"
++  "\377\377\14\377\377\377\35\377\377\3771\377\377\377L\377\377\377p\377\377"
++  "\377\221\377\377\377\266\373\373\373\322\377\377\377\345\377\377\377\362"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\35\377"
++  "\377\3771\377\377\377L\377\377\377p\377\377\377\221\377\377\377\266\373\373"
++  "\373\322\377\377\377\345\377\377\377\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377"
++  "\377\6\377\377\377\14\377\377\377\35\377\377\3771\377\377\377L\377\377\377"
++  "p\367\367\367\224\377\377\377\266\377\377\377\322\377\377\377\345\374\374"
++  "\374\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377"
++  "\35\377\377\3771\377\377\377L\377\377\377p\367\367\367\224\377\377\377\266"
++  "\377\377\377\322\377\377\377\345\374\374\374\362\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\377\377\377\6\377\377\377\14\377\377\377\35\377\377\3771\377\377\377L\377"
++  "\377\377p\367\367\367\224\377\377\377\266\377\377\377\322\377\377\377\345"
++  "\374\374\374\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377"
++  "\377\377\35\377\377\3771\377\377\377L\377\377\377p\367\367\367\224\377\377"
++  "\377\266\377\377\377\322\377\377\377\345\374\374\374\362\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\35\377\377\3771\377\377"
++  "\377L\377\377\377p\367\367\367\224\377\377\377\266\377\377\377\322\377\377"
++  "\377\345\374\374\374\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377"
++  "\14\377\377\377\35\377\377\3771\377\377\377L\377\377\377p\367\367\367\224"
++  "\377\377\377\266\377\377\377\322\377\377\377\345\374\374\374\362\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\377\377\377\6\377\377\377\14\377\377\377\35\377\377\377"
++  "1\377\377\377L\377\377\377p\367\367\367\224\377\377\377\266\377\377\377\322"
++  "\377\377\377\345\374\374\374\362\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
++  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0",
++};
++
++#endif
+Index: ubuntu/plugins/expo/src/wall_offset/CMakeLists.txt
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/wall_offset/CMakeLists.txt	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,33 @@
++include_directories (
++  ${CMAKE_CURRENT_SOURCE_DIR}/include
++  ${CMAKE_CURRENT_SOURCE_DIR}/src
++  ${Boost_INCLUDE_DIRS}
++  ${GLIBMM_INCLUDE_DIRS}
++)
++
++link_directories (${GLIBMM_LIBRARY_DIRS} ${COMPIZ_LIBRARY_DIRS})
++
++set (
++  PRIVATE_HEADERS
++  ${CMAKE_CURRENT_SOURCE_DIR}/include/wall-offset.h
++)
++
++set (
++  SRCS
++  ${CMAKE_CURRENT_SOURCE_DIR}/src/wall-offset.cpp
++)
++
++add_library (
++  compiz_expo_wall_offset STATIC
++  ${SRCS}
++  ${PRIVATE_HEADERS}
++)
++
++if (COMPIZ_BUILD_TESTING)
++  add_subdirectory ( ${CMAKE_CURRENT_SOURCE_DIR}/tests )
++endif (COMPIZ_BUILD_TESTING)
++
++target_link_libraries (
++  compiz_expo_wall_offset
++  compiz_core
++)
+Index: ubuntu/plugins/expo/src/wall_offset/include/wall-offset.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/wall_offset/include/wall-offset.h	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,43 @@
++/**
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Authors:
++ * Sam Spilsbury <sam.spilsbury@canonical.com>
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++
++#ifndef _COMPIZ_EXPO_WALL_OFFSET_H
++#define _COMPIZ_EXPO_WALL_OFFSET_H
++
++#include <core/point.h>
++#include <core/size.h>
++#include <core/rect.h>
++
++namespace compiz
++{
++    namespace expo
++    {
++	void
++	calculateWallOffset (const CompRect  &output,
++			     const CompPoint &offsetInScreenCoords,
++			     const CompPoint &vpSize,
++			     const CompSize  &screenSize,
++			     float           &offsetInWorldX,
++			     float           &offsetInWorldY,
++			     float	     &worldScaleFactorX,
++			     float	     &worldScaleFactorY,
++			     float           animationProgress);
++    }
++}
++
++#endif
+Index: ubuntu/plugins/expo/src/wall_offset/src/wall-offset.cpp
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/wall_offset/src/wall-offset.cpp	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,55 @@
++/**
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Authors:
++ * Sam Spilsbury <sam.spilsbury@canonical.com>
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++#include "wall-offset.h"
++
++namespace compiz
++{
++    namespace expo
++    {
++	void
++	calculateWallOffset (const CompRect  &output,
++			     const CompPoint &offsetInScreenCoords,
++			     const CompPoint &vpSize,
++			     const CompSize  &screenSize,
++			     float           &offsetInWorldX,
++			     float           &offsetInWorldY,
++			     float	     &worldScaleFactorX,
++			     float	     &worldScaleFactorY,
++			     float           animationProgress)
++	{
++	    const float sx = screenSize.width () / static_cast <float> (output.width ());
++	    const float sy = screenSize.height () / static_cast <float> (output.height ());
++	    offsetInWorldX = 0.0;
++	    offsetInWorldY = 0.0;
++	    worldScaleFactorX = 1.0f;
++	    worldScaleFactorY = 1.0f;
++
++	    if (output.left () == 0)
++	    {
++		offsetInWorldX = ((vpSize.x () * sx) / ((float) output.width ()) * (offsetInScreenCoords.x ()) * animationProgress);
++		worldScaleFactorX = 1.0f - ((float) (offsetInScreenCoords.x ()) / (float) (output.width ())) * animationProgress;
++	    }
++
++	    if (output.top () == 0)
++	    {
++		offsetInWorldY = ((vpSize.y () * sy) / ((float) output.height ()) * (offsetInScreenCoords.y ()) * animationProgress);
++		worldScaleFactorY = 1.0f - ((float) (offsetInScreenCoords.y ()) / (float) output.height ()) * animationProgress;
++	    }
++	}
++    }
++}
+Index: ubuntu/plugins/expo/src/wall_offset/tests/CMakeLists.txt
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/wall_offset/tests/CMakeLists.txt	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,19 @@
++if (NOT GTEST_FOUND)
++  message ("Google Test not found - cannot build tests!")
++  set (COMPIZ_BUILD_TESTING OFF)
++endif (NOT GTEST_FOUND)
++
++include_directories (${GTEST_INCLUDE_DIRS})
++
++link_directories (${COMPIZ_LIBRARY_DIRS})
++
++add_executable (compiz_test_expo_wall_offset
++		${CMAKE_CURRENT_SOURCE_DIR}/test-expo-wall-offset.cpp)
++
++target_link_libraries (compiz_test_expo_wall_offset
++		       compiz_expo_wall_offset
++		       ${GTEST_BOTH_LIBRARIES}
++		       ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
++                       )
++
++compiz_discover_tests (compiz_test_expo_wall_offset COVERAGE compiz_expo_wall_offset)
+Index: ubuntu/plugins/expo/src/wall_offset/tests/test-expo-wall-offset.cpp
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/wall_offset/tests/test-expo-wall-offset.cpp	2012-09-12 22:20:43.280760497 +0800
+@@ -0,0 +1,263 @@
++/*
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Permission to use, copy, modify, distribute, and sell this software
++ * and its documentation for any purpose is hereby granted without
++ * fee, provided that the above copyright notice appear in all copies
++ * and that both that copyright notice and this permission notice
++ * appear in supporting documentation, and that the name of
++ * Canonical Ltd. not be used in advertising or publicity pertaining to
++ * distribution of the software without specific, written prior permission.
++ * Canonical Ltd. makes no representations about the suitability of this
++ * software for any purpose. It is provided "as is" without express or
++ * implied warranty.
++ *
++ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
++ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
++ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
++ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
++ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
++ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
++ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
++ *
++ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
++ */
++#include <tr1/tuple>
++#include <gtest/gtest.h>
++#include "wall-offset.h"
++
++using ::testing::WithParamInterface;
++using ::testing::ValuesIn;
++using ::testing::Combine;
++using ::testing::Range;
++
++class ExpoWallOffsetTest :
++    public ::testing::Test
++{
++    protected:
++
++	float offsetInWorldX;
++	float offsetInWorldY;
++	float worldScaleFactorX;
++	float worldScaleFactorY;
++};
++
++namespace
++{
++    const unsigned int nAnimationsBegin = 0;
++    const unsigned int nAnimationSteps = 20;
++
++    struct OffsetAnimationParameters
++    {
++	float offsetInWorldX;
++	float offsetInWorldY;
++	float worldScaleFactorX;
++	float worldScaleFactorY;
++    };
++
++    struct OffsetParameters
++    {
++	float offsetX;
++	float offsetY;
++	int   vpSizeWidth;
++	int   vpSizeHeight;
++	int   screenWidth;
++	int   screenHeight;
++	int   outputWidth;
++	int   outputHeight;
++	OffsetAnimationParameters animationParameters[20];
++    };
++
++    const OffsetParameters testingOffsetParameters[] =
++    {
++	{
++	    0,
++	    0,
++	    1,
++	    1,
++	    100,
++	    100,
++	    100,
++	    100,
++	    {
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 },
++		{ 0, 0, 1.0, 1.0 }
++	    }
++	},
++	/* Monitor 1280x800, Screen: 1280x800, Viewport Layout: 2x2, Offset: 32, 24 */
++	{
++	    32,
++	    24,
++	    2,
++	    2,
++	    1280,
++	    800,
++	    1280,
++	    800,
++	    {
++		{ 0, 0, 1, 1 },
++		{ 0.0025000001769512892, 0.0011718750465661287, 0.99874997138977051, 0.99906247854232788 },
++		{ 0.0050000003539025784, 0.0023437500931322575, 0.99750000238418579, 0.99812501668930054 },
++		{ 0.0075000002980232239, 0.0035156251396983862, 0.9962499737739563, 0.99718749523162842 },
++		{ 0.010000000707805157, 0.0046875001862645149, 0.99500000476837158, 0.9962499737739563 },
++		{ 0.012500000186264515, 0.005859375, 0.99374997615814209, 0.99531251192092896 },
++		{ 0.015000000596046448, 0.0070312502793967724, 0.99250000715255737, 0.99437499046325684 },
++		{ 0.017500000074505806, 0.0082031246274709702, 0.99124997854232788, 0.99343752861022949 },
++		{ 0.020000001415610313, 0.0093750003725290298, 0.99000000953674316, 0.99250000715255737 },
++		{ 0.022499999031424522, 0.01054687425494194, 0.98874998092651367, 0.99156248569488525 },
++		{ 0.02500000037252903, 0.01171875, 0.98750001192092896, 0.99062502384185791 },
++		{ 0.027500001713633537, 0.01289062574505806, 0.98624998331069946, 0.98968750238418579 },
++		{ 0.030000001192092896, 0.014062500558793545, 0.98500001430511475, 0.98874998092651367 },
++		{ 0.032499998807907104, 0.015234374441206455, 0.98374998569488525, 0.98781251907348633 },
++		{ 0.035000000149011612, 0.01640624925494194, 0.98250001668930054, 0.98687499761581421 },
++		{ 0.037500001490116119, 0.017578125, 0.98124998807907104, 0.98593747615814209 },
++		{ 0.040000002831220627, 0.01875000074505806, 0.98000001907348633, 0.98500001430511475 },
++		{ 0.042500000447034836, 0.019921876490116119, 0.97874999046325684, 0.98406249284744263 },
++		{ 0.044999998062849045, 0.021093748509883881, 0.97750002145767212, 0.98312497138977051 },
++		{ 0.047499999403953552, 0.02226562425494194, 0.97624999284744263, 0.98218750953674316 }
++	    }
++	},
++	/* Monitor 1280x1024, Screen: 2560x1024, Viewport Layout: 2x2, Offset: 32, 24 */
++	{
++	    32,
++	    24,
++	    2,
++	    2,
++	    2560,
++	    1024,
++	    1280,
++	    1024,
++	    {
++		{ 0, 0, 1, 1 },
++		{ 0.0050000003539025784, 0.001500000013038516, 0.99874997138977051, 0.99906247854232788 },
++		{ 0.010000000707805157, 0.0030000000260770321, 0.99750000238418579, 0.99812501668930054 },
++		{ 0.015000000596046448, 0.0045000002719461918, 0.9962499737739563, 0.99718749523162842 },
++		{ 0.020000001415610313, 0.0060000000521540642, 0.99500000476837158, 0.9962499737739563 },
++		{ 0.02500000037252903, 0.0074999998323619366, 0.99374997615814209, 0.99531251192092896 },
++		{ 0.030000001192092896, 0.0090000005438923836, 0.99250000715255737, 0.99437499046325684 },
++		{ 0.035000000149011612, 0.010499999858438969, 0.99124997854232788, 0.99343752861022949 },
++		{ 0.040000002831220627, 0.012000000104308128, 0.99000000953674316, 0.99250000715255737 },
++		{ 0.044999998062849045, 0.013499999418854713, 0.98874998092651367, 0.99156248569488525 },
++		{ 0.05000000074505806, 0.014999999664723873, 0.98750001192092896, 0.99062502384185791 },
++		{ 0.055000003427267075, 0.016499999910593033, 0.98624998331069946, 0.98968750238418579 },
++		{ 0.060000002384185791, 0.018000001087784767, 0.98500001430511475, 0.98874998092651367 },
++		{ 0.064999997615814209, 0.019499998539686203, 0.98374998569488525, 0.98781251907348633 },
++		{ 0.070000000298023224, 0.020999999716877937, 0.98250001668930054, 0.98687499761581421 },
++		{ 0.075000002980232239, 0.022499999031424522, 0.98124998807907104, 0.98593747615814209 },
++		{ 0.080000005662441254, 0.024000000208616257, 0.98000001907348633, 0.98500001430511475 },
++		{ 0.085000000894069672, 0.025499999523162842, 0.97874999046325684, 0.98406249284744263 },
++		{ 0.08999999612569809, 0.026999998837709427, 0.97750002145767212, 0.98312497138977051 },
++		{ 0.094999998807907104, 0.028499998152256012, 0.97624999284744263, 0.98218750953674316 }
++	    }
++	},
++    };
++
++    typedef std::tr1::tuple <OffsetParameters, unsigned int> AnimParam;
++}
++
++class ExpoWallOffsetTestAnimations :
++    public ExpoWallOffsetTest,
++    public ::testing::WithParamInterface <AnimParam>
++{
++    public:
++
++	void
++	RecordProperty (const char *name, float value)
++	{
++	    ::testing::Message message;
++	    message << value;
++	    Test::RecordProperty (name, message.GetString ().c_str ());
++	}
++};
++
++TEST_P (ExpoWallOffsetTestAnimations, TestAnimationValues)
++{
++    const OffsetParameters &offset (std::tr1::get <0> (GetParam ()));
++    const unsigned int     &index (std::tr1::get <1> (GetParam ()));
++
++    RecordProperty ("outputWidth", offset.outputWidth);
++    RecordProperty ("outputHeight", offset.outputHeight);
++    RecordProperty ("screenWidth", offset.screenWidth);
++    RecordProperty ("screenHeight", offset.screenHeight);
++    RecordProperty ("offsetX", offset.offsetX);
++    RecordProperty ("offsetY", offset.offsetY);
++
++    RecordProperty ("expected.offsetInWorldX", offset.animationParameters[index].offsetInWorldX);
++    RecordProperty ("expected.offsetInWorldY", offset.animationParameters[index].offsetInWorldY);
++    RecordProperty ("expected.worldScaleFactorX", offset.animationParameters[index].worldScaleFactorX);
++    RecordProperty ("expected.worldScaleFactorY", offset.animationParameters[index].worldScaleFactorY);
++
++    compiz::expo::calculateWallOffset (CompRect (0,
++						 0,
++						 offset.outputWidth,
++						 offset.outputWidth),
++				       CompPoint (offset.offsetX,
++						  offset.offsetY),
++				       CompPoint (offset.vpSizeWidth,
++						  offset.vpSizeHeight),
++				       CompSize (offset.screenWidth,
++						 offset.screenHeight),
++				       offsetInWorldX,
++				       offsetInWorldY,
++				       worldScaleFactorX,
++				       worldScaleFactorY,
++				       index / static_cast <float> (nAnimationSteps));
++
++    RecordProperty ("offsetInWorldX", offsetInWorldX);
++    RecordProperty ("offsetInWorldY", offsetInWorldY);
++    RecordProperty ("worldScaleFactorX", worldScaleFactorX);
++    RecordProperty ("worldScaleFactorY", worldScaleFactorY);
++
++    EXPECT_EQ (offsetInWorldX, offset.animationParameters[index].offsetInWorldX);
++    EXPECT_EQ (offsetInWorldY, offset.animationParameters[index].offsetInWorldY);
++    EXPECT_EQ (worldScaleFactorX, offset.animationParameters[index].worldScaleFactorX);
++    EXPECT_EQ (worldScaleFactorY, offset.animationParameters[index].worldScaleFactorY);
++}
++
++TEST_F (ExpoWallOffsetTest, TestNoOffsetIfOutputIsNotOrigin)
++{
++    compiz::expo::calculateWallOffset (CompRect (1,
++						 1,
++						 100,
++						 100),
++				       CompPoint (100,
++						  100),
++				       CompPoint (1,
++						  1),
++				       CompSize (100,
++						 100),
++				       offsetInWorldX,
++				       offsetInWorldY,
++				       worldScaleFactorX,
++				       worldScaleFactorY,
++				       1.0);
++
++    EXPECT_EQ (offsetInWorldX, 0.0f);
++    EXPECT_EQ (offsetInWorldY, 0.0f);
++    EXPECT_EQ (worldScaleFactorX, 1.0f);
++    EXPECT_EQ (worldScaleFactorY, 1.0f);
++}
++
++INSTANTIATE_TEST_CASE_P (ExpoAnimationOffsetTest,
++			 ExpoWallOffsetTestAnimations,
++			 Combine (ValuesIn (testingOffsetParameters),
++				  Range (nAnimationsBegin,
++					 nAnimationSteps)));
+Index: ubuntu/plugins/expo/CMakeLists.txt
+===================================================================
+--- ubuntu.orig/plugins/expo/CMakeLists.txt	2012-09-08 17:26:40.599035911 +0800
++++ ubuntu/plugins/expo/CMakeLists.txt	2012-09-12 22:20:43.300760590 +0800
+@@ -1,7 +1,16 @@
+ find_package (Compiz REQUIRED)
+ include (CompizPlugin)
+ 
++set (COMPIZ_EXPO_PLUGIN_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
++
+ add_subdirectory (src/click_threshold)
+ include_directories (src/click_threshold/include)
++add_subdirectory (src/wall_offset)
++include_directories (src/wall_offset/include)
++add_subdirectory (src/windows_on_viewport)
++include_directories (src/windows_on_viewport/include)
+ 
+-compiz_plugin (expo PLUGINDEPS composite opengl LIBRARIES compiz_expo_click_threshold)
++compiz_plugin (expo PLUGINDEPS composite opengl LIBRARIES
++	       compiz_expo_click_threshold
++	       compiz_expo_wall_offset
++	       compiz_expo_windows_on_viewport)
+Index: ubuntu/plugins/expo/src/windows_on_viewport/CMakeLists.txt
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/windows_on_viewport/CMakeLists.txt	2012-09-12 22:20:43.300760590 +0800
+@@ -0,0 +1,36 @@
++include_directories (
++  ${CMAKE_CURRENT_SOURCE_DIR}/include
++  ${CMAKE_CURRENT_SOURCE_DIR}/src
++  ${COMPIZ_INCLUDE_DIRS}
++  ${COMPIZ_EXPO_PLUGIN_SOURCE_DIR}
++  ${Boost_INCLUDE_DIRS}
++  ${GLIBMM_INCLUDE_DIRS}
++)
++
++link_directories (${GLIBMM_LIBRARY_DIRS} ${COMPIZ_LIBRARY_DIRS})
++
++set (
++  PRIVATE_HEADERS
++  ${CMAKE_CURRENT_SOURCE_DIR}/include/windows-on-viewport.h
++)
++
++set (
++  SRCS
++  ${CMAKE_CURRENT_SOURCE_DIR}/src/windows-on-viewport.cpp
++)
++
++add_library (
++  compiz_expo_windows_on_viewport STATIC
++  ${SRCS}
++  ${PRIVATE_HEADERS}
++)
++
++if (COMPIZ_BUILD_TESTING)
++  add_subdirectory ( ${CMAKE_CURRENT_SOURCE_DIR}/tests )
++endif (COMPIZ_BUILD_TESTING)
++
++target_link_libraries (
++  compiz_expo_windows_on_viewport
++  compiz_window_geometry
++  compiz_core
++)
+Index: ubuntu/plugins/expo/src/windows_on_viewport/include/windows-on-viewport.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/windows_on_viewport/include/windows-on-viewport.h	2012-09-12 22:31:06.807852402 +0800
+@@ -0,0 +1,43 @@
++/**
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Authors:
++ * Sam Spilsbury <sam.spilsbury@canonical.com>
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++#ifndef _COMPIZ_EXPO_WINDOWS_ON_VIEWPORT_H
++#define _COMPIZ_EXPO_WINDOWS_ON_VIEWPORT_H
++
++#include <core/point.h>
++#include <core/size.h>
++#include <core/rect.h>
++#include "client-list-generator.h"
++
++namespace compiz
++{
++    namespace expo
++    {
++	unsigned int countViewports (const CompSize &vpSize);
++
++	void fillInNewViewportActiveData (unsigned int vpCount,
++					  std::vector <bool> &vpActive);
++
++	void activeViewportsForMembers (compiz::expo::ClientListGenerator &clientList,
++					const CompPoint                   &cursor,
++					const CompSize			  &vpSize,
++					const CompSize                    &screenSize,
++					std::vector <bool>                &viewportActiveStates);
++    }
++}
++
++#endif
+Index: ubuntu/plugins/expo/src/windows_on_viewport/src/windows-on-viewport.cpp
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/windows_on_viewport/src/windows-on-viewport.cpp	2012-09-12 22:20:43.300760590 +0800
+@@ -0,0 +1,80 @@
++/**
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Authors:
++ * Sam Spilsbury <sam.spilsbury@canonical.com>
++ *
++ * This program is free software; you can redistribute it and/or
++ * modify it under the terms of the GNU General Public License
++ * as published by the Free Software Foundation; either version 2
++ * of the License, or (at your option) any later version.
++ *
++ * This program is distributed in the hope that it will be useful,
++ * but WITHOUT ANY WARRANTY; without even the implied warranty of
++ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
++ * GNU General Public License for more details.
++ *
++ **/
++#include <cstdio>
++#include <algorithm>
++#include "windows-on-viewport.h"
++#include "viewport-member-window.h"
++
++namespace compiz
++{
++    namespace expo
++    {
++	unsigned int countViewports (const CompSize &vpSize)
++	{
++	    return vpSize.width () * vpSize.height ();
++	}
++
++	void fillInNewViewportActiveData (unsigned int vpCount,
++					  std::vector <bool> &vpActive)
++	{
++	    if (vpActive.size () < vpCount)
++	    {
++		unsigned int last = vpActive.size () - 1;
++		vpActive.resize (vpCount);
++		for (unsigned int i = last; i < vpActive.size (); i++)
++		    vpActive[i] = false;
++	    }
++	}
++
++	void activeViewportsForMembers (compiz::expo::ClientListGenerator &clientList,
++					const CompPoint                   &cursor,
++					const CompSize			  &vpSize,
++					const CompSize			  &screenSize,
++					std::vector <bool>		  &viewportActiveStates)
++	{
++	    compiz::expo::ViewportMemberWindow *vpMemberWindow = clientList.nextClient ();
++
++	    fillInNewViewportActiveData (countViewports (vpSize), viewportActiveStates);
++	    std::fill_n (viewportActiveStates.begin (), viewportActiveStates.size (), false);
++
++	    while (vpMemberWindow)
++	    {
++		if (!vpMemberWindow->isDesktopOrDock ())
++		{
++		    CompPoint viewport;
++
++		    /* If this is a dragged window, use the cursor position */
++		    if (vpMemberWindow->dragged ())
++			viewport.set (cursor.x () / screenSize.width (),
++				      cursor.y () / screenSize.height ());
++		    else
++		    {
++			const compiz::window::Geometry &geom = vpMemberWindow->absoluteGeometry ();
++			viewport.set (geom.centerX () / screenSize.width (),
++				      geom.centerY () / screenSize.height ());
++		    }
++
++		    unsigned int vpIndex = vpSize.width () * viewport.y () + viewport.x ();
++		    viewportActiveStates[vpIndex] = true;
++		}
++
++		vpMemberWindow = clientList.nextClient ();
++	    }
++	}
++    }
++}
+Index: ubuntu/plugins/expo/src/windows_on_viewport/tests/CMakeLists.txt
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/windows_on_viewport/tests/CMakeLists.txt	2012-09-12 22:20:43.300760590 +0800
+@@ -0,0 +1,22 @@
++if (NOT GTEST_FOUND)
++  message ("Google Test not found - cannot build tests!")
++  set (COMPIZ_BUILD_TESTING OFF)
++endif (NOT GTEST_FOUND)
++
++include_directories (${GTEST_INCLUDE_DIRS})
++include_directories (${CMAKE_EXPO_PLUGIN_SOURCE_DIR})
++
++link_directories (${COMPIZ_LIBRARY_DIRS})
++
++add_executable (compiz_test_expo_windows_on_viewport
++		${CMAKE_CURRENT_SOURCE_DIR}/test-windows-on-viewport.cpp)
++
++target_link_libraries (compiz_test_expo_windows_on_viewport
++		       compiz_expo_windows_on_viewport
++		       ${GTEST_BOTH_LIBRARIES}
++		       ${CMAKE_THREAD_LIBS_INIT} # Link in pthread.
++                       ${GMOCK_LIBRARY}
++                       ${GMOCK_MAIN_LIBRARY}
++                       )
++
++compiz_discover_tests (compiz_test_expo_windows_on_viewport COVERAGE compiz_expo_windows_on_viewport)
+Index: ubuntu/plugins/expo/src/windows_on_viewport/tests/test-windows-on-viewport.cpp
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/windows_on_viewport/tests/test-windows-on-viewport.cpp	2012-09-12 22:20:43.304760606 +0800
+@@ -0,0 +1,149 @@
++/*
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Permission to use, copy, modify, distribute, and sell this software
++ * and its documentation for any purpose is hereby granted without
++ * fee, provided that the above copyright notice appear in all copies
++ * and that both that copyright notice and this permission notice
++ * appear in supporting documentation, and that the name of
++ * Canonical Ltd. not be used in advertising or publicity pertaining to
++ * distribution of the software without specific, written prior permission.
++ * Canonical Ltd. makes no representations about the suitability of this
++ * software for any purpose. It is provided "as is" without express or
++ * implied warranty.
++ *
++ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
++ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
++ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
++ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
++ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
++ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
++ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
++ *
++ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
++ */
++#include <gtest/gtest.h>
++#include <gmock/gmock.h>
++#include "windows-on-viewport.h"
++#include "client-list-generator.h"
++#include "viewport-member-window.h"
++
++using ::testing::InSequence;
++using ::testing::Return;
++using ::testing::ReturnNull;
++using ::testing::ReturnRef;
++
++namespace
++{
++    namespace ce = compiz::expo;
++
++    class MockViewportMemberWindow :
++	public ce::ViewportMemberWindow
++    {
++	public:
++
++	    MOCK_CONST_METHOD0 (absoluteGeometry, const compiz::window::Geometry & ());
++	    MOCK_CONST_METHOD0 (isDesktopOrDock, bool ());
++	    MOCK_CONST_METHOD0 (dragged, bool ());
++    };
++
++    class MockClientListGenerator :
++	public ce::ClientListGenerator
++    {
++	public:
++
++	    MOCK_METHOD0 (nextClient, ce::ViewportMemberWindow * ());
++    };
++}
++
++class ExpoWindowsOnViewportTest :
++    public ::testing::Test
++{
++    protected:
++
++	MockClientListGenerator mockClientListGenerator;
++	std::vector <bool>      activeStates;
++};
++
++namespace
++{
++    const CompSize vpSize (2, 2);
++    const CompSize screenSize (1000, 1000);
++}
++
++TEST_F (ExpoWindowsOnViewportTest, TestNoDocksMakeViewportsActive)
++{
++    MockViewportMemberWindow mockViewportMembers[1];
++    InSequence s;
++
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (Return (&mockViewportMembers[0]));
++    EXPECT_CALL (mockViewportMembers[0], isDesktopOrDock ()).WillOnce (Return (true));
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (ReturnNull ());
++
++    compiz::expo::activeViewportsForMembers (mockClientListGenerator,
++					     CompPoint (1, 1),
++					     vpSize,
++					     screenSize,
++					     activeStates);
++
++    ASSERT_EQ (activeStates.size (), vpSize.width () * vpSize.height ());
++    EXPECT_EQ (activeStates[0], false);
++    EXPECT_EQ (activeStates[1], false);
++    EXPECT_EQ (activeStates[2], false);
++    EXPECT_EQ (activeStates[3], false);
++}
++
++TEST_F (ExpoWindowsOnViewportTest, TestGrabbedWindowUsesCursorPosition)
++{
++    MockViewportMemberWindow mockViewportMembers[1];
++    InSequence s;
++
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (Return (&mockViewportMembers[0]));
++    EXPECT_CALL (mockViewportMembers[0], isDesktopOrDock ()).WillOnce (Return (false));
++    EXPECT_CALL (mockViewportMembers[0], dragged ()).WillOnce (Return (true));
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (ReturnNull ());
++
++    compiz::expo::activeViewportsForMembers (mockClientListGenerator,
++					     CompPoint (screenSize.width () * 1.5,
++							screenSize.height () * 1.5),
++					     vpSize,
++					     screenSize,
++					     activeStates);
++
++    ASSERT_EQ (activeStates.size (), vpSize.width () * vpSize.height ());
++    EXPECT_EQ (activeStates[0], false);
++    EXPECT_EQ (activeStates[1], false);
++    EXPECT_EQ (activeStates[2], false);
++    EXPECT_EQ (activeStates[3], true); // 2,2 has the cursor of a dragged window
++}
++
++TEST_F (ExpoWindowsOnViewportTest, TestUngrabbedWindowUsesGeometry)
++{
++    MockViewportMemberWindow mockViewportMembers[1];
++    InSequence s;
++
++    compiz::window::Geometry vpMemberGeometry1 (screenSize.width () * 1.1,
++						screenSize.height () * 1.1,
++						screenSize.width () / 2,
++						screenSize.height () / 2,
++						0);
++
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (Return (&mockViewportMembers[0]));
++    EXPECT_CALL (mockViewportMembers[0], isDesktopOrDock ()).WillOnce (Return (false));
++    EXPECT_CALL (mockViewportMembers[0], dragged ()).WillOnce (Return (false));
++    EXPECT_CALL (mockViewportMembers[0], absoluteGeometry ()).WillOnce (ReturnRef (vpMemberGeometry1));
++    EXPECT_CALL (mockClientListGenerator, nextClient ()).WillOnce (ReturnNull ());
++
++    compiz::expo::activeViewportsForMembers (mockClientListGenerator,
++					     CompPoint (screenSize.width () * 1.5,
++							screenSize.height () * 1.5),
++					     vpSize,
++					     screenSize,
++					     activeStates);
++
++    ASSERT_EQ (activeStates.size (), vpSize.width () * vpSize.height ());
++    EXPECT_EQ (activeStates[0], false);
++    EXPECT_EQ (activeStates[1], false);
++    EXPECT_EQ (activeStates[2], false);
++    EXPECT_EQ (activeStates[3], true); // 2,2 has a window on it
++}
+Index: ubuntu/plugins/expo/src/client-list-generator.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/client-list-generator.h	2012-09-12 22:20:43.304760606 +0800
+@@ -0,0 +1,45 @@
++/*
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Permission to use, copy, modify, distribute, and sell this software
++ * and its documentation for any purpose is hereby granted without
++ * fee, provided that the above copyright notice appear in all copies
++ * and that both that copyright notice and this permission notice
++ * appear in supporting documentation, and that the name of
++ * Canonical Ltd. not be used in advertising or publicity pertaining to
++ * distribution of the software without specific, written prior permission.
++ * Canonical Ltd. makes no representations about the suitability of this
++ * software for any purpose. It is provided "as is" without express or
++ * implied warranty.
++ *
++ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
++ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
++ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
++ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
++ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
++ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
++ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
++ *
++ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
++ */
++#ifndef _COMPIZ_EXPO_CLIENT_LIST_GENERATOR_H
++#define _COMPIZ_EXPO_CLIENT_LIST_GENERATOR_H
++
++namespace compiz
++{
++    namespace expo
++    {
++	class ViewportMemberWindow;
++
++	class ClientListGenerator
++	{
++	    public:
++
++		virtual ~ClientListGenerator () {};
++		virtual ViewportMemberWindow * nextClient () = 0;
++	};
++    }
++}
++#endif
++
++
+Index: ubuntu/plugins/expo/src/viewport-member-window.h
+===================================================================
+--- /dev/null	1970-01-01 00:00:00.000000000 +0000
++++ ubuntu/plugins/expo/src/viewport-member-window.h	2012-09-12 22:20:43.304760606 +0800
+@@ -0,0 +1,46 @@
++/*
++ * Copyright © 2012 Canonical Ltd.
++ *
++ * Permission to use, copy, modify, distribute, and sell this software
++ * and its documentation for any purpose is hereby granted without
++ * fee, provided that the above copyright notice appear in all copies
++ * and that both that copyright notice and this permission notice
++ * appear in supporting documentation, and that the name of
++ * Canonical Ltd. not be used in advertising or publicity pertaining to
++ * distribution of the software without specific, written prior permission.
++ * Canonical Ltd. makes no representations about the suitability of this
++ * software for any purpose. It is provided "as is" without express or
++ * implied warranty.
++ *
++ * CANONICAL, LTD. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
++ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
++ * NO EVENT SHALL CANONICAL, LTD. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
++ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
++ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
++ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
++ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
++ *
++ * Authored by: Sam Spilsbury <sam.spilsbury@canonical.com>
++ */
++#ifndef _COMPIZ_EXPO_VIEWPORT_MEMBER_WINDOW_H
++#define _COMPIZ_EXPO_VIEWPORT_MEMBER_WINDOW_H
++
++#include <core/windowgeometry.h>
++
++namespace compiz
++{
++    namespace expo
++    {
++	class ViewportMemberWindow
++	{
++	    public:
++
++		virtual ~ViewportMemberWindow () {};
++		virtual const compiz::window::Geometry & absoluteGeometry () const = 0;
++		virtual bool dragged () const = 0;
++		virtual bool isDesktopOrDock () const = 0;
++	};
++    }
++}
++
++#endif

=== added file 'debian/patches/99_valid_ccsm_desktop_file.patch'
--- debian/patches/99_valid_ccsm_desktop_file.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/99_valid_ccsm_desktop_file.patch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,16 @@
+Index: compiz-0.9.8/compizconfig/ccsm/ccsm.desktop.in
+===================================================================
+--- compiz-0.9.8.orig/compizconfig/ccsm/ccsm.desktop.in	2012-05-29 12:09:56.000000000 +0200
++++ compiz-0.9.8/compizconfig/ccsm/ccsm.desktop.in	2012-05-29 14:54:50.181992801 +0200
+@@ -1,10 +1,9 @@
+ [Desktop Entry]
+-Encoding=UTF-8
+ _Name=CompizConfig Settings Manager
+ _Comment=Configure Compiz with CompizConfig
+ Icon=ccsm
+ Exec=ccsm
+ Terminal=false
+ Type=Application
+-Categories=Compiz;Settings;DesktopSettings;
++Categories=Settings;DesktopSettings;
+ StartupNotify=true

=== added file 'debian/patches/ccp_plugin.patch'
--- debian/patches/ccp_plugin.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/ccp_plugin.patch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,35 @@
+Index: compiz-0.9.8/src/main.cpp
+===================================================================
+--- compiz-0.9.8.orig/src/main.cpp	2012-05-29 12:09:56.000000000 +0200
++++ compiz-0.9.8/src/main.cpp	2012-05-30 16:29:24.940570174 +0200
+@@ -146,23 +146,25 @@
+ 
+     modHandler = new ModifierHandler ();
+ 
+-    if (!initialPlugins.empty ())
+-    {
+-	CompOption::Value::Vector list;
+-        CompOption::Value         value;
++    CompOption::Value::Vector list;
++    CompOption::Value         value;
+ 	CompOption                *o = screen->getOption ("active_plugins");
+ 
++    if (!initialPlugins.empty ())
++    {
+ 	foreach (CompString &str, initialPlugins)
+ 	{
+ 	    value.set (str);
+ 	    list.push_back (value);
+ 	}
++    }
++    else
++	list.push_back ("ccp");
+ 
+ 	value.set (CompOption::TypeString, list);
+ 
+ 	if (o)
+ 	    o->set (value);
+-    }
+ 
+     if (!screen->init (displayName))
+ 	return false;

=== added file 'debian/patches/ccsm_add_first_run_warning.patch'
--- debian/patches/ccsm_add_first_run_warning.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/ccsm_add_first_run_warning.patch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,105 @@
+Description: Add a first run dialog providing a user warning.
+Author: Andrew Starr-Bochicchio <a.starr.b@gmail.com>
+
+=== modified file 'ccm/Widgets.py'
+diff -Nur -x '*.orig' -x '*~' a/compizconfig/ccsm/ccm/Constants.py.in b/compizconfig/ccsm/ccm/Constants.py.in
+--- a/compizconfig/ccsm/ccm/Constants.py.in	2012-02-01 13:30:19.131478000 -0500
++++ b/compizconfig/ccsm/ccm/Constants.py.in	2012-02-13 18:26:19.699626332 -0500
+@@ -23,6 +23,7 @@
+ import pygtk
+ import gtk
+ import gtk.gdk
++import os
+ 
+ # Current Screen
+ #
+@@ -66,6 +67,11 @@
+ DataDir = "@prefix@/share"
+ IconDir = DataDir+"/ccsm/icons"
+ PixmapDir = DataDir+"/ccsm/images"
++ConfigHome = os.getenv("XDG_CONFIG_HOME")
++if not ConfigHome:
++   ConfigHome = os.path.join(os.getenv("HOME"), ".config")
++ConfDir = os.path.join(ConfigHome, "compiz-1/compizconfig/")
++ConfFile = os.path.join(ConfDir, "firstrun")
+ 
+ # Version
+ #
+diff -Nur -x '*.orig' -x '*~' a/compizconfig/ccsm/ccm/Widgets.py b/compizconfig/ccsm/ccm/Widgets.py
+--- a/compizconfig/ccsm/ccm/Widgets.py	2012-02-02 22:43:52.623481000 -0500
++++ b/compizconfig/ccsm/ccm/Widgets.py	2012-02-13 18:25:55.659409730 -0500
+@@ -1371,6 +1371,42 @@
+         self.set_transient_for (parent)
+         self.connect_after ("response", lambda *args: self.destroy ())
+ 
++# First run dialog providing a user warning.
++#
++class FirstRun (gtk.MessageDialog):
++    '''First run dialog providing a user warning.'''
++
++    def __init__(self, parent):
++        gtk.MessageDialog.__init__ (self, parent,
++                                    gtk.DIALOG_DESTROY_WITH_PARENT,
++                                    gtk.MESSAGE_WARNING,
++                                    gtk.BUTTONS_OK)
++        self.set_position (gtk.WIN_POS_CENTER)
++        title = _("CCSM is an advanced tool. Use with caution.")
++        self.set_markup("<b>%s</b>" % title)
++        message = _("This tool allows you to deeply configure Compiz's settings. Some options may be incompatible with each other. Unless used with care, it is possible to be left with an unusable desktop.")
++        self.format_secondary_markup(message)
++        check_button = gtk.CheckButton(label=_("Show this warning next time?"))
++        check_button.set_active(True)
++        self.vbox.pack_start(check_button, True, True, 2)
++        check_button.show()
++        check_button.connect("toggled", self.callback, "check button 1")
++        self.set_transient_for(parent)
++        self.set_modal(True)
++        self.show_all()
++        self.connect("response", lambda *args: self.destroy ())
++        
++    def callback(self, widget, data=None):
++        if widget.get_active() == True:
++            if os.path.isfile(ConfFile):
++                os.remove(ConfFile)
++        else:
++            if not os.path.exists(ConfDir):
++                os.mkdir(ConfDir)
++            if os.path.isdir(ConfDir):
++                f = open(ConfFile, "w")
++                f.close()
++
+ # Plugin Button
+ #
+ class PluginButton (gtk.HBox):
+diff -Nur -x '*.orig' -x '*~' a/compizconfig/ccsm/ccsm b/compizconfig/ccsm/ccsm
+--- a/compizconfig/ccsm/ccsm	2012-02-02 16:42:01.161305000 -0500
++++ b/compizconfig/ccsm/ccsm	2012-02-13 18:25:55.663409766 -0500
+@@ -31,6 +31,7 @@
+ pygtk.require('2.0')
+ import gtk
+ import sys
++import os
+ 
+ def try_register_dbus ():
+     '''Return instance of dbus control object on success, None on failure'''
+@@ -92,7 +93,7 @@
+ import compizconfig
+ import ccm
+ from ccm.Utils import GlobalUpdater
+-from ccm.Constants import Version
++from ccm.Constants import Version, ConfFile
+ 
+ plugin   = None
+ category = None
+@@ -124,4 +125,11 @@
+ idle = ccm.IdleSettingsParser(context, mainWin)
+ mainWin.show_all()
+ 
++# Check if we should show the first run warning dialog.
++if os.path.isfile(ConfFile):
++    pass
++else:
++    warning = ccm.FirstRun(mainWin)
++    warning.show_all()
++
+ gtk.main()

=== added file 'debian/patches/ccsm_disable_unity_checkbox.patch'
--- debian/patches/ccsm_disable_unity_checkbox.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/ccsm_disable_unity_checkbox.patch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,20 @@
+Description: If in a Unity session, don't allow the user to disable Unity from main view.
+Author: Andrew Starr-Bochicchio <a.starr.b@gmail.com>
+
+=== modified file 'ccm/Widgets.py'
+diff -Nur -x '*.orig' -x '*~' a/compizconfig/ccsm/ccm/Widgets.py b/compiconfig/ccsm/ccm/Widgets.py
+--- a/compizconfig/ccsm/ccm/Widgets.py	2012-02-02 19:05:53.690931000 -0500
++++ b/compizconfig/ccsm/ccm/Widgets.py	2012-02-13 18:42:47.612544975 -0500
+@@ -1401,7 +1401,11 @@
+         button.set_tooltip_text (plugin.LongDesc)
+         button.add (box)
+ 
+-        if plugin.Name != 'core':
++        blacklist_plugins = ['core']
++        if os.getenv('DESKTOP_SESSION') == 'ubuntu':
++            blacklist_plugins.append('unityshell')
++
++        if plugin.Name not in blacklist_plugins:
+             enable = gtk.CheckButton ()
+             enable.set_tooltip_text(_("Enable %s") % plugin.ShortDesc)
+             enable.set_active (plugin.Enabled)

=== added file 'debian/patches/ccsm_remove_redundant_sliders.patch'
--- debian/patches/ccsm_remove_redundant_sliders.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/ccsm_remove_redundant_sliders.patch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,39 @@
+=== modified file 'ccm/Settings.py'
+diff -Nur -x '*.orig' -x '*~' a/compizconfig/ccsm/ccm/Settings.py b/compizconfig/Settings.py
+--- a/compizconfig/ccsm/ccm/Settings.py	2011-08-22 13:38:46.000000000 +0200
++++ b/compizconfig/ccsm/ccm/Settings.py	2012-02-01 12:44:46.254767412 +0100
+@@ -441,16 +441,10 @@
+         self.NoneValue = info[0]
+         self.Adj = gtk.Adjustment(self.Get(), info[0], info[1], inc, inc*10)
+         self.Spin = gtk.SpinButton(self.Adj)
+-
+-        self.Scale = gtk.HScale(self.Adj)
+-
+-        self.Scale.set_update_policy(gtk.UPDATE_DISCONTINUOUS)
+-        self.Scale.connect("value-changed", self.Changed)
+         self.Spin.connect("value-changed", self.Changed)
+-        self.Widget = self.Scale
++        self.Widget = self.Spin
+ 
+-        self.Box.pack_start(self.Scale, True, True)
+-        self.Box.pack_start(self.Spin, False, False)
++        self.Box.pack_end(self.Spin, False, False)
+ 
+     def _Read(self):
+         self.Adj.set_value(self.Get())
+@@ -464,7 +458,6 @@
+         self.Inc = 1
+         NumberSetting._Init(self)
+         self.Spin.set_digits(0)
+-        self.Scale.set_digits(0)
+ 
+ class FloatSetting(NumberSetting):
+ 
+@@ -474,7 +467,6 @@
+         self.Inc = None
+         NumberSetting._Init(self)
+         self.Spin.set_digits(4)
+-        self.Scale.set_digits(4)
+ 
+ 
+ class ColorSetting(StockSetting):

=== added file 'debian/patches/series'
--- debian/patches/series	1970-01-01 00:00:00 +0000
+++ debian/patches/series	2012-11-05 20:50:59 +0000
@@ -0,0 +1,9 @@
+ubuntu-config.patch
+ccp_plugin.patch
+workaround_broken_drivers.patch
+ccsm_remove_redundant_sliders.patch
+ccsm_add_first_run_warning.patch
+ccsm_disable_unity_checkbox.patch
+99_valid_ccsm_desktop_file.patch
+100_expo_layout.patch
+unity_support_test.patch

=== added file 'debian/patches/ubuntu-config.patch'
--- debian/patches/ubuntu-config.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/ubuntu-config.patch	2012-08-27 19:12:22 +0000
@@ -0,0 +1,771 @@
+=== modified file 'metadata/core.xml.in'
+--- old/metadata/core.xml.in	2012-03-09 16:13:05 +0000
++++ new/metadata/core.xml.in	2012-07-27 12:41:52 +0000
+@@ -138,7 +138,7 @@
+ 			<option name="focus_prevention_match" type="match">
+ 			<_short>Focus Prevention Windows</_short>
+ 			<_long>Focus prevention windows</_long>
+-			<default>any</default>
++			<default>!(class=Polkit-gnome-authentication-agent-1)</default>
+ 			</option>
+ 		</group>
+ 		<group>
+@@ -173,7 +173,7 @@
+ 			<option name="minimize_window_key" type="key">
+ 			<_short>Minimize Window</_short>
+ 			<_long>Minimize active window</_long>
+-			<default>&lt;Alt&gt;F9</default>
++			<default>&lt;Control&gt;&lt;Alt&gt;KP_0</default>
+ 			</option>
+ 			<option name="minimize_window_button" type="button">
+ 			<_short>Minimize Window</_short>
+@@ -182,12 +182,12 @@
+ 			<option name="maximize_window_key" type="key">
+ 			<_short>Maximize Window</_short>
+ 			<_long>Maximize active window</_long>
+-			<default>&lt;Alt&gt;F10</default>
++			<default>&lt;Control&gt;&lt;Super&gt;Up</default>
+ 			</option>
+ 			<option name="unmaximize_window_key" type="key">
+ 			<_short>Unmaximize Window</_short>
+ 			<_long>Unmaximize active window</_long>
+-			<default>&lt;Alt&gt;F5</default>
++			<default>&lt;Control&gt;&lt;Super&gt;Down</default>
+ 			</option>
+ 			<option name="maximize_window_horizontally_key" type="key">
+ 			<_short>Maximize Window Horizontally</_short>
+@@ -210,7 +210,7 @@
+ 			<option name="show_desktop_key" type="key">
+ 			<_short>Show Desktop</_short>
+ 			<_long>Hide all windows and focus desktop</_long>
+-			<default>&lt;Control&gt;&lt;Alt&gt;d</default>
++			<default>&lt;Control&gt;&lt;Super&gt;d</default>
+ 			</option>
+ 			<option name="show_desktop_edge" type="edge">
+ 			<_short>Show Desktop</_short>
+@@ -220,6 +220,7 @@
+ 			<option name="toggle_window_maximized_key" type="key">
+ 			<_short>Toggle Window Maximized</_short>
+ 			<_long>Toggle active window maximized</_long>
++            <default>&lt;Control&gt;&lt;Alt&gt;KP_5</default>
+ 			</option>
+ 			<option name="toggle_window_maximized_button" type="button">
+ 			<_short>Toggle Window Maximized</_short>
+@@ -244,14 +245,14 @@
+ 			<option name="hsize" type="int">
+ 			<_short>Horizontal Virtual Size</_short>
+ 			<_long>Screen size multiplier for horizontal virtual size</_long>
+-			<default>4</default>
++			<default>2</default>
+ 			<min>1</min>
+ 			<max>32</max>
+ 			</option>
+ 			<option name="vsize" type="int">
+ 			<_short>Vertical Virtual Size</_short>
+ 			<_long>Screen size multiplier for vertical virtual size</_long>
+-			<default>1</default>
++			<default>2</default>
+ 			<min>1</min>
+ 			<max>32</max>
+ 			</option>
+
+=== modified file 'plugins/animation/animation.xml.in'
+--- old/plugins/animation/animation.xml.in	2012-05-16 17:40:41 +0000
++++ new/plugins/animation/animation.xml.in	2012-07-27 12:41:52 +0000
+@@ -35,7 +35,7 @@
+ 	    <extensible/>
+ 	    <sort start="2"/>
+ 	    <default>
+-	      <value>animation:Zoom</value>
++	      <value>animation:Glide 2</value>
+ 	      <value>animation:Fade</value>
+ 	      <value>animation:Fade</value>
+ 	    </default>
+@@ -47,9 +47,9 @@
+ 	    <min>50</min>
+ 	    <max>4000</max>
+ 	    <default>
+-	      <value>200</value>
+-	      <value>150</value>
+-	      <value>150</value>
++	      <value>120</value>
++	      <value>80</value>
++	      <value>80</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="open_matches" type="list">
+@@ -57,8 +57,8 @@
+ 	    <_long>The windows that will be animated.</_long>
+ 	    <type>match</type>
+ 	    <default>
+-	      <value>(type=Normal | Dialog | ModalDialog | Unknown) &amp; !(name=gnome-screensaver)</value>
+-	      <value>(type=Menu | PopupMenu | DropdownMenu | Combo)</value>
++ 	      <value>((type=Normal | Unknown) | name=sun-awt-X11-XFramePeer | name=sun-awt-X11-XDialogPeer) &amp; !(role=toolTipTip | role=qtooltip_label) &amp; !(type=Normal &amp; override_redirect=1) &amp; !(name=gnome-screensaver)</value>
++ 	      <value>(type=Menu | PopupMenu | DropdownMenu | Combo | Dialog | ModalDialog | Normal)</value>
+ 	      <value>(type=Tooltip | Notification | Utility) &amp; !(name=compiz) &amp; !(title=notify-osd)</value>
+ 	    </default>
+ 	  </option>
+@@ -101,7 +101,7 @@
+ 	    <extensible/>
+ 	    <sort start="2"/>
+ 	    <default>
+-	      <value>animation:Zoom</value>
++	      <value>animation:Glide 2</value>
+ 	      <value>animation:Fade</value>
+ 	      <value>animation:Fade</value>
+ 	    </default>
+@@ -113,9 +113,9 @@
+ 	    <min>50</min>
+ 	    <max>4000</max>
+ 	    <default>
+-	      <value>200</value>
+-	      <value>150</value>
+-	      <value>150</value>
++	      <value>120</value>
++	      <value>80</value>
++	      <value>50</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="close_matches" type="list">
+@@ -123,8 +123,8 @@
+ 	    <_long>The windows that will be animated.</_long>
+ 	    <type>match</type>
+ 	    <default>
+-	      <value>(type=Normal | Dialog | ModalDialog | Unknown) &amp; !(name=gnome-screensaver)</value>
+-	      <value>(type=Menu | PopupMenu | DropdownMenu | Combo)</value>
++ 	      <value>((type=Normal | Unknown) | name=sun-awt-X11-XFramePeer | name=sun-awt-X11-XDialogPeer) &amp; !(role=toolTipTip | role=qtooltip_label) &amp; !(type=Normal &amp; override_redirect=1) &amp; !(name=gnome-screensaver) &amp; !(name=gnome-screenshot)</value>
++ 	      <value>(type=Menu | PopupMenu | DropdownMenu | Combo | Dialog | ModalDialog | Normal)</value>
+ 	      <value>(type=Tooltip | Notification | Utility) &amp; !(name=compiz) &amp; !(title=notify-osd)</value>
+ 	    </default>
+ 	  </option>
+@@ -167,7 +167,7 @@
+ 	    <extensible/>
+ 	    <sort start="2"/>
+ 	    <default>
+-	      <value>animation:Magic Lamp</value>
++	      <value>animation:Zoom</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="minimize_durations" type="list">
+@@ -177,7 +177,7 @@
+ 	    <min>50</min>
+ 	    <max>4000</max>
+ 	    <default>
+-	      <value>300</value>
++	      <value>220</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="minimize_matches" type="list">
+@@ -282,7 +282,7 @@
+ 	    <extensible/>
+ 	    <sort start="1"/>
+ 	    <default>
+-	      <value>animation:None</value>
++	      <value>animation:Fade</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="focus_durations" type="list">
+@@ -292,7 +292,7 @@
+ 	    <min>50</min>
+ 	    <max>4000</max>
+ 	    <default>
+-	      <value>300</value>
++	      <value>150</value>
+ 	    </default>
+ 	  </option>
+ 	  <option name="focus_matches" type="list">
+@@ -326,7 +326,7 @@
+ 	<option name="time_step" type="int">
+ 	  <_short>Animation Time Step</_short>
+ 	  <_long>The amount of time in milliseconds between each render of the animation. The higher the number, the jerkier the movements become.</_long>
+-	  <default>10</default>
++	  <default>16</default>
+ 	  <min>1</min>
+ 	  <max>400</max>
+ 	</option>
+@@ -414,7 +414,7 @@
+ 	  <option name="glide2_away_position" type="float">
+ 	    <_short>Away Position</_short>
+ 	    <_long>Closeness of window to camera at the end of the animation (1.0: Close to camera, -2.0: Away from camera).</_long>
+-	    <default>-0.4</default>
++	    <default>-0.1</default>
+ 	    <min>-2</min>
+ 	    <max>1</max>
+ 	    <precision>0.05</precision>
+@@ -422,7 +422,7 @@
+ 	  <option name="glide2_away_angle" type="float">
+ 	    <_short>Away Angle</_short>
+ 	    <_long>Angle of window at the end of the animation.</_long>
+-	    <default>-45</default>
++	    <default>0</default>
+ 	    <min>-540</min>
+ 	    <max>540</max>
+ 	    <precision>5</precision>
+@@ -627,7 +627,7 @@
+ 	  <option name="zoom_springiness" type="float">
+ 	    <_short>Springiness</_short>
+ 	    <_long>How spring-like the Zoom animation should be.</_long>
+-	    <default>0.0</default>
++	    <default>0.08</default>
+ 	    <min>0</min>
+ 	    <max>1</max>
+ 	    <precision>0.01</precision>
+
+=== modified file 'plugins/decor/decor.xml.in'
+--- old/plugins/decor/decor.xml.in	2012-06-24 09:00:27 +0000
++++ new/plugins/decor/decor.xml.in	2012-07-27 12:41:52 +0000
+@@ -30,7 +30,7 @@
+ 		<option name="active_shadow_opacity" type="float">
+ 		    <_short>Shadow Opacity</_short>
+ 		    <_long>Drop shadow opacity</_long>
+-		    <default>0.5</default>
++		    <default>0.8</default>
+ 		    <min>0.01</min>
+ 		    <max>6.0</max>
+ 		    <precision>0.01</precision>
+@@ -65,7 +65,7 @@
+ 		<option name="inactive_shadow_radius" type="float">
+ 		    <_short>Shadow Radius</_short>
+ 		    <_long>Drop shadow radius</_long>
+-		    <default>8.0</default>
++		    <default>5.0</default>
+ 		    <min>0.1</min>
+ 		    <max>13.0</max>
+ 		    <precision>0.1</precision>
+@@ -73,7 +73,7 @@
+ 		<option name="inactive_shadow_opacity" type="float">
+ 		    <_short>Shadow Opacity</_short>
+ 		    <_long>Drop shadow opacity</_long>
+-		    <default>0.5</default>
++		    <default>0.4</default>
+ 		    <min>0.01</min>
+ 		    <max>6.0</max>
+ 		    <precision>0.01</precision>
+@@ -100,7 +100,7 @@
+ 	    <option name="command" type="string">
+ 		<_short>Command</_short>
+ 		<_long>Decorator command line that is executed if no decorator is already running.</_long>
+-		<default>exec \"${COMPIZ_BIN_PATH}compiz-decorator\"</default>
++		<default>/usr/bin/gtk-window-decorator</default>
+ 	    </option>
+ 	    <option name="mipmap" type="bool">
+ 		<_short>Mipmap</_short>
+
+=== modified file 'plugins/expo/expo.xml.in'
+--- old/plugins/expo/expo.xml.in	2012-05-16 17:40:58 +0000
++++ new/plugins/expo/expo.xml.in	2012-07-27 12:41:52 +0000
+@@ -36,7 +36,6 @@
+ 		    <_short>Expo edge</_short>
+ 		    <_long>Engage wall expo mode edge binding</_long>
+ 		    <default>
+-			<edge name="TopLeft"/>
+ 		    </default>
+ 		</option>
+ 		<option name="double_click_time" type="int">
+
+=== modified file 'plugins/ezoom/ezoom.xml.in'
+--- old/plugins/ezoom/ezoom.xml.in	2012-05-16 17:40:27 +0000
++++ new/plugins/ezoom/ezoom.xml.in	2012-07-27 12:41:52 +0000
+@@ -29,7 +29,6 @@
+ 		<option type="button" name="zoom_in_button">
+ 		    <_short>Zoom In</_short>
+ 		    <_long>Zoom In</_long>
+-		    <default>&lt;Super&gt;Button4</default>
+ 		</option>
+ 		<option type="key" name="zoom_in_key">
+ 		    <_short>Zoom In</_short>
+@@ -38,7 +37,6 @@
+ 		<option type="button" name="zoom_out_button">
+ 		    <_short>Zoom Out</_short>
+ 		    <_long>Zoom Out</_long>
+-		    <default>&lt;Super&gt;Button5</default>
+ 		</option>
+ 		<option type="key" name="zoom_out_key">
+ 		    <_short>Zoom Out</_short>
+@@ -47,7 +45,6 @@
+ 		<option type="button" name="zoom_box_button">
+ 		    <_short>Zoom Box</_short>
+ 		    <_long>Zoom in on a boxed area</_long>
+-		    <default>&lt;Super&gt;Button2</default>
+ 		</option>
+ 	    </group>
+ 	    <group>
+@@ -141,7 +138,7 @@
+ 		    <option type="key" name="fit_to_window_key">
+ 			<_short>Fit zoomed area to window</_short>
+ 			<_long>Zooms in/out so the focused window is zoomed to the maximum while still being fully visible.</_long>
+-			<default>&lt;Super&gt;r</default>
++			<default></default>
+ 		    </option>
+ 		</subgroup>
+ 	    </group>
+
+=== modified file 'plugins/fade/fade.xml.in'
+--- old/plugins/fade/fade.xml.in	2011-06-27 13:32:58 +0000
++++ new/plugins/fade/fade.xml.in	2012-07-27 12:41:52 +0000
+@@ -9,6 +9,7 @@
+ 	    </requirement>
+ 	    <relation type="after">
+ 		<plugin>decor</plugin>
++		<plugin>staticswitcher</plugin>
+ 	    </relation>
+ 	    <relation type="before">
+ 		<plugin>cube</plugin>
+@@ -49,7 +50,7 @@
+ 	    <option name="window_match" type="match">
+ 		<_short>Fade windows</_short>
+ 		<_long>Windows that should be fading</_long>
+-		<default>any</default>
++                <default>any &amp; !(title=notify-osd)</default>
+ 	    </option>
+ 	    <option name="visual_bell" type="bell">
+ 		<_short>Visual Bell</_short>
+
+=== modified file 'plugins/gnomecompat/gnomecompat.xml.in'
+--- old/plugins/gnomecompat/gnomecompat.xml.in	2010-12-07 05:03:07 +0000
++++ new/plugins/gnomecompat/gnomecompat.xml.in	2012-07-27 12:41:52 +0000
+@@ -52,6 +52,7 @@
+ 		<option name="run_command_terminal_key" type="key">
+ 		    <_short>Open a terminal</_short>
+ 		    <_long>Open a terminal</_long>
++		    <default>&lt;Control&gt;&lt;Alt&gt;T</default>
+ 		</option>
+ 	    </group>
+ 	</options>
+
+=== modified file 'plugins/grid/grid.xml.in'
+--- old/plugins/grid/grid.xml.in	2012-05-16 17:43:21 +0000
++++ new/plugins/grid/grid.xml.in	2012-07-27 12:41:52 +0000
+@@ -23,17 +23,16 @@
+ 		<option name="put_center_key" type="key">
+ 		    <_short>Put Center</_short>
+ 		    <_long>Move window to the center</_long>
+-		    <default>&lt;Control&gt;&lt;Alt&gt;KP_5</default>
+ 		</option>
+ 		<option name="put_left_key" type="key">
+ 		    <_short>Put Left</_short>
+ 		    <_long>Move window to the left edge</_long>
+-		    <default>&lt;Control&gt;&lt;Alt&gt;KP_4</default>
++		    <default>&lt;Control&gt;&lt;Super&gt;Left</default>
+ 		</option>
+ 		<option name="put_right_key" type="key">
+ 		    <_short>Put Right</_short>
+ 		    <_long>Move window to the right edge</_long>
+-		    <default>&lt;Control&gt;&lt;Alt&gt;KP_6</default>
++		    <default>&lt;Control&gt;&lt;Super&gt;Right</default>
+ 		</option>
+ 		<option name="put_top_key" type="key">
+ 		    <_short>Put Top</_short>
+@@ -68,7 +67,6 @@
+ 		<option name="put_maximize_key" type="key">
+ 		    <_short>Maximize</_short>
+ 		    <_long>Maximize window</_long>
+-		    <default>&lt;Control&gt;&lt;Alt&gt;KP_0</default>
+ 		</option>
+ 		<option name="put_restore_key" type="key">
+ 		    <_short>Restore</_short>
+
+=== modified file 'plugins/place/place.xml.in'
+--- old/plugins/place/place.xml.in	2011-10-13 14:36:35 +0000
++++ new/plugins/place/place.xml.in	2012-07-27 12:41:52 +0000
+@@ -19,8 +19,8 @@
+ 	    <option name="mode" type="int">
+ 		<_short>Placement Mode</_short>
+ 		<_long>Algorithm to use for window placement</_long>
+-		<default>0</default>
+-		<min>2</min>
++		<default>2</default>
++		<min>0</min>
+ 		<max>5</max>
+ 		<desc>
+ 		    <value>0</value>
+
+=== modified file 'plugins/resize/resize.xml.in'
+--- old/plugins/resize/resize.xml.in	2011-05-01 20:59:20 +0000
++++ new/plugins/resize/resize.xml.in	2012-07-27 12:41:52 +0000
+@@ -28,7 +28,7 @@
+ 	    <option name="mode" type="int">
+ 		<_short>Default Resize Mode</_short>
+ 		<_long>Default mode used for window resizing</_long>
+-		<default>0</default>
++		<default>2</default>
+ 		<min>0</min>
+ 		<max>3</max>
+ 		<desc>
+@@ -56,15 +56,15 @@
+ 	    <option name="maximize_vertically" type="bool">
+ 	        <short>Maximize Vertically if screen edge hit</short>
+ 	        <long>Maximizes the window vertically if the top or bottom screen edge is hit while resizing</long>
+-	        <default>false</default>
++	        <default>true</default>
+ 	    </option>
+ 	    <option name="border_color" type="color">
+ 		<_short>Border Color</_short>
+ 		<_long>Border color used for outline and rectangle resize modes</_long>
+ 		<default>
+-		    <red>0x2f2f</red>
+-		    <green>0x2f2f</green>
+-		    <blue>0x4f4f</blue>
++		    <red>0xfbfb</red>
++		    <green>0x8b8b</green>
++		    <blue>0x0</blue>
+ 		    <alpha>0x9f9f</alpha>
+ 		</default>
+ 	    </option>
+@@ -72,10 +72,10 @@
+ 		<_short>Fill Color</_short>
+ 		<_long>Fill color used for rectangle resize mode</_long>
+ 		<default>
+-		    <red>0x2f2f</red>
+-		    <green>0x2f2f</green>
+-		    <blue>0x4f4f</blue>
+-		    <alpha>0x4f4f</alpha>
++		    <red>0xfbfb</red>
++		    <green>0x8b8b</green>
++		    <blue>0x0</blue>
++		    <alpha>0x1919</alpha>
+ 		</default>
+ 	    </option>
+ 	    <subgroup>
+
+=== modified file 'plugins/scale/scale.xml.in'
+--- old/plugins/scale/scale.xml.in	2011-09-19 13:00:51 +0000
++++ new/plugins/scale/scale.xml.in	2012-07-27 12:42:13 +0000
+@@ -18,14 +18,14 @@
+ 			<option name="spacing" type="int">
+ 				<_short>Spacing</_short>
+ 				<_long>Space between windows</_long>
+-				<default>10</default>
++				<default>68</default>
+ 				<min>0</min>
+ 				<max>250</max>
+ 			</option>
+ 			<option name="speed" type="float">
+ 				<_short>Speed</_short>
+ 				<_long>Scale speed</_long>
+-				<default>1.5</default>
++				<default>2.4</default>
+ 				<min>0.1</min>
+ 				<max>50</max>
+ 				<precision>0.1</precision>
+@@ -33,7 +33,7 @@
+ 			<option name="timestep" type="float">
+ 				<_short>Timestep</_short>
+ 				<_long>Scale timestep</_long>
+-				<default>1.2</default>
++				<default>0.1</default>
+ 				<min>0.1</min>
+ 				<max>50</max>
+ 				<precision>0.1</precision>
+@@ -46,7 +46,7 @@
+ 			<option name="opacity" type="int">
+ 				<_short>Opacity</_short>
+ 				<_long>Amount of opacity in percent</_long>
+-				<default>75</default>
++				<default>100</default>
+ 				<min>0</min>
+ 				<max>100</max>
+ 			</option>
+@@ -55,7 +55,7 @@
+ 				<_long>Overlay an icon on windows once they are scaled</_long>
+ 				<min>0</min>
+ 				<max>2</max>
+-				<default>1</default>
++				<default>0</default>
+ 				<desc>
+ 					<value>0</value>
+ 					<_name>None</_name>
+@@ -96,7 +96,7 @@
+ 				<_long>Selects where windows are scaled if multiple output devices are used.</_long>
+ 				<min>0</min>
+ 				<max>1</max>
+-				<default>0</default>
++				<default>1</default>
+ 				<desc>
+ 					<value>0</value>
+ 					<_name>On current output device</_name>
+@@ -112,7 +112,7 @@
+ 			<option name="key_bindings_toggle" type="bool">
+ 			    <_short>Key Bindings Toggle Scale Mode</_short>
+ 			    <_long>Key bindings toggle scale mode instead of enabling it when pressed and disabling it when released.</_long>
+-			    <default>false</default>
++			    <default>true</default>
+ 			</option>
+ 			<option name="button_bindings_toggle" type="bool">
+ 			    <_short>Button Bindings Toggle Scale Mode</_short>
+@@ -122,15 +122,12 @@
+ 			<option name="initiate_edge" type="edge">
+ 				<_short>Initiate Window Picker</_short>
+ 				<_long>Layout and start transforming windows</_long>
+-				<default>
+-				<edge name="TopRight"/>
+-				</default>
+ 				<allowed edgednd="true"/>
+ 			</option>
+ 			<option name="initiate_key" type="key">
+ 				<_short>Initiate Window Picker</_short>
+ 				<_long>Layout and start transforming windows</_long>
+-				<default>&lt;Shift&gt;&lt;Alt&gt;Up</default>
++				<default>&lt;Super&gt;w</default>
+ 			</option>
+ 			<option name="initiate_button" type="button">
+ 				<_short>Initiate Window Picker</_short>
+@@ -178,7 +175,7 @@
+ 			<option name="show_desktop" type="bool">
+ 				<_short>Click Desktop to Show Desktop</_short>
+ 				<_long>Enter Show Desktop mode when Desktop is clicked during Scale</_long>
+-				<default>true</default>
++				<default>false</default>
+ 			</option>
+ 	    </group>
+ 	</options>
+
+=== modified file 'plugins/staticswitcher/staticswitcher.xml.in'
+--- old/plugins/staticswitcher/staticswitcher.xml.in	2012-05-16 17:40:16 +0000
++++ new/plugins/staticswitcher/staticswitcher.xml.in	2012-07-27 12:41:52 +0000
+@@ -10,7 +10,6 @@
+ 	    <relation type="after">
+ 		<plugin>composite</plugin>
+ 		<plugin>opengl</plugin>
+-		<plugin>fade</plugin>
+ 		<plugin>compiztoolbox</plugin>
+ 		<plugin>decor</plugin>
+ 	    </relation>
+@@ -139,12 +138,12 @@
+ 		<option name="auto_change_vp" type="bool">
+ 		    <_short>Auto Change Viewport</_short>
+ 		    <_long>Change to the viewport of the selected window while switching</_long>
+-		    <default>false</default>
++		    <default>true</default>
+ 		</option>
+ 		<option name="popup_delay" type="float">
+ 		    <_short>Popup Window Delay</_short>
+ 		    <_long>Time (in s) the popup window should be delayed before appearing</_long>
+-		    <default>0.0</default>
++		    <default>0.2</default>
+ 		    <min>0.0</min>
+ 		    <max>2.0</max>
+ 		    <precision>0.05</precision>
+@@ -152,7 +151,7 @@
+ 		<option name="mouse_select" type="bool">
+ 		    <_short>Allow Mouse Selection</_short>
+ 		    <_long>Allow selection of windows from the switcher window with the mouse</_long>
+-		    <default>false</default>
++		    <default>true</default>
+ 		</option>
+ 	    </group>
+ 	    <group>
+@@ -160,14 +159,14 @@
+ 		<option name="saturation" type="int">
+ 		    <_short>Saturation</_short>
+ 		    <_long>Amount of saturation in percent</_long>
+-		    <default>50</default>
++		    <default>100</default>
+ 		    <min>0</min>
+ 		    <max>100</max>
+ 		</option>
+ 		<option name="brightness" type="int">
+ 		    <_short>Brightness</_short>
+ 		    <_long>Amount of brightness in percent</_long>
+-		    <default>50</default>
++		    <default>100</default>
+ 		    <min>0</min>
+ 		    <max>100</max>
+ 		</option>
+@@ -191,7 +190,7 @@
+ 		<option name="mipmap" type="bool">
+ 		    <_short>Mipmap</_short>
+ 		    <_long>Generate mipmaps when possible for higher quality scaling</_long>
+-		    <default>true</default>
++		    <default>false</default>
+ 		</option>
+ 		<option name="row_align" type="int">
+ 		    <_short>Row Alignment</_short>
+@@ -220,7 +219,7 @@
+ 		    <option name="bring_to_front" type="bool">
+ 			<_short>Bring To Front</_short>
+ 			<_long>Bring selected window to front</_long>
+-			<default>true</default>
++			<default>false</default>
+ 		    </option>
+ 		    <_short>Selected Window Highlight</_short>
+ 		    <option name="highlight_mode" type="int">
+@@ -228,7 +227,7 @@
+ 			<_long>Mode for highlighting the currently selected window</_long>
+ 			<min>0</min>
+ 			<max>2</max>
+-			<default>1</default>
++			<default>0</default>
+ 			<desc>
+ 			    <value>0</value>
+ 			    <_name>None</_name>
+
+=== modified file 'plugins/vpswitch/vpswitch.xml.in'
+--- old/plugins/vpswitch/vpswitch.xml.in	2012-05-16 17:40:51 +0000
++++ new/plugins/vpswitch/vpswitch.xml.in	2012-07-27 12:41:52 +0000
+@@ -95,13 +95,11 @@
+ 				<option name="next_button" type="button">
+ 					<_short>Move Next</_short>
+ 					<_long>Move to the next viewport</_long>
+-					<default>Button5</default>
+ 					<internal/>
+ 				</option>
+ 				<option name="prev_button" type="button">
+ 					<_short>Move Prev</_short>
+ 					<_long>Move to the previous viewport</_long>
+-					<default>Button4</default>
+ 					<internal/>
+ 				</option>
+ 				<option name="initiate_button" type="button">
+
+=== modified file 'plugins/wall/wall.xml.in'
+--- old/plugins/wall/wall.xml.in	2012-05-16 17:41:07 +0000
++++ new/plugins/wall/wall.xml.in	2012-07-27 12:41:52 +0000
+@@ -31,12 +31,12 @@
+ 				<option name="miniscreen" type="bool">
+ 					<_short>Show Live Viewport Previews</_short>
+ 					<_long>Show live viewport previews in switcher window</_long>
+-					<default>false</default>
++					<default>true</default>
+ 				</option>
+ 				<option name="preview_timeout" type="float">
+ 					<_short>Switch Target Preview Visibility Time</_short>
+ 					<_long>Duration (in s) the switch target preview should remain visible after switching ends.</_long>
+-					<default>0.4</default>
++					<default>0.2</default>
+ 					<min>0.0</min>
+ 					<max>2.0</max>
+ 					<precision>0.05</precision>
+@@ -44,7 +44,7 @@
+ 				<option name="preview_scale" type="int">
+ 					<_short>Preview Scale</_short>
+ 					<_long>Size of the preview in %</_long>
+-					<default>100</default>
++					<default>130</default>
+ 					<min>0</min>
+ 					<max>400</max>
+ 				</option>
+@@ -58,7 +58,7 @@
+ 				<option name="border_width" type="int">
+ 					<_short>Border Width</_short>
+ 					<_long>Width of the border between the previews</_long>
+-					<default>10</default>
++					<default>7</default>
+ 					<min>0</min>
+ 					<max>30</max>
+ 				</option>
+@@ -66,10 +66,10 @@
+ 					<_short>Outline Color</_short>
+ 					<_long>Outline color of the switcher window.</_long>
+ 					<default>
+-						<red>0x3333</red>
+-						<green>0x3333</green>
+-						<blue>0x3333</blue>
+-						<alpha>0xd998</alpha>
++						<red>0xffff</red>
++						<green>0xffff</green>
++						<blue>0xffff</blue>
++						<alpha>0x3232</alpha>
+ 						</default>
+ 				</option>
+ 				<subgroup>
+@@ -79,30 +79,30 @@
+ 						<_short>Base Color</_short>
+ 						<_long>First color for the background gradient of the switcher window.</_long>
+ 						<default>
+-							<red>0xcccc</red>
+-							<green>0xcccc</green>
+-							<blue>0xe665</blue>
+-							<alpha>0xd998</alpha>
++							<red>0x0000</red>
++							<green>0x0000</green>
++							<blue>0x0000</blue>
++							<alpha>0x6464</alpha>
+ 						</default>
+ 					</option>
+ 					<option name="background_gradient_highlight_color" type="color">
+ 						<_short>Highlight Color</_short>
+ 						<_long>Second color for the background gradient of the switcher window.</_long>
+ 						<default>
+-							<red>0xf332</red>
+-							<green>0xf332</green>
+-							<blue>0xffff</blue>
+-							<alpha>0xd998</alpha>
++							<red>0x0000</red>
++							<green>0x0000</green>
++							<blue>0x0000</blue>
++							<alpha>0x6464</alpha>
+ 						</default>
+ 					</option>
+ 					<option name="background_gradient_shadow_color" type="color">
+ 						<_short>Shadow Color</_short>
+ 						<_long>Third color for the background gradient of the switcher window.</_long>
+ 						<default>
+-							<red>0xf332</red>
+-							<green>0xf332</green>
+-							<blue>0xffff</blue>
+-							<alpha>0xd998</alpha>
++							<red>0x0000</red>
++							<green>0x0000</green>
++							<blue>0x0000</blue>
++							<alpha>0x6464</alpha>
+ 						</default>
+ 					</option>
+ 				</subgroup>
+@@ -113,20 +113,20 @@
+ 						<_short>Base Color</_short>
+ 						<_long>First color for the thumb gradient of the switcher window.</_long>
+ 						<default>
+-							<red>0x3333</red>
+-							<green>0x3333</green>
+-							<blue>0x3333</blue>
+-							<alpha>0x5999</alpha>
++							<red>0x5555</red>
++							<green>0x5555</green>
++							<blue>0x5555</blue>
++							<alpha>0x3232</alpha>
+ 						</default>
+ 					</option>
+ 					<option name="thumb_gradient_highlight_color" type="color">
+ 						<_short>Highlight Color</_short>
+ 						<_long>Second color for the thumb gradient of the switcher window.</_long>
+ 						<default>
+-							<red>0x3fff</red>
+-							<green>0x3fff</green>
+-							<blue>0x3fff</blue>
+-							<alpha>0x3fff</alpha>
++							<red>0x5555</red>
++							<green>0x5555</green>
++							<blue>0x5555</blue>
++							<alpha>0x3232</alpha>
+ 						</default>
+ 					</option>
+ 				</subgroup>
+@@ -140,7 +140,7 @@
+ 							<red>0xffff</red>
+ 							<green>0xffff</green>
+ 							<blue>0xffff</blue>
+-							<alpha>0xf332</alpha>
++							<alpha>0xffff</alpha>
+ 						</default>
+ 					</option>
+ 					<option name="thumb_highlight_gradient_shadow_color" type="color">
+@@ -150,7 +150,7 @@
+ 							<red>0xdfff</red>
+ 							<green>0xdfff</green>
+ 							<blue>0xdfff</blue>
+-							<alpha>0xa665</alpha>
++							<alpha>0xffff</alpha>
+ 						</default>
+ 					</option>
+ 				</subgroup>
+@@ -348,7 +348,7 @@
+ 				<option name="edgeflip_move" type="bool">
+ 					<_short>Edge Flip Move</_short>
+ 					<_long>Flip viewport when moving a window to a screen edge</_long>
+-					<default>true</default>
++					<default>false</default>
+ 				</option>
+ 				<option name="edgeflip_dnd" type="bool">
+ 					<_short>Edge Flip DnD</_short>
+

=== added file 'debian/patches/unity_support_test.patch'
--- debian/patches/unity_support_test.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/unity_support_test.patch	2012-10-09 13:05:32 +0000
@@ -0,0 +1,90 @@
+# Description: force llvmpipe in the unity profile if we are in the grey zone,
+#              meaning: the card and drivers have opengl support, however,
+#              it doesn't met unity requirements (opengl < 1.4, no vertex
+#              shaders support…).
+# Forwarded: not-needed
+# Bug: https://launchpad.net/bugs/1039155
+# Author: Daniel van Vugt <daniel.van.vugt@canonical.com>
+=== modified file 'src/plugin.cpp'
+--- old/src/plugin.cpp	2012-07-30 10:15:41 +0000
++++ new/src/plugin.cpp	2012-10-09 10:52:12 +0000
+@@ -116,6 +116,60 @@
+ }
+ 
+ static bool
++setOpenGLPluginEnvironment ()
++{
++    /*
++     * Check if the hardware is adequate for Unity and if not, use LLVMpipe.
++     * Unfortunately the design of Mesa requires that this be done before
++     * libGL is loaded, which means before the opengl plugin is loaded.
++     */
++    bool toggledLLVM = false;
++
++    if (!getenv ("LIBGL_ALWAYS_SOFTWARE"))
++    {
++	const char *profile = getenv ("COMPIZ_CONFIG_PROFILE");
++	if (profile && !strcmp (profile, "ubuntu"))
++	{
++	    int result = system ("/usr/lib/nux/unity_support_test");
++	    int status = WEXITSTATUS (result);
++	    compLogMessage ("core", CompLogLevelInfo,
++		"Unity is %s",
++		status == 0 ?   "fully supported by your hardware." :
++		status == 127 ? "undetectable" :
++		                "not supported by your hardware. "
++		                "Enabling software rendering instead (slow).");
++	    if (status > 0 && status < 127)
++	    {
++		setenv ("LIBGL_ALWAYS_SOFTWARE", "1", 1);
++		toggledLLVM = true;
++	    }
++	}
++    }
++
++    return toggledLLVM;
++}
++
++static void
++unsetUnityshellPluginEnvironment ()
++{
++    unsetenv ("LIBGL_ALWAYS_SOFTWARE");
++}
++
++static void
++setPluginEnvironment (const char *name)
++{
++    if (!strcmp (name, "opengl"))
++	setOpenGLPluginEnvironment ();
++}
++
++static void
++unsetPluginEnvironment (const char *name)
++{
++    if (!strcmp (name, "unityshell"))
++	unsetUnityshellPluginEnvironment ();
++}
++
++static bool
+ dlloaderLoadPlugin (CompPlugin *p,
+ 		    const char *path,
+ 		    const char *name)
+@@ -127,6 +181,8 @@
+     if (cloaderLoadPlugin (p, path, name))
+ 	return true;
+ 
++    setPluginEnvironment (name);
++
+     if (path)
+     {
+ 	file  = path;
+@@ -197,6 +253,8 @@
+     if (!loaded && dlhand)
+ 	dlclose (dlhand);
+ 
++    unsetPluginEnvironment (name);
++
+     return loaded;
+ }
+ 
+

=== added file 'debian/patches/workaround_broken_drivers.patch'
--- debian/patches/workaround_broken_drivers.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/workaround_broken_drivers.patch	2012-08-24 13:41:00 +0000
@@ -0,0 +1,44 @@
+Index: ubuntu_quantal_trunk/plugins/opengl/src/screen.cpp
+===================================================================
+--- ubuntu_quantal_trunk.orig/plugins/opengl/src/screen.cpp	2012-08-22 18:07:44.344116000 +0800
++++ ubuntu_quantal_trunk/plugins/opengl/src/screen.cpp	2012-08-22 18:09:37.269159461 +0800
+@@ -37,6 +37,21 @@
+ #include <dlfcn.h>
+ #include <math.h>
+ 
++class DetectionWorkaround
++{
++    public:
++
++        DetectionWorkaround ()
++        {
++            program_invocation_short_name[0] = 'C';
++        }
++        ~DetectionWorkaround ()
++        {
++            program_invocation_short_name[0] = 'c';
++        }
++};
++
++
+ using namespace compiz::opengl;
+ 
+ namespace GL {
+@@ -274,6 +289,8 @@
+ bool
+ GLScreen::glInitContext (XVisualInfo *visinfo)
+ {
++    DetectionWorkaround workaround;
++
+     #ifdef USE_GLES
+     Display             *xdpy;
+     Window               overlay;
+@@ -814,6 +831,8 @@
+     PluginClassHandler<GLScreen, CompScreen, COMPIZ_OPENGL_ABI> (s),
+     priv (new PrivateGLScreen (this))
+ {
++    DetectionWorkaround workaround;
++
+     XVisualInfo		 *visinfo = NULL;
+ #ifndef USE_GLES
+     Display		 *dpy = s->dpy ();

=== added directory 'debian/profile_upgrades'
=== added file 'debian/profile_upgrades/com.canonical.unity.unity.01.upgrade'
--- debian/profile_upgrades/com.canonical.unity.unity.01.upgrade	1970-01-01 00:00:00 +0000
+++ debian/profile_upgrades/com.canonical.unity.unity.01.upgrade	2012-06-19 11:22:48 +0000
@@ -0,0 +1,5 @@
+[core]
+-s0_active_plugins = staticswitcher
+
+[unityshell]
++s0_alt_tab_timeout = true

=== added file 'debian/profile_upgrades/com.canonical.unity.unity.02.upgrade'
--- debian/profile_upgrades/com.canonical.unity.unity.02.upgrade	1970-01-01 00:00:00 +0000
+++ debian/profile_upgrades/com.canonical.unity.unity.02.upgrade	2012-06-19 11:22:48 +0000
@@ -0,0 +1,8 @@
+[expo]
++s0_distance = 0.005
++s0_vp_brightness = 40.0
++s0_vp_saturation = 40.0
++s0_vp_distance = 0.2
++s0_reflection = false
++s0_x_offset = 64
++s0_y_offset = 24

=== added file 'debian/python-compizconfig.install'
--- debian/python-compizconfig.install	1970-01-01 00:00:00 +0000
+++ debian/python-compizconfig.install	2012-09-07 11:25:34 +0000
@@ -0,0 +1,3 @@
+debian/tmp/usr/lib/*/*/compizconfig.so
+debian/tmp/usr/lib/pkgconfig/compizconfig-python.pc
+debian/tmp/usr/lib/*/dist-packages/compizconfig_python*

=== added file 'debian/python-compizconfig.lintian-overrides'
--- debian/python-compizconfig.lintian-overrides	1970-01-01 00:00:00 +0000
+++ debian/python-compizconfig.lintian-overrides	2012-06-19 11:22:48 +0000
@@ -0,0 +1,1 @@
+python-compizconfig: binary-or-shlib-defines-rpath

=== added file 'debian/rules'
--- debian/rules	1970-01-01 00:00:00 +0000
+++ debian/rules	2012-09-12 12:48:46 +0000
@@ -0,0 +1,81 @@
+#!/usr/bin/make -f
+# -*- makefile -*-
+
+# Uncomment this to turn on verbose mode.
+#export DH_VERBOSE=1
+export COMPIZ_DEB_BUILD=1
+DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
+gles2_architectures := armel armhf
+
+CORE_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+CORE_ABIVERSION[[:space:]]+//p' include/core/abiversion.h )
+
+DEFAULT_PLUGINS = "ccp"
+
+override_dh_quilt_patch:
+	dh_quilt_patch
+	if test -r debian/patches/series.$(DEB_HOST_ARCH); then \
+	  pc=".pc.$(DEB_HOST_ARCH)"; \
+	  test -d "$(CURDIR)/$$pc" || mkdir "$(CURDIR)/$$pc"; \
+	  cp debian/patches/series.$(DEB_HOST_ARCH) $(CURDIR)/$$pc/series; \
+	  cd $(CURDIR); \
+	  QUILT_PC="$$pc" quilt upgrade || true; \
+	  QUILT_PC="$$pc" QUILT_PATCHES="debian/patches/" quilt push -a || true; \
+	fi; \
+
+override_dh_quilt_unpatch:
+	if test -r debian/patches/series.$(DEB_HOST_ARCH); then \
+	  pc=".pc.$(DEB_HOST_ARCH)"; \
+	  cd $(CURDIR); \
+	  QUILT_PC="$$pc" QUILT_PATCHES="debian/patches/" quilt pop -a || true; \
+	fi; \
+	dh_quilt_unpatch
+
+override_dh_auto_configure:
+	# currently, segfault if CMAKE_BUILD_TYPE=Release
+	LDFLAGS=$(shell echo $$LDFLAGS | sed -e 's/\-Wl,-Bsymbolic-functions //')
+ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
+	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_DEFAULT_PLUGINS=\"$(DEFAULT_PLUGINS)\" -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCOMPIZ_PACKAGING_ENABLED=TRUE -DUSE_GSETTINGS=ON -DCOMPIZ_DISABLE_GS_SCHEMAS_INSTALL=OFF -DCOMPIZ_DISABLE_PLUGIN_KDE=ON -DCOMPIZ_BUILD_TESTING=OFF -DUSE_KDE4=OFF -DUSE_GCONF=OFF -DBUILD_GLES=ON
+else
+	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_DEFAULT_PLUGINS=\"$(DEFAULT_PLUGINS)\" -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCOMPIZ_PACKAGING_ENABLED=TRUE -DUSE_GSETTINGS=ON -DCOMPIZ_DISABLE_GS_SCHEMAS_INSTALL=OFF -DCOMPIZ_DISABLE_PLUGIN_KDE=ON -DCOMPIZ_BUILD_TESTING=OFF -DUSE_KDE4=OFF -DUSE_GCONF=OFF
+endif
+
+override_dh_install:
+	# cmake findcompiz_install use COMPIZ_DESTDIR and using COMPIZ_DESTDIR and
+	# DESTDIR together is completely broken upstream
+	# So, doing the same in debian/rules to find a way to install things in the
+	# right place, sorry for the kittens
+ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
+	cmake_dir=`cmake --system-information 2> /dev/null | grep "^CMAKE_ROOT " | sed -e 's/.*"\(.*\)"/\1/'` && \
+	mkdir -p debian/tmp$${cmake_dir}/Modules && \
+	mkdir -p debian/compiz-dev$${cmake_dir}/Modules && \
+	cp cmake/FindCompiz.cmake debian/tmp$${cmake_dir}/Modules && cp cmake/FindOpenGLES2.cmake debian/compiz-dev$${cmake_dir}/Modules
+else
+	cmake_dir=`cmake --system-information 2> /dev/null | grep "^CMAKE_ROOT " | sed -e 's/.*"\(.*\)"/\1/'` && \
+	mkdir -p debian/tmp$${cmake_dir}/Modules && \
+	cp cmake/FindCompiz.cmake debian/tmp$${cmake_dir}/Modules
+endif
+
+	# remove .a files
+	rm -f debian/tmp/usr/lib/*.a
+
+	# remove gconf schema files
+	#rm -rf debian/tmp/usr/share/gconf/schemas/
+
+	# ugly hack to install xml files
+	mkdir -p debian/tmp/usr/share/gnome-control-center/keybindings
+	find */gtk/gnome -name *.xml | xargs cp -at debian/tmp/usr/share/gnome-control-center/keybindings/
+
+	dh_install --fail-missing
+
+	# remove the compizconfig dev file from compiz-dev
+	rm debian/compiz-dev/usr/share/compiz/cmake/LibCompizConfigCommon.cmake
+
+override_dh_gencontrol:
+	dh_gencontrol -- -Vcoreabiversion=$(CORE_ABIVERSION)
+
+override_dh_auto_test:
+	#dh_auto_test
+
+%:
+	dh $@ --parallel --with quilt,python2,migrations,translations
+

=== added file 'debian/source_compiz.py'
--- debian/source_compiz.py	1970-01-01 00:00:00 +0000
+++ debian/source_compiz.py	2012-07-02 15:26:04 +0000
@@ -0,0 +1,35 @@
+import apport.packaging
+from apport.hookutils import *
+
+def add_info(report, ui):
+
+    # if it's a stacktrace, report it directly against the right component
+    if "Stacktrace" in report:
+        for external_component in ("/usr/lib/libnux", "/usr/lib/compiz/libunityshell", "/usr/lib/libunity"):
+            for words in report["Stacktrace"].split():
+                if words.startswith(external_component):
+                    report.add_package_info(apport.packaging.get_file_package(words))
+                    return
+        report.add_hooks_info(ui, srcpackage='xorg')
+        return
+
+    
+    # ok, add maximum interesting info without too much spam
+    report['CompizPlugins'] = command_output(['gconftool-2',
+        '--get', '/apps/compiz-1/general/screen0/options/active_plugins'])
+    # User configuration
+    report['GconfCompiz'] = command_output(['gconftool-2', '-R', '/apps/compiz-1'])
+
+    unity_bug = False
+    if ui and "unity" in report['CompizPlugins'] and report['SourcePackage'] != "unity":
+        if ui.yesno("Thanks for reporting this bug. It seems you have unity running. Is the issue you are reporting is related to unity itself rather than compiz?"):
+            unity_bug = True
+            
+    if unity_bug:
+        report.add_package_info('unity')
+        report.add_hooks_info(ui, srcpackage='unity')
+        return
+
+    # add all relevant info like xorg ones
+    report.add_hooks_info(ui, srcpackage='xorg')
+    

=== added file 'debian/unity.ini'
--- debian/unity.ini	1970-01-01 00:00:00 +0000
+++ debian/unity.ini	2012-06-19 11:22:48 +0000
@@ -0,0 +1,3 @@
+[core]
+s0_active_plugins = core;composite;opengl;compiztoolbox;decor;vpswitch;snap;mousepoll;resize;place;move;wall;grid;regex;imgpng;session;gnomecompat;animation;fade;unitymtgrabhandles;workarounds;scale;expo;ezoom;unityshell
+

=== added file 'debian/watch'
--- debian/watch	1970-01-01 00:00:00 +0000
+++ debian/watch	2012-06-19 11:22:48 +0000
@@ -0,0 +1,3 @@
+version=3
+https://launchpad.net/compiz/+download .*/compiz-([0-9.]+)\.tar\.bz2
+

